/*
 * changelog.h
 *
 *  Created on: Apr 30, 2012
 *      Author: ian
 */

#ifndef APP_DB_CHANGELOG_H_
#define APP_DB_CHANGELOG_H_

#include <rinhw/stdrinstrum.h>
#include <rindb/db_database.h>
#include <rindb/db_changelog.h>
#include <rindb/db_changelog_reader.h>


/** System change log */
extern struct s_db_changelog *app_changelog;


/** System change log reader */
extern struct s_db_changelog_reader *app_changelog_reader;


/** Create the database change log */
bool app_changelog_init(void);


/** Shut down the change log */
bool app_changelog_destroy(void);


/** Determine if the changelog is full, in which case the databases can't be saved */
bool app_can_save_databases(void);


/** Update the change log with any changes to database */
bool app_changelog_update(struct s_db_database *database);


/** Back up the change log file to a file called "folder/WE2111_serno_date_time_changelog.csv" */
bool app_changelog_backup_file(const char *folder);


#endif /* APP_DB_CHANGELOG_H_ */
