/*
 * app_save.h
 *
 *  Created on: 13 Jul. 2018
 *      Author: ian
 */

#ifndef APP_SAVE_H_
#define APP_SAVE_H_

#include <stdbool.h>
#include <setnetconfig.h>


/** Re-initialise comms, buzzer, IO, analog, setpoints and device finder after a save has been performed */
void reinitialise_after_save(void);


/**
 * Save databases changes and network settings and re-initialise the application with the changes
 *
 * @param check_can_save true if the function should check that the changelog is not full before saving
 * @param net_config if not NULL then the network configuration will be set/saved with this configuration
 *
 * @return true if databases were saved
 */
bool app_save_databases_and_reinit(bool check_can_save, struct s_snc_net_config *net_config);


#endif /* APP_SAVE_H_ */
