#ifndef BUZZ5000_DOT_H
#define BUZZ5000_DOT_H 1

#include <rinhw/rio.h>
#include "system.h"


/* freq constants */
#define BUZZ_NORMAL 250         /* approx 4 kHz */
/* used for freq parameters below */

/* time in system ticks */
#define BEEP_TIME 37            /* 75 */
#define BEEP_WAIT 25            /* 50 */


/**************************************************************************/
void buzzer_on(uint8_t freq);
/*  turn buzzer on at a particular frequency
**************************************************************************/
void buzzer_off();
/*  turn buzzer off
**************************************************************************/
void buzz(uint16_t milli, uint8_t freq);
/* buzz at freq  for milli milliseconds.
**************************************************************************/
void buzz_times(uint16_t on_milli, uint16_t off_milli, uint8_t freq, uint8_t times);
/*  sets buzzer for a 'times' beeps at 'freq' of 'on_milli'msec duration with
** 'off_milli' msec between.
***************************************************************************/
void beep_twice(void);
void beep_thrice(void);
/***************************************************************************/
void beep(void);
/***************************************************************************/
void beep_long(void);
/***************************************************************************/
void beep_error(void);
/***************************************************************************/
bool is_beeping(void);
/***************************************************************************/

#endif /* #ifndef BUZZ5000_DOT_H */
