/*
 * cmdline.h
 *
 *  Created on: 28/05/2010
 *      Author: ian
 */

#ifndef CMDLINE_H_
#define CMDLINE_H_

#include <rinhw/stdrinstrum.h>


/** WE2111 configuration file */
extern const char *cmdline_config_file;


/** Flag to indicate the program should run as a daemon */
extern bool cmdline_daemonise;


/** Display command line help */
extern bool cmdline_showhelp;


/** Flag to indicate the program should log error messages to syslog */
extern bool cmdline_logtosyslog;


/** Flag to indicate the program should log error messages to stdout */
extern bool cmdline_logtostdout;


/** Serial port device to use for remote devices, if NULL remote devices are not used */
extern const char *cmdline_remote_device;


/** Print out the command line options */
void print_commandlineopts(const char *program_name);


/** Parse the command line options */
int parse_commandline(int argc, char *argv[]);


#endif /* CMDLINE_H_ */
