/*
 * comms_auto_trigger.h
 *
 *  Created on: 03/03/2011
 *      Author: ian
 */

#ifndef COMMS_AUTO_TRIGGER_H_
#define COMMS_AUTO_TRIGGER_H_

#include <stdbool.h>
#include <rinhw/rio.h>
#include "comms_auto.h"


/** Re-initialise parts of ca from the database settings */
void comms_auto_reinit(struct s_comms_auto *ca);


/** Create and initialise a new s_comms_auto structure */
struct s_comms_auto *comms_auto_create(struct t_io_dev *serdev, bool is_incoming_udp);


/** Clean up and destroy an existing s_comms_auto structure */
void comms_auto_destroy(struct s_comms_auto *ca);


/** Does the work of sending an automatic output. Waits until signalled. */
void comms_auto_handler(struct s_comms_auto *ca);


/** Trigger an auto output on a specific port */
void auto_output_trigger(struct s_comms_auto *ca);


/** Trigger an auto-output transmission on all configured ports */
void auto_lo_output_trigger(void);


/** Trigger an auto-output transmission on all configured ports */
void auto_hi_output_trigger(void);


/** Trigger an single auto-output transmission on specified port */
bool auto_single_output_trigger(enum eSerialPort port);


#endif /* COMMS_AUTO_TRIGGER_H_ */
