/*
 * comms_bdxwfp.h
 *
 *  Created on: Jun 2, 2016
 *      Author: ian
 */

#ifndef COMMS_BDXWFP_H_
#define COMMS_BDXWFP_H_

#include <stdbool.h>
#include "serial_ports.h"


/** BDX & WFP serial port order is different @ref enum eSerialPort */
enum eBDXWFPSerialPort
{
  BDXWFP_PORT_0_RB1A = 0,
  BDXWFP_PORT_1_RB1B,
  BDXWFP_PORT_2_RB2A,
  BDXWFP_PORT_3_RB2B,
  BDXWFP_PORT_4_TCPNET,
  BDXWFP_PORT_5_TCPAUTO,
  BDXWFP_PORT_6_USBGADGET,
  BDXWFP_PORT_7_USBHOST,
  BDXWFP_PORT_8_USBLP,
  BDXWFP_PORT_9_RL_FRONT,
  BDXWFP_PORT_10_SER1_RL_REAR,
  BDXWFP_PORT_11_UDPOUT1,
  BDXWFP_PORT_12_UDPOUT2,
  BDXWFP_PORT_13_UDPIN1,
  BDXWFP_PORT_14_UDPIN2,
  BDXWFP_PORT_15_UDSNET,
  BDXWFP_PORT_16_UDSAUTO,
  BDXWFP_PORT_17_SER2,

  BDXWFP_PORTNUM
};


/** Convert enum eSerialPort to enum eBDXWFPSerialPort */
enum eBDXWFPSerialPort xlat_serial_port_to_bdxwfp(enum eSerialPort serial_port);


/** Convert enum eBDXWFPSerialPort to enum eSerialPort */
enum eSerialPort xlat_bdxwfp_to_serial_port(enum eBDXWFPSerialPort bdxwfp_port);


/** Can this port be configured? */
bool bdxwfp_port_can_configure(enum eBDXWFPSerialPort bdxwfp_port);


#endif /* COMMS_BDXWFP_H_ */
