/*
 * comms_hdlr_dft.h
 *
 *  Created on: 30 May 2018
 *      Author: ian
 */

#ifndef COMMS_HDLR_DEFAULTS_H_
#define COMMS_HDLR_DEFAULTS_H_

#include <stdbool.h>
#include <stdint.h>
#include "comms_util.h"


/** What database to default */
enum e_comms_default_settings
{
  cds_all = 0,      /*!< Default everything except licensing */
  cds_userdb,       /*!< Default the user database, except calibration */
  cds_runtimedb,    /*!< Default the runtime database, including ADC settings */
  cds_calibration,  /*!< Default the calibration */
  cds_network,      /*!< Default the network settings */
  cds_licensingdb,  /*!< Default the licensing database */
};


/** Default the settings specified by default_what from a comms command */
bool comms_default_settings(enum e_comms_default_settings default_what);


/** A single command for setting defaults, more for final factory setup than customer use */
uint8_t handle_DFT(struct s_comms_control *comms_ctrl, char *s);


#endif /* COMMS_HDLR_DEFAULTS_H_ */
