/*
 * comms_hdlr_network.h
 *
 *  Created on: Jan 11, 2018
 *      Author: ian
 */

#ifndef COMMS_HDLR_NETWORK_H_
#define COMMS_HDLR_NETWORK_H_


#include <stdint.h>
#include <stdbool.h>
#include <linux/if_ether.h>
#include <rincmd/rc_public.h>
#include "comms_util.h"
#include "ipinfo.h"
#include "iface_ethnet.h"


/** Network configuration for rincmd */
extern struct s_snc_net_config rincmd_840x_net_config;


/** MAC address as a string for rincmd */
extern char rincmd_8408_mac_address_string[MAC_ADDRESS_STR_LENGTH];


/** Ethernet settings */
uint8_t handle_ETH(struct s_comms_control *comms_ctrl, char *s);


/** Rincmd callback for network settings */
bool rincmd_840x_network_settings(char *val, size_t len, size_t maxLen, struct s_rc_localRegisterTable *topLevel, struct s_rc_Register *reg, uint8_t opt);


/** Call this when the rincmd network settings have been saved */
void rincmd_840x_saved_settings(void);


/** Rincmd callback for defaulting the network settings */
bool rincmd_8406_network_defaults(char *val, size_t len, size_t maxLen, struct s_rc_localRegisterTable *topLevel, struct s_rc_Register *reg, uint8_t opt);


#endif /* COMMS_HDLR_NETWORK_H_ */
