/*
 * comms_hdlr_nz.h
 *
 *  Created on: 13/10/2010
 *      Author: ian
 */

#ifndef COMMS_HDLR_NZ_H_
#define COMMS_HDLR_NZ_H_

#include <stdint.h>
#include "comms_util.h"


/** Printer formats */
uint8_t handle_PFT(struct s_comms_control *comms_ctrl, char *s);


/** Digital inputs and outputs */
uint8_t handle_POR(struct s_comms_control *comms_ctrl, char *s);


/** Printer settings */
uint8_t handle_PRS(struct s_comms_control *comms_ctrl, char *s);


/** Perform printout */
uint8_t handle_PRT(struct s_comms_control *comms_ctrl, char *s);


/** Printer text */
uint8_t handle_PST(struct s_comms_control *comms_ctrl, char *s);


/** Quality Assurance settings */
uint8_t handle_QAF(struct s_comms_control *comms_ctrl, char *s);


/** Remote button settings */
uint8_t handle_RBT(struct s_comms_control *comms_ctrl, char *s);


/** Reset unit */
uint8_t handle_RES(struct s_comms_control *comms_ctrl, char *s);


/** Sxx addressing commands, including STP */
uint8_t handle_S(struct s_comms_control *comms_ctrl, char *s);


/** Tare */
uint8_t handle_TAR(struct s_comms_control *comms_ctrl, char *s);


/** Gross/net select */
uint8_t handle_TAS(struct s_comms_control *comms_ctrl, char *s);


/** Preset tare */
uint8_t handle_TAV(struct s_comms_control *comms_ctrl, char *s);


/** Save database */
uint8_t handle_TDD(struct s_comms_control *comms_ctrl, char *s);


/** Test command, enable factory commands */
uint8_t handle_TST(struct s_comms_control *comms_ctrl, char *s);


/** Text strings */
uint8_t handle_TXT(struct s_comms_control *comms_ctrl, char *s);


/** Unit switching settings */
uint8_t handle_UNT(struct s_comms_control *comms_ctrl, char *s);


/** mv/V reading */
uint8_t handle_VAL(struct s_comms_control *comms_ctrl, char *s);


/** Which serial port is this? */
uint8_t handle_WFP(struct s_comms_control *comms_ctrl, char *s);


/** Weighing mode */
uint8_t handle_WMD(struct s_comms_control *comms_ctrl, char *s);


/** Zero settings */
uint8_t handle_ZST(struct s_comms_control *comms_ctrl, char *s);


#endif /* COMMS_HDLR_NZ_H_ */
