/*
 * comm_hdlr_passcode.h
 *
 *  Created on: Nov 27, 2017
 *      Author: ian
 */

#ifndef COMMS_HDLR_PASSCODE_H_
#define COMMS_HDLR_PASSCODE_H_

#include <stdbool.h>
#include <stdint.h>
#include "comms_util.h"


/** Full passcode */
uint8_t handle_DPF(struct s_comms_control *comms_ctrl, char *s);


/** Safe passcode */
uint8_t handle_DPS(struct s_comms_control *comms_ctrl, char *s);


/** Rincmd check full passcode for access. TODO this should be on a per connection basis */
extern uint32_t rincmd_check_fullPC;


/** Rincmd check safe passcode for access. TODO this should be on a per connection basis */
extern uint32_t rincmd_check_safePC;


/** Initialise access to registers if passcodes are 0 */
void rincmd_initPasscode(struct s_rc_localRegisterTable *topLevel);


/** Rincmd handler for enabling access to safe and full passcode protected registers */
bool rincmd_checkPasscode(char *val, size_t len, size_t maxLen, struct s_rc_localRegisterTable *topLevel, struct s_rc_Register *reg, uint8_t opt);


#endif /* COMMS_HDLR_PASSCODE_H_ */
