/*
 * comms_print_buffer.h
 *
 *  Created on: Mar 18, 2014
 *      Author: ian
 */

#ifndef COMMS_PRINT_BUFFER_H_
#define COMMS_PRINT_BUFFER_H_

#include <pthread.h>
#include <stddef.h>
#include <stdbool.h>


/** Structure for housing a comms print buffer */
struct s_comms_print_buffer
{
  pthread_mutex_t mutex;                  /*!< Exclusive access mutex */
  size_t buf_in;                          /*!< Incoming data pointer */
  size_t buf_out;                         /*!< Outgoing data pointer */
  size_t buf_size;                        /*!< Buffer size */
  char *buffer;                           /*!< Buffer */
};


/** Create a new comms print buffer */
struct s_comms_print_buffer *comms_print_buffer_create(size_t size);


/** Destroy a comms print buffer */
void comms_print_buffer_destroy(struct s_comms_print_buffer *cpb);


/** Add a character to the print buffer if there is room */
bool comms_print_buffer_add_char(struct s_comms_print_buffer *cpb, char ch);


/** Get a character from the print buffer if there are any */
bool comms_print_buffer_get_char(struct s_comms_print_buffer *cpb, char *ch);


#endif /* COMMS_PRINT_BUFFER_H_ */
