/*
 * comms_print_interlock.c
 *
 *  Created on: Oct 19, 2017
 *      Author: sean
 */
#include "adcthread.h"
#include "app_db_user.h"

#include "comms_print_interlock.h"


/** Check if the interlock conditions have been met */
bool comms_print_interlock_ok(const struct s_comms_print_interlock *cpi)
{
  bool result;

  switch (db_app_user.print_interlock)
  {
    case PRINT_INTERLOCK_MOTION:
      result = cpi->previous_motion;
      break;

    case PRINT_INTERLOCK_RETZ:
      result = cpi->returned_to_zero;
      break;

    case PRINT_INTERLOCK_NONE:
    default:
      result = true;
      break;
  }

  return result;
}


/** Clear interlocks after printing */
void comms_print_interlock_clear(struct s_comms_print_interlock *cpi)
{
  cpi->returned_to_zero = false;
  cpi->previous_motion = false;
}


/** Update the print interlock status */
void comms_print_interlock_update(struct s_comms_print_interlock *cpi)
{
  cpi->previous_motion = cpi->previous_motion || adcSuperStructure.adcDataWorking.dispRdg.info.status.bit.motion;
  cpi->returned_to_zero = cpi->returned_to_zero || adcSuperStructure.adcDataWorking.dispRdg.info.status.bit.zeroBand;
}


/** Initialise the print interlock status */
void comms_print_interlock_init(struct s_comms_print_interlock *cpi)
{
  cpi->returned_to_zero = true;
  cpi->previous_motion = true;
}
