/*
 * comms_print_interlock.h
 *
 *  Created on: Oct 19, 2017
 *      Author: sean
 */

#ifndef COMMS_PRINT_INTERLOCK_H_
#define COMMS_PRINT_INTERLOCK_H_

#include <stdbool.h>

/** Print interlock status */
struct s_comms_print_interlock
{
  bool previous_motion;
  bool returned_to_zero;
};


/** Update the print interlock status */
void comms_print_interlock_update(struct s_comms_print_interlock *cpi);


/** Initialise the print interlock status */
void comms_print_interlock_init(struct s_comms_print_interlock *cpi);


/** Clear interlocks after printing */
void comms_print_interlock_clear(struct s_comms_print_interlock *cpi);


/** Check if the interlock conditions have been met */
bool comms_print_interlock_ok(const struct s_comms_print_interlock *cpi);


#endif /* COMMS_PRINT_INTERLOCK_H_ */
