/*
 * comms_task_listen.h
 *
 *  Created on: Sep 25, 2017
 *      Author: ian
 */

#ifndef COMMS_TASK_LISTEN_H_
#define COMMS_TASK_LISTEN_H_

#include <stdbool.h>


/** Cleanup after a comms thread has quit (gets rid of zombies) */
void comms_task_listen_cleanup(void);


/** Reload configuration for the tcp port listening thread */
void comms_task_listen_reconfigure(void);


/**
 * Create the comms listen task that accepts incoming socket connections (TCP and UDS) and creates the appropriate handler task
 *
 * Unix domain sockets are specified here, and don't change
 * TCP ports are specified in the database and will change when @ref comms_task_listen_reconfigure() is called
 */
bool comms_task_listen_init(const char *uds_net_file, const char *uds_auto_file);


/** Destroy the listening thread */
void comms_task_listen_destroy(void);


#endif /* COMMS_TASK_LISTEN_H_ */
