/*
 * comms_task_udp.h
 *
 *  Created on: Sep 28, 2017
 *      Author: ian
 */

#ifndef COMMS_TASK_UDP_H_
#define COMMS_TASK_UDP_H_

#include <stdbool.h>
#include <rinhw/rio.h>
#include "serial_ports.h"
#include "comms_udp.h"


/** Reconfigure an already running UDP task. Returns false if the task should quit. udpinfo in host endian. */
bool comms_task_udp_running_reconfigure(enum eSerialPort port, struct t_io_dev *rindev, struct s_comms_udp_info *udpinfo);


/**
 * Reconfigure the UDP tasks from the database settings.
 *
 * This really only starts tasks if they have been enabled.
 * UDP tasks are responsible for exiting if they have been disabled,
 * and reconfiguring their ports if a change has been made
 */
void comms_task_udp_reconfigure(void);


/** Init the UDP tasks */
void comms_task_udp_init(void);


#endif /* COMMS_TASK_UDP_H_ */
