/*
 * comms_udp.h
 *
 *  Created on: Sep 28, 2017
 *      Author: ian
 */

#ifndef COMMS_UDP_H_
#define COMMS_UDP_H_

#include <netinet/in.h>
#include <rinhw/rio.h>


/** Specific info for UDP comms tasks */
struct s_comms_udp_info
{
  int localport;                /*!< The local UDP port we are bound to. Zero if outgoing port. Use getsockname() if you want to know the actual port */
  struct sockaddr_in dest;      /*!< The UDP destination IP and port we are sending to. sin_port and sin_addr = 0 if incoming port */
};


/**
 * Do special read handling for UDP incoming connections
 * that only do transmits (autoout or print)
 *
 * We do a non-blocking recvfrom() here, so we can
 * get the sender ip:port and set this as the reply-to address
 */
void comms_udp_read_for_txonly(struct t_io_dev *serdev);


#endif /* COMMS_UDP_H_ */
