/*
 * daemonise.h
 *
 *  Created on: Mar 12, 2013
 *      Author: ian
 */

#ifndef DAEMONISE_H_
#define DAEMONISE_H_


/** Start the daemonise process.
 *
 * Passes argv to the exec'ed process with the current environment.
 * The calling process can tell it has been restarted by the presence
 * of cont_var=1 in the environment.
 *
 * Returns 1 on error, 0 on success
 */
int daemoniseStart(int argc, char *argv[], const char *cont_var);


/**
 * Continues where daemoniseStart off, as the child process. It is the responsibility
 * of the main process to call this, basically if the cont_var above
 * is set, then we start here.
 */
int daemoniseContinue(int argc, char *argv[]);


#endif /* DAEMONISE_H_ */
