/*
 * db_clock.h
 *
 *  Created on: 26/05/2017
 *      Author: sean
 */

#ifndef DB_CLOCK_H_
#define DB_CLOCK_H_

#include <stdint.h>
#include <rinweigh/adcdatatypes.h>


/** Enum for time formats */
enum eTimeFormat { TIME_FMT_24H = 0,
                   TIME_FMT_12H,
                   NUM_TIME_FMTS
                 };


/** Enum for date formats */
enum eDateFormat { DATE_FMT_DD_MM_YYYY = 0,
                   DATE_FMT_MM_DD_YYYY,
                   DATE_FMT_YYYY_MM_DD,
                   DATE_FMT_DD_MM_YY,
                   DATE_FMT_MM_DD_YY,
                   DATE_FMT_YY_MM_DD,
                   NUM_DATE_FMTS
                 };


/** Time format options */
#define TIME_FORMAT_STRS { "24 HR",  /* 24 hour */ \
                           "12 HR"   /* 12 hour */ \
                         }


/** Time format options */
extern const char *const time_format_settings[NUM_TIME_FMTS];


/** Date format options */
#define DATE_FORMAT_STRS { "DD.MM.Y4",  /* DD/MM/YYYY */ \
                           "MM.DD.Y4",  /* MM/DD/YYYY */ \
                           "Y4.MM.DD",  /* YYYY/MM/DD */ \
                           "DD.MM.Y2",  /* DD/MM/YY   */ \
                           "MM.DD.Y2",  /* MM/DD/YY   */ \
                           "Y2.MM.DD"   /* YY/MM/DD   */ \
                         }


/** Date format options */
extern const char *const date_format_settings[NUM_DATE_FMTS];


#endif /* DB_CLOCK_H_ */
