/*
 * db_remote.c
 *
 *  Created on: 04/03/2011
 *      Author: ian
 */
#include "kbd_5000.h"

#include "db_remote.h"


/** Remote function keys functions string list. Matches @ref enum eRemoteKeyFn */
const char *const remote_keyfn_strings[NUM_REMOTE_KEY_FUNCTIONS] = REMOTE_KEYFN_OPT_STRS;


/** Lookup to translate each of the remote key functions in @ref enum eRemoteKeyFn into a keypress, but no the batching ones */
const uint8_t remote_key_lookup[NUM_REMOTE_KEY_FUNCTIONS] = REMOTE_KEYFN_LOOKUP;


/** Remote inputs implemented as key presses, not inputs. Must match @ref enum eRemoteKeyFn */
const bool remote_key_is_key[NUM_REMOTE_KEY_FUNCTIONS] = REMOTE_KEYFN_IS_KEY;


/** Defaults for each of the remote key inputs */
const uint8_t remote_key_defaults[NUM_REMOTE_KEYS] =
{
  REMOTE_DISABLED,
  REMOTE_DISABLED,
  REMOTE_DISABLED,
  REMOTE_DISABLED,
  REMOTE_DISABLED,
  REMOTE_DISABLED,
  REMOTE_DISABLED,
  REMOTE_DISABLED
};


/** Front function keys function characters */
const char *const frontfunc_keyfn_strings[NUM_FRONTFUNC] = FRONTFUNC_KEYFN_OPT_STRS;


/** Lookup to translate each of the front function key functions in @ref enum eFunctionKeyFn into a keypress, but not the batching ones */
const enum eIndicatorKey frontfunc_key_lookup[NUM_FRONTFUNC] = FRONTFUNC_KEYFN_LOOKUP;


/** Defaults for each of the front function keys */
const uint8_t frontfunc_key_defaults[NUM_FRONT_FUNCTION_KEYS] =
{
  FRONTFUNC_PRINT,
  FRONTFUNC_DISABLED,
  FRONTFUNC_DISABLED,
};


/** String to convert a remote button into a key */
const char remote_button_to_key_str[NUM_REMOTE_KEY_FUNCTIONS + 1] = REMOTE_KEYFN_XLAT;


/** String to convert a front function key press into a key */
const char front_func_to_key_str[NUM_REMOTE_KEY_FUNCTIONS + 1] = FRONTFUNC_KEYFN_XLAT;

