/*
 * db_special.c
 *
 *  Created on: 01/08/2011
 *      Author: ian
 */

#include "db_special.h"


/** Permission options for each of the front keys */
const char *const front_key_permission_settings[NUM_FRONT_KEYS] = FRONT_KEY_PERMISSION_STRS;


/** Permission setting upper limit for each of the front keys */
const enum eFrontKeyPermissions front_key_permission_limits[NUM_FRONT_KEYS] = FRONT_KEY_PERMISSION_LIMITS;


/** Alternate units strings used in the menus */
const char *const alt_units_menus[NUM_ALT_UNITS] = ALT_UNITS_MENU_STRS;


/** Convert an indicator key into a front key */
enum eFrontKeys xlat_indicator_key_to_front_key(enum eIndicatorKey key)
{
  enum eFrontKeys fk;

  switch (key)
  {
    case ZERO_KEY:
      fk = FRONTKEY_ZERO;
      break;
    case TARE_KEY:
      fk = FRONTKEY_TARE;
      break;
    case GROSS_KEY:
      fk = FRONTKEY_GROSSNET;
      break;
    case FUNC1_KEY:
      fk = FRONTKEY_FUNC1;
      break;
    case FUNC2_KEY:
      fk = FRONTKEY_FUNC2;
      break;
    case FUNC3_KEY:
      fk = FRONTKEY_FUNC3;
      break;
    default:
      fk = NUM_FRONT_KEYS;
      break;
  }
  return fk;
}
