#ifndef DBPRINT_DOT_H
#define DBPRINT_DOT_H 1

#include <stdio.h>
#include <stdbool.h>
#include "comms_print.h"


/** DB print for menu item with no setting (like FAC.DFT) */
void to_string_no_setting(bool full, void *user_data, size_t index, char *buffer, size_t buflen);


/** DB print for a weight menu item */
void to_string_weight(const AdcRdg *rdg, bool print_units, char *buffer, size_t buflen);


/** Convert a print/autooutput format to a string */
void to_string_print_fmt(const char *fmt, char *buffer, size_t buflen);


/** Does the work of printing the database. Called from the comms printer thread. Don't call directly */
void comms_print_db(struct s_comms_print *cp, bool full);


/** Print out the entire configuration for the WE2111. This will be sent to the attached printer, or generate an error */
void print_current_config(bool full);


/** Print the database in human readable form to a file */
void print_db_to_file(FILE *f, bool full);


#endif /* #ifndef DBPRINT_DOT_H */
