/*
 * we_debug.c
 *
 *  Created on: 09/03/2011
 *      Author: ian
 */
#include <rinhw/ucos_ii.h>
#include "we_debug.h"

#include "debug_loop.h"


void loop_timing_init(struct s_loop_timing *lt, uint32_t interval)
{
  lt->lasttime = OSTimeGet();
  lt->print_interval = interval;
  lt->lastcount = 0;
  lt->count = 0;
}


void loop_timing_check(struct s_loop_timing *lt, const char *prefix)
{
  lt->count++;
  if (OSTimeGet() >= lt->lasttime + OS_TICKS_PER_SEC * lt->print_interval)
  {
    rdebug_printf(LOG_INFO, "%s: readings per second: %d\n",
                  prefix,
                  (lt->count - lt->lastcount) / lt->print_interval
                 );
    lt->lastcount = lt->count;
    lt->lasttime = OSTimeGet();
  }
}
