/*
 * device_finder.h
 *
 *  Created on: 27/07/2011
 *      Author: ian
 */

#ifndef DEVICE_FINDER_H_
#define DEVICE_FINDER_H_


#define DEVICE_FINDER_UPDATE_FILE "/var/run/rindevfind.xml"
#define DEVICE_FINDER_XML_MAX_LENGTH 1024

#define DEVICE_FINDER_XML_ROOT "rinstrum"
#define DEVICE_FINDER_XML_DEVICE "device"

#define DEVICE_FINDER_XML_CLASS "class"
#define DEVICE_FINDER_XML_CLASS_INDICATOR "Digital Weight Indicator"

#define DEVICE_FINDER_XML_NAME "name"
#define DEVICE_FINDER_XML_SERIALNUMBER "serialnumber"
#define DEVICE_FINDER_XML_VERSION "version"
#define DEVICE_FINDER_XML_CUSTOMID "customid"
#define DEVICE_FINDER_XML_MACADDRESS "macaddress"
#define DEVICE_FINDER_XML_TCPPORT "tcpport"
#define DEVICE_FINDER_XML_HOSTNAME "hostname"


/** Create XML containing necessary information for the device finder */
char *create_device_finder_xml(const char *class, const char *name, const char *serialno,
                               const char *version, const char *customid, const char *macaddr,
                               const char *tcpport, const char *hostname);


/** Create XML file containing necessary information for the device finder */
int write_device_finder_xml(const char *filename, const char *xml);


#endif /* DEVICE_FINDER_H_ */
