/*
 * devices.h
 *
 *  Created on: Dec 12, 2011
 *      Author: ian
 */

#ifndef DEVICES_H_
#define DEVICES_H_

#include <stdbool.h>
#include <rinhw/rio.h>
#include "indicator_model.h"


/** Buzzer device (located on display rinblock) */
extern struct t_io_dev dev_buz_we;


/** Primary keyboard device, (located on display rinblock) */
extern struct t_io_dev dev_kbd_we;


/** Second keyboard device, used for linux event devices (usb keyboards and the like) */
extern struct t_io_dev dev_kbd_event;


/** Real time clock device */
extern struct t_io_dev dev_rtc_we;


/** I2C device */
extern struct t_io_dev dev_iic0;


/** 24bit ADC device */
extern struct t_io_dev dev_adc24bit_we;


/** LCD device */
extern struct t_io_dev dev_lcd_we;


/**
 * Create devices for the system that don't required any settings from the database.
 *
 * Returns false on major problem (ie don't bother running).
 */
bool init_app_devices_pre_db(void);


/**
 * Create devices for the system that require settings from the database.
 *
 * Returns false on major problem (ie don't bother running).
 */
bool init_app_devices_post_db(enum e_indicator_model_sub_type imst);


/** Clean up devices */
void destroy_app_devices(void);


#endif /* DEVICES_H_ */
