/*
 * dm_envlist.h
 *
 *  Created on: Nov 21, 2011
 *      Author: ian
 */

#ifndef DM_ENVLIST_H_
#define DM_ENVLIST_H_


/**
 * Determine if an environment variable exists in the list:
 * varname=varvalue\n
 * varname=varvalue\n
 * \0
 *
 * Returns 0 if found, -1 if not
 *
 */
int envlist_variable_exists(const char *buf, const char *varname);


/**
 * Find a environment variable in a list of the form:
 * varname=varvalue\n
 * varname=varvalue\n
 * \0
 *
 */
int envlist_find(const char *buf, const char *varname, char *varvalue, size_t varvalue_max_len);


/**
 * Find a environment variable in a list of the form:
 * varname=varvalue\n
 * varname=varvalue\n
 * \0
 *
 * and check that the value equals varvalue
 *
 * Returns 0 for match, -1 otherwise
 *
 */
int envlist_findequals(const char *buf, const char *varname, const char *varvalue);


#endif /* DM_ENVLIST_H_ */
