/*
 * dm_event.h
 *
 *  Created on: Nov 22, 2011
 *      Author: ian
 */

#ifndef DM_EVENT_H_
#define DM_EVENT_H_

#include <stdbool.h>
#include <rinhw/rio.h>
#include "devicemounter.h"


/** Typedef of function to call when a event device is added/removed. result is RIO_ERROR_* or RIO_SUCCESS */
typedef void (*t_dm_event_callback_fn)(void *client_callback_data, enum eDeviceMounterAction action, int result);


/** Command to unregister an event device, command_data = NULL for all event devices, or name (eg "event0") for a specific one */
#define DM_EVENT_CMD_UNREGISTER 1


/** Initialise handling of event devices. kbd_io_dev is an existing keyboard device created by rio_create_device_kbd_linux_event() */
int dm_event_init(struct s_devicemounter *dm, struct t_io_dev *kbd_io_dev, t_dm_event_callback_fn event_callback_fn, void *client_callback_data);


#endif /* DM_EVENT_H_ */
