/*
 * dm_printer.h
 *
 *  Created on: Nov 21, 2011
 *      Author: ian
 */

#ifndef DM_PRINTER_H_
#define DM_PRINTER_H_

#include <stdbool.h>
#include <rinhw/rio.h>
#include "devicemounter.h"


/** Typedef of function to call when a printer device is added/removed */
typedef void (*t_dm_printer_callback_fn)(void *client_callback_data, enum eDeviceMounterAction action, bool result);


/** Command to remove a printer, command_data = NULL */
#define DM_PRINTER_CMD_REMOVE 1


/** Initialise handling of printer devices */
int dm_printer_init(struct s_devicemounter *dm, struct t_io_dev *printer_dev, t_dm_printer_callback_fn printer_callback_fn, void *client_callback_data);


#endif /* DM_PRINTER_H_ */
