/*
 * dm_serial.h
 *
 *  Created on: Sep 2, 2016
 *      Author: ian
 */

#ifndef DM_SERIAL_H_
#define DM_SERIAL_H_

#include <stdbool.h>
#include <rinhw/rio.h>
#include "devicemounter.h"


/**
 * Typedef of function to call when a serial port device is added/removed
 *
 * @param client_callback_data is the pointer passed to @ref dm_serial_init as client_callback_data
 * @param action is the action (add, remove)
 * @param result is success/failure so far of the serial device mounting
 * @param full_device_path is the full device path (eg "/dev/ttyUSB0"). Can be NULL if result is false.
 */
typedef void (*t_dm_serial_callback_fn)(void *client_callback_data, enum eDeviceMounterAction action, bool result, const char *full_device_path);


/** Command to remove a serial port, command_data = NULL */
#define DM_SERIAL_CMD_REMOVE 1


/** Initialise handling of serial devices */
int dm_serial_init(struct s_devicemounter *dm, t_dm_serial_callback_fn serial_callback_fn, void *client_callback_data);


#endif /* DM_SERIAL_H_ */
