/*
 * dsd.h
 *
 *  Created on: Mar 15, 2012
 *      Author: ian
 */

#ifndef DSD_H_
#define DSD_H_

#include <rinweigh/adcdatatypes.h>
#include <rinweigh/adcpacked.h>


#pragma pack(push)
#pragma pack(1)
/** This is what we store in each DSD record */
struct s_we_dsd_record
{
  AdcTraceableWeightPacked atwp;
};
#pragma pack(pop)


#define WE_DSD_APPROXFILESIZE (512 * 1024)
#define WE_DSD_RECORDSIZE (sizeof(struct s_we_dsd_record))
#define WE_DSD_MAXRECORDS (WE_DSD_APPROXFILESIZE / (WE_DSD_RECORDSIZE + sizeof(struct s_adc_dsd_record_header)))
#define WE_DSD_CRCSEED (2111)


/** The DSD */
extern struct s_adc_dsd *wedsd;


/** Returns true if there is a working DSD */
bool dsd_is_running(void);


/** Check if the DSD is full, will return false if DSD is not present */
bool dsd_is_full(void);


/** Purge records from the DSD */
bool dsd_purge(void);


/** Write a record to the DSD */
bool dsd_write(const AdcTraceableWeight *atw);


/** Start up the DSD, will open existing DSD file, but won't create a new one. */
bool dsd_init(void);


/** Clean up the DSD structure. File is closed, but not deleted */
void dsd_destroy(void);


/** Re-create a DSD file. All data will be lost. */
bool dsd_recreate_file(void);


/** Back up the DSD file to a file called "folder/WE2111_serno_date_time.dsd" */
bool dsd_backup_file(const char *folder);


#endif /* DSD_H_ */
