/*
 * edit_ip.h
 *
 *  Created on: Sep 19, 2017
 *      Author: ian
 */

#ifndef EDIT_IP_H_
#define EDIT_IP_H_


#include <netinet/in.h>
#include "editor.h"


/** The endian to run the IP editor in */
enum e_edit_ip_endian
{
  eie_host,     /*!< Run the editor in the host endian */
  eie_network   /*!< Run the editor in network endian */
};


/** A menu editor that allows IPv4 addresses to be edited in the specified endian */
enum eEditResult edit_ipv4_address(struct in_addr *ip_address, enum e_edit_ip_endian endian);


/** A menu editor that allows IPv4 addresses to be viewed but not edited in the specified endian */
enum eEditResult view_ipv4_address(const struct in_addr *ip_address, enum e_edit_ip_endian endian);


#endif /* EDIT_IP_H_ */
