/*
 * facdb_endian.h
 *
 *  Created on: Mar 15, 2017
 *      Author: ian
 */

#ifndef FACDB_ENDIAN_H_
#define FACDB_ENDIAN_H_

#include <stdint.h>
#include <rinweigh/adcdatatypes.h>


/** Convert a factory database to a specific endian */
void facdb_to_endian(AdcFactoryDatabase *facdb, int endian);


/** Calculate a checksum for a factory database given a specific endian */
uint16_t facdb_calc_checksum(const AdcFactoryDatabase *facdb, int endian);


/** Try to guess the endian of a factory database. Relies on a valid checksum */
int facdb_guess_endian(const AdcFactoryDatabase *facdb);


#endif /* FACDB_ENDIAN_H_ */
