/*
 * filebackup.h
 *
 *  Created on: 29/05/2012
 *      Author: ian
 */

#ifndef FILEBACKUP_H_
#define FILEBACKUP_H_


/**
 * Create backup file name in the form "folder/model_serialno_date_time_postfix.extension
 *
 * @param filename is the resultant file name, must be filename_len characters in length. Not NULL
 * @param filename_len is the maximum length of filename. Must be > 0
 * @param folder is the folder to prefix the filename with, will separate filename with '/' where appropriate. Can be NULL, in which case not used
 * @param postfix is appended to the filename before the extension. Can be NULL, in which case nothing is appended
 * @param extension is appended to the end of the filename, must contain '.' if you need one. Can be NULL in which case nothing is appended
 */
void create_backup_filename(char *filename, size_t filename_len, const char *folder, const char *postfix, const char *extension);


#endif /* FILEBACKUP_H_ */
