/*
 * fwinstall.c
 *
 *  Created on: Mar 23, 2012
 *      Author: ian
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dirent.h>
#include <rinexec/el_runcmd.h>

#include "fwinstall.h"


/**
 * Look for any .rpk files in dir_path
 *
 * Returns the number found, and the name of the last one
 */
int find_rpk(const char *dir_path, char *filename, size_t filename_length)
{
  struct dirent entry;
  struct dirent *dp;
  DIR *dir;
  int rpk_count;
  char *pos;
  const char ext[] = ".rpk";

  dir = opendir(dir_path);

  /* For each directory entry */
  for (rpk_count = 0; ; )
  {
    /* Get directory entry */
    if (0 != readdir_r(dir, &entry, &dp) || NULL == dp)
    {
      break;
    }
    else
    {
      /* Does this entry end in ".rpk" */
      pos = strstr(entry.d_name, ext);
      if (NULL != pos && pos == &entry.d_name[strlen(entry.d_name) - strlen(ext)])
      {
        strncpy(filename, entry.d_name, filename_length);
        filename[filename_length - 1] = '\0';
        rpk_count++;
      }
    }
  }

  closedir(dir);
  return rpk_count;
}


/**
 * Run "rinfwupgrade" in the background to install rpkfilename
 *
 * Note: rinfwupgrade will shutdown a bunch of services,
 * including the WE2111, so this app will die.
 */
bool install_rpk(const char *rpkfilename)
{
  const char *const rinfwupgrade_args[] = { "/usr/local/bin/rinfwupgrade", rpkfilename, NULL };

  /* Start the firmware upgrade, but don't wait for completion */
  return (el_run_command(rinfwupgrade_args[0], rinfwupgrade_args, NULL, NULL, false, false, true) == elr_success);
}
