/*
 * iface_analog.h
 *
 *  Created on: 24/03/2011
 *      Author: ian
 */

#ifndef IFACE_ANALOG_H_
#define IFACE_ANALOG_H_

#include "menus.h"
#include "we_config.h"
#include "access.h"


/** Analog source options */
enum eAnalogSource { ANALOG_SOURCE_GROSS = 0,
                     ANALOG_SOURCE_NET,
                     ANALOG_SOURCE_DISPLAY,
                     ANALOG_SOURCE_COMMS,
                     ANALOG_SOURCE_NUM
                   };


/** Analog source option strings, must match @ref enum eAnalogSource */
#define ANALOG_SOURCE_STRS { "GROSS", \
                             "NET", \
                             "DISP", \
                             "COMMS" \
                           }


/** Analog source option strings */
extern const char *const anal_src_setting[ANALOG_SOURCE_NUM];


/** Analog type options */
enum eAnalogType { ANALOG_TYPE_CURRENT = 0,
                   ANALOG_TYPE_VOLT,
                   ANALOG_TYPE_NUM
                 };


/** Analog type option strings, must match @ref enum eAnalogType */
#define ANALOG_TYPE_STRS { "CURR", \
                           "VOLT", \
                         }


/** Analog type option strings */
extern const char *const anal_type_setting[ANALOG_TYPE_NUM];


/** Convert percent * 100 into a proportion of analog output fullscale counts */
#define ANALOG_OUTPUT_PERCENT_TO_FULLSCALE_COUNTS(pct) (((ANALOG_OUTPUT_DAC_FULLSCALE / 100L) * pct) / 100L)


/** WECFG_ANALOG_OUTPUT_CAL_LIMIT represented in analog output DAC counts */
#define ANALOG_OUTPUT_CAL_LIMIT_COUNTS (ANALOG_OUTPUT_PERCENT_TO_FULLSCALE_COUNTS(WECFG_ANALOG_OUTPUT_CAL_LIMIT))


/** WECFG_ANALOG_OUTPUT_CAL_INCREMENT represented in analog output DAC counts */
#define ANALOG_OUTPUT_CAL_INCREMENT_COUNTS (ANALOG_OUTPUT_PERCENT_TO_FULLSCALE_COUNTS(WECFG_ANALOG_OUTPUT_CAL_INCREMENT))


/** Analog menu item */
extern const struct s_menu_item menu_analog;


#endif /* IFACE_ANALOG_H_ */
