/*
 * iface_display_total.h
 *
 *  Created on: Apr 16, 2018
 *      Author: ian
 */

#ifndef IFACE_DISPLAY_TOTAL_H_
#define IFACE_DISPLAY_TOTAL_H_

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>
#include <rinweigh/adcdatatypes.h>
#include "display.h"


/** Structure for displaying totals */
struct s_display_total
{
  bool show_total;                      /*!< Set if the total needs to be displayed */
  enum eAdcApprovalMode approval_mode;  /*!< The current approval mode */

  uint32_t item_count;                  /*!< The number of items in the total */
  AdcRdg ntep_gross_total;              /*!< Total gross weight for NTEP */
  AdcRdg ntep_net_total;                /*!< Total net weight for NTEP */
  AdcRdg non_ntep_total;                /*!< Total weight for non-NTEP */
  size_t ntep_min_digits;               /*!< Minimum number of digits for NTEP */
};


/** Run the total display sequence */
void run_total_display(struct s_display_total *dt);


/** Initiate the display of the statistics totals */
void initiate_display_total(struct s_display_total *dt);


#endif /* IFACE_DISPLAY_TOTAL_H_ */
