/*
 * iface_serial.c
 *
 *  Created on: 17/11/2010
 *      Author: ian
 */
#include <stdio.h>
#include "menus.h"
#include "iface_serial_config.h"
#include "iface_serial_ip.h"
#include "iface_serial_ports.h"
#include "indicator_model_features.h"

#include "iface_serial.h"


/*
 * Serial menu
 */


#define MENU_SERIAL_LIST_MAX 19


static const struct s_menu_item *menu_serial_list[MENU_SERIAL_LIST_MAX];


/** Construct the serial menu depending on what is fitted */
static bool serial_menu_enter_exit(bool entry_not_exit, bool full_edit, void *user_data, bool edit_not_tostring)
{
  size_t i;

  if (entry_not_exit)
  {
    i = 0;
    if (serial_menu_check_port_present(SERPORT_SER1_RL_REAR))
      menu_serial_list[i++] = &sub_menu_serial_ser1db9;
    if (serial_menu_check_port_present(SERPORT_SER2))
      menu_serial_list[i++] = &sub_menu_serial_ser2db9;
    if (serial_menu_check_port_present(SERPORT_RB1A))
      menu_serial_list[i++] = &sub_menu_serial_mod1a;
    if (serial_menu_check_port_present(SERPORT_RB1B))
      menu_serial_list[i++] = &sub_menu_serial_mod1b;
    if (serial_menu_check_port_present(SERPORT_RB2A))
      menu_serial_list[i++] = &sub_menu_serial_mod2a;
    if (serial_menu_check_port_present(SERPORT_RB2B))
      menu_serial_list[i++] = &sub_menu_serial_mod2b;
    menu_serial_list[i++] = &sub_menu_serial_usbslave;
    menu_serial_list[i++] = &sub_menu_serial_usbhost;
    menu_serial_list[i++] = &sub_menu_serial_tcp1;
    menu_serial_list[i++] = &sub_menu_serial_tcp2;
    menu_serial_list[i++] = &sub_menu_serial_udpfixed1;
    menu_serial_list[i++] = &sub_menu_serial_udpfixed2;
    menu_serial_list[i++] = &sub_menu_serial_udpdyn1;
    menu_serial_list[i++] = &sub_menu_serial_udpdyn2;
    menu_serial_list[i++] = &sub_menu_serial_netopt;
    menu_serial_list[i++] = &sub_menu_serial_autoopt;
    menu_serial_list[i++] = &sub_menu_serial_printopt;
    menu_serial_list[i++] = &sub_menu_serial_modbusopt;
    menu_serial_list[i++] = NULL;

    /* Can run */
    return true;
  }
  else
  {
    /* Can exit */
    return true;
  }
}


/** Serial menu item */
const struct s_menu_item menu_serial =
{
  .title = "SERIAL",
  .sub_menu = menu_serial_list,
  .menu_enter_exit = serial_menu_enter_exit
};
