/*
 * iface_serial_ports.h
 *
 *  Created on: 03/09/2016
 *      Author: ian
 */

#ifndef IFACE_SERIAL_PORTS_H_
#define IFACE_SERIAL_PORTS_H_

#include <stdbool.h>
#include "db_serial.h"
#include "menus.h"
#include "serial_ports.h"


/** Serial port type setting (auto out, net, etc) */
extern const char *const ser_type_setting[NUM_DB_SERIAL_TYPES];


extern const char *const baud_setting[NUM_DB_BAUD_SETTINGS];


/** Display error if serial port is not available */
void comms_error_setting_not_avail(void);


/** Check if a port is present */
bool serial_menu_check_port_present(enum eSerialPort port);


/*
 * Rinlink serial ports are fixed type/baud/bits
 */
/*
extern const struct s_menu_item sub_menu_serial_rlfront;
extern const struct s_menu_item sub_menu_serial_rlrear;
*/
extern const struct s_menu_item sub_menu_serial_ser1db9;
extern const struct s_menu_item sub_menu_serial_ser2db9;
extern const struct s_menu_item sub_menu_serial_mod1a;
extern const struct s_menu_item sub_menu_serial_mod1b;
extern const struct s_menu_item sub_menu_serial_mod2a;
extern const struct s_menu_item sub_menu_serial_mod2b;
extern const struct s_menu_item sub_menu_serial_usbslave;
extern const struct s_menu_item sub_menu_serial_usbhost;


#endif /* IFACE_SERIAL_PORTS_H_ */
