/*
 * indicator_model_features.h
 *
 *  Created on: 15 Nov. 2018
 *      Author: ian
 */

#ifndef INDICATOR_MODEL_FEATURES_H_
#define INDICATOR_MODEL_FEATURES_H_

#include "indicator_model.h"


/** Does the indicator have a status LED */
#define indicator_model_subtype_has_status_led(imst) (imst_c520_rinlink == imst || imst_c530_original == imst)


/** Does the indicator have a front rinlink */
#define indicator_model_subtype_has_front_rinlink(imst) (imst_c520_rinlink == imst || imst_c520_db9serial == imst)


/** Does the indicator have a rear rinlink */
#define indicator_model_subtype_has_rear_rinlink(imst) (imst_c520_rinlink == imst || imst_c530_original == imst)


/** Does the indicator have DB9 serial ports */
#define indicator_model_subtype_has_db9_serial(imst) (imst_we2111_original == imst || imst_c510_original == imst || imst_c520_db9serial == imst)


/** Does the indicator have a display */
#define indicator_model_subtype_has_display(imst) (imst_c530_original != imst)


/** Does the indicator have a keyboard */
#define indicator_model_subtype_has_keyboard(imst) (imst_c530_original != imst)


/** Does the indicator have key LEDs */
#define indicator_model_subtype_has_key_leds(imst) (imst_we2111_original == imst || imst_c510_original == imst)


/** Does the indicator have an F3 key (C520, C530 does, C510 & WE2111 doesn't) */
#define indicator_model_subtype_has_f3_key(imst) \
  (imst_c520_rinlink == imst || imst_c520_db9serial == imst || imst_c530_original == imst)


/** How many front keys does the the indicator model */
#define indicator_model_subtype_num_front_keys(imst) \
  ((imst_we2111_original == imst || imst_c510_original == imst) ? 5 : \
   (imst_c520_rinlink == imst || imst_c520_db9serial == imst || imst_c530_original == imst) ? 6 : 0)


#endif /* INDICATOR_MODEL_FEATURES_H_ */
