#ifndef KEY_DRVR_DOT_H
#define KEY_DRVR_DOT_H 1


/** Handle zero key press */
void zero_key_driver(void);


/** Handle de-zero (long press of zero key). Only works in non-trade mode */
void dezero_key_driver(void);


/** Handle a press of the tare key */
void tare_key_driver(void);


/** Handle longpress of tare key (operator menu) */
void detare_key_driver(void);


/** Handle gross/net key press */
void gross_key_driver(void);


/** Handle setup from front keys (long press of gross/net key) */
void front_cal_key_driver(void);


/** Handle a print key press */
void print_key_driver(bool immediate);


/** Handle a long print key press */
void deprint_key_driver(void);


/** Handle a function key press */
void function_key_driver(enum eIndicatorKey key);


/** Handle a function key long press */
void defunction_key_driver(enum eIndicatorKey key);


/** Handle setup from rear setup button */
void rear_cal_key_driver(void);


/** Handle the clear total key */
void clear_total_key_driver(void);


/** Initialise the key driver */
void init_key_driver(void);


/** Shutdown the key driver */
void destroy_key_driver(void);


#endif /* #ifndef KEY_DRVR_DOT_H */
