#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <rinweigh/adcinterface.h>
#include <rinweigh/adcdatabase.h>
#include "backgrnd.h"
#include "system.h"
#include "sysclock.h"
#include "buzz5000.h"
#include "comms_print.h"
#include "comms_util.h"
#include "remote_cal.h"
#include "adcthread.h"

#include "meas.h"


bool is_gross(void)
{
  return adcSuperStructure.adcDataWorking.dispRdg.info.status.bit.gross;
}


void set_gross(bool on)
{
  if (on)
  {
    AdcToGross(&adcSuperStructure, true, false);
  }
  else
  {
    AdcToNet(&adcSuperStructure, true, false);
  }
}


bool motion(void)
{
  return adcSuperStructure.adcDataWorking.grossRdg.info.status.bit.motion;
}


long get_peak_user_rdg(void)
{
  return adcSuperStructure.adcDataWorking.peakMaxDispRdg.rdg;
}


long get_user_rdg(void)
{
  return adcSuperStructure.adcDataWorking.dispRdg.rdg;
}


long get_abs_mv_v(void)
{
  return adcSuperStructure.adcDataWorking.mvvAbsRdg;
}


long get_user_gross(void)
{
  return adcSuperStructure.adcDataWorking.grossRdg.rdg;
}


long get_user_net(void)
{
  return adcSuperStructure.adcDataWorking.netRdg.rdg;
}


/*
 * Live weigh
 */


bool livest_ok(void)
{
  return (adcSuperStructure.adcHeldData.dataValid);
}
