#ifndef MEAS_DOT_H
#define MEAS_DOT_H 1

#include <stdbool.h>


bool is_gross(void);
/* returns true if gross mode is active
****************************************************************************/
void set_gross(bool on);
/*  routines to set and clear the zero, tare and gross states.
**************************************************************************/
bool motion(void);
/* returns true if motion detected
***************************************************************************/
long get_peak_user_rdg(void);
/* called to get or clear the peak user reading.
**************************************************************************/
long get_user_rdg(void);
/*  current user reading counts, gross or net depending on status of is_gross().
**************************************************************************/
long get_abs_mv_v(void);
/* get the underlying raw mv/v reading
** reading returned in mV/V where 30000 = 3.0 mV/V
**************************************************************************/
long get_user_gross(void);
/*  gross user reading counts
**************************************************************************/
long get_user_net(void);
/*   net user reading counts
**************************************************************************/
bool livest_ok(void);


#endif /* #ifndef MEAS_DOT_H */
