/*
 * resolution.c
 *
 *  Created on: 05/09/2011
 *      Author: ian
 */
#include <rinweigh/adcdatabase.h>
#include "adcthread.h"

#include "resolution.h"


/** Calculate the total number of graduations for the scale setup */
int32s calculate_scale_total_graduations(void)
{
  int32s total_grads;
  int32s tmp;

  switch (adcSuperStructure.adcUserDatabase.scaleType)
  {
    case ADC_SCALE_TYPE_SINGLE:
      total_grads = adcSuperStructure.adcUserDatabase.fullScale[0] / AdcResolutions[adcSuperStructure.adcUserDatabase.resolution[0]];
      break;

    case ADC_SCALE_TYPE_DUAL_RANGE:
    case ADC_SCALE_TYPE_DUAL_INTERVAL:
      tmp = adcSuperStructure.adcUserDatabase.fullScale[0] / AdcResolutions[adcSuperStructure.adcUserDatabase.resolution[0]];
      total_grads = tmp;
      tmp = adcSuperStructure.adcUserDatabase.fullScale[1] / AdcResolutions[adcSuperStructure.adcUserDatabase.resolution[1]];
      if (tmp > total_grads)
        total_grads = tmp;
      break;
    default:
      total_grads = 0;
      break;
  }
  return total_grads;
}


/** Check whether the current scale setup is outside the allowable limits for graduations */
bool scale_has_resolution_error(void)
{
  int32s total_grads;

  /* Get total graduations */
  total_grads = calculate_scale_total_graduations();

  /* Check limits */
  return (total_grads > MAX_GRADS || total_grads < MIN_GRADS);
}
