/*
 * resolution.h
 *
 *  Created on: 05/09/2011
 *      Author: ian
 */
#ifndef RESOLUTION_H_
#define RESOLUTION_H_

#include <rinhw/stdrinstrum.h>


/** Maximum number of graduations on the scale */
#define MAX_GRADS 100000L


/** Minimum number of graduations on the scale */
#define MIN_GRADS 100L


/** Calculate the total number of graduations for the scale setup */
int32s calculate_scale_total_graduations(void);


/** Check whether the current scale setup is outside the allowable limits for graduations */
bool scale_has_resolution_error(void);


#endif /* RESOLUTION_H_ */
