/*
 * modbus_task.h
 *
 *  Created on: Sep 4, 2014
 *      Author: ian
 */

#ifndef MODBUS_TASK_H_
#define MODBUS_TASK_H_

#include <stdbool.h>
#include <stddef.h>


/** Initialise modbus */
bool rinmodbus_init(size_t num_connections);


/** Force rin modbus to re-initalise settings from database */
void rinmodbus_reinit(enum eRinModbusEndian mb_endian,
                      unsigned tcp_port,
                      enum eRinModbusSerialMode mb_serial_mode,
                      unsigned mb_serial_address,
                      unsigned long mb_serial_baud,
                      char mb_serial_parity_bits,
                      unsigned mb_serial_data_bits,
                      unsigned mb_serial_stop_bits);


/** Change the serial port used by Modbus */
void rinmodbus_reinit_serial_port(const char *port);


/** Shutdown modbus */
void rinmodbus_destroy(void);


#endif /* MODBUS_TASK_H_ */
