/*
 * reboot.c
 *
 *  Created on: 27/10/2010
 *      Author: ian
 */
#include <wait.h>
#include <rinexec/el_runcmd.h>
#include <rinhw/rstdio.h>

#include "reboot.h"


/**
 * Force the system to reboot.
 *
 * Note this function will return, and our application will keep running
 * until the init process (or whatever it is) sends us a SIGTERM or SIGKILL.
 * This function simply initiates the reboot.
 */
int system_reboot(void)
{
  int ret_code;
  const char *const reboot_args[] = { "/sbin/reboot", NULL };

  /* Run reboot and check the return code */
  if (el_run_command(reboot_args[0], reboot_args, &ret_code, NULL, true, false, true) != elr_success ||
      !WIFEXITED(ret_code) || 0 != WEXITSTATUS(ret_code))
  {
    return RIO_ERROR;
  }

  return RIO_SUCCESS;
}
