#ifndef SERIAL_LEVELS_DOT_H
#define SERIAL_LEVELS_DOT_H 1

#include <stdint.h>
#include <stdbool.h>
#include <rinhw/rio.h>


/** Work out how much room there is left in the serial transmit buffer */
uint16_t get_serial_tx_free(struct t_io_dev *dev);


/** Work out the size of the serial transmit buffer */
uint16_t get_serial_tx_bufsize(struct t_io_dev *dev);


/**
 * Return if CTS is blocking transmission on a port.
 * This is simply the pin state, not whether the port
 * is configured to ignore CTS (or not)
 */
bool get_serial_cts_blocking(struct t_io_dev *dev);


#endif /* #ifndef SERIAL_LEVELS_DOT_H */
