#include <rinhw/rtc.h>
#include "system.h"
#include "devices.h"

#include "sysclock.h"


/** Get system date and time */
bool GetDateTime(t_datetime *datetime)
{
  bool result;

  result = (ropen(&dev_rtc_we, 0) == RIO_SUCCESS);
  if (result)
  {
    result = (rread(&dev_rtc_we, datetime, sizeof(t_datetime), 0) == sizeof(t_datetime));
    rclose(&dev_rtc_we);
  }
  return result;
}


/** Set system date and time */
bool SetDateTime(const t_datetime *datetime)
{
  bool result;

  result = (ropen(&dev_rtc_we, 0) == RIO_SUCCESS);
  if (result)
  {
    result = (rwrite(&dev_rtc_we, datetime, sizeof(t_datetime), 0) == sizeof(t_datetime));
    rclose(&dev_rtc_we);
  }
  return result;
}


static const uint8_t days_in_month[] = { 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };


bool check_date(uint8_t date, uint8_t month, uint16_t year)
{
  if (month > 12)
    return false;
  if (month < 1)
    return false;
  if (date < 1)
    return false;
  if (date > days_in_month[month - 1])
    return false;
  /* Year / 4, but not divisible by 100, but are divisble by 400 */
  /* Fixme: 100 years. Not implemented due to unnecessary calculation. */
  if ((month == 2) && ((year % 4) > 0))
    return ((bool) (date < 29));
  return true;
}
