#ifndef SYSTEM_DOT_H
#define SYSTEM_DOT_H 1

#include <stdint.h>


extern void my_idle(void);
extern void my_bf1000(void);
extern void my_bf100(void);


uint8_t get_seconds(void);
uint8_t get_tenths(void);

/* called to get either a count of tenths of a second 0..9
** or hundredths of a second 0..9.
** Each of these counters only counts 0..9 before cycling.
**************************************************************************/


/** Yield the current task for a number of milliseconds */
void delay(uint16_t millis);


/** Initialise the system poll functions */
void init_system(void);


/** Shutdown the system poll functions */
void destroy_system(void);


#endif /* #ifndef SYSTEM_DOT_H */
