/*
 * temperature.h
 *
 *  Created on: Aug 22, 2013
 *      Author: ian
 */

#ifndef TEMPERATURE_H_
#define TEMPERATURE_H_

#include <rinhw/stdrinstrum.h>
#include <rinweigh/adcdatatypes.h>


/** Different temperature units available */
enum eTemperatureUnits {
  tuRaw,          /*!< Raw reading from the temperature sensor */
  tuRawAveraged,  /*!< Raw averaged reading from the temperature sensor. Basically tuRaw * 16. Used by ADC library */
  tuKelvin,       /*!< Temperature in Kelvin */
  tuCelcius,      /*!< Temperature in Celcius */
};


/** Call to update the temperature with a new reading */
void temperature_update(uint16_t rawrdg);


/** Get the current temperature in requested units */
long temperature_get(enum eTemperatureUnits units);


#endif /* TEMPERATURE_H_ */
