/*
 * tests.c
 *
 *  Created on: May 11, 2015
 *      Author: ian
 */
#include <stdio.h>
#include <cutest/CuTest.h>
#include "test_comms_print_buffer.h"
#include "test_comms_send_buffer.h"


int main(int argc, char *argv[])
{
  int result;

  CuString *output = CuStringNew();
  CuSuite *suite = CuSuiteNew();

  /* Add tests */
  CuSuiteConsume(suite, CuGetSuite_comms_print_buffer());
  CuSuiteConsume(suite, CuGetSuite_comms_send_buffer());

  /* Run all tests */
  CuSuiteRun(suite);
  CuSuiteSummary(suite, output);
  CuSuiteDetails(suite, output);

  /* Print results */
  printf("%s\n", output->buffer);
  result = (suite->failCount > 0) ? 1 : 0;

  /* Clean up */
  CuSuiteDelete(suite);
  suite = NULL;
  CuStringDelete(output);
  output = NULL;

  /* Return result */
  return result;
}
