/*
 * timer.c
 *
 *  Created on: 5 May 2016
 *      Author: merrick
 */
#include <time.h>

#include "timer.h"


struct timespec diffTime(struct timespec start, struct timespec end)
{
  struct timespec temp;
  if ((end.tv_nsec - start.tv_nsec) < 0)
  {
          temp.tv_sec = end.tv_sec - start.tv_sec - 1;
          temp.tv_nsec = 1000000000 + end.tv_nsec - start.tv_nsec;
  }
  else
  {
          temp.tv_sec = end.tv_sec - start.tv_sec;
          temp.tv_nsec = end.tv_nsec - start.tv_nsec;
  }
  return temp;
}


int32_t msDiffTime(struct timespec start, struct timespec end)
{
  struct timespec temp;
  int32_t diff;

  temp = diffTime(start, end);

  diff = temp.tv_sec * 1000;  // TODO check the value is not too large before converting to ms
  diff += temp.tv_nsec / 1000000;

  return diff;
}


struct timespec addTime(struct timespec start, int32_t msec)
{
  struct timespec temp;

  temp.tv_sec = start.tv_sec + (msec / 1000);
  temp.tv_nsec = start.tv_nsec + ((msec % 1000) * 1000000);
  // check if nsec went over 1 sec
  if (temp.tv_nsec >= 1000000000)
  {
    temp.tv_sec += (temp.tv_nsec / 1000000000);
    temp.tv_nsec = temp.tv_nsec % 1000000000;
  }

  return temp;
}
