#ifndef VERSION_DOT_H
#define VERSION_DOT_H 1

#include <stdint.h>
#include "app_version.h"
#include "config.h"


/** Version as an integer, each can be 0..999 */
#define APP_VERSION_INT (APP_VERSION_MAJOR * 1000000 + APP_VERSION_MINOR * 1000 + APP_VERSION_REVISION)


/** Version as a string of the form n.n.n */
#define APP_VERSION_STR PACKAGE_VERSION


/** The drawing number string in the form C500-500-v.v.v where v.v.v is the version */
#define APP_DRAWING_NUMBER_STR PACKAGE_NAME "-" PACKAGE_VERSION


/** Maximum length of the version string */
#define APP_VERSION_STR_MAX 50


/** 5 character version string (eg P54i) */
extern const char app_version_str[];


/** Copyright string */
extern const char copyright[];


/** Model number string  */
extern const char model[];


/** This matches version where P54A = 1, P54B = 2 etc */
extern const uint32_t sw_version_cnt;


/** Default for when application ID hasn't been set */
#define APPLICATION_ID_DEFAULT 99


/** WE2111 model */
#define APPLICATION_ID_WE2111 21


/** Determine if the software is a prototype */
#define IS_PROTOTYPE_SOFTWARE() (APP_VERSION_MAJOR == 0)


#endif /* #ifndef VERSION_DOT_H */
