/*
 * watchdog.h
 *
 *  Created on: Apr 2, 2014
 *      Author: ian
 */

#ifndef WATCHDOG_H_
#define WATCHDOG_H_


/** Kick the watchdog, this should be called at regular intervals */
void watchdog_kick(void);


/** Initialise the watchdog using specified device (eg /dev/watchdog) */
void watchdog_init(const char *device);


/**
 * Shut down the watchdog.
 *
 * This sends the magic close char before closing the device, to prevent reboots once the
 * application has quit. This allows us to do firmware upgrades without having a reboot
 * in the middle of it
 */
void watchdog_destroy(void);


#endif /* WATCHDOG_H_ */
