/*
 * we_debug.c
 *
 *  Created on: Apr 18, 2013
 *      Author: ian
 */
#include <stdarg.h>
#include <stdio.h>
#include <ctype.h>
#include <syslog.h>
#include <rinhw/rstdio.h>
#include <rinhw/rio.h>
#include <rinhw/sio.h>
#include "devices.h"
#include "cmdline.h"

#include "we_debug.h"


/** Debug vprintf */
void rdebug_vprintf(int level, const char *format, va_list arglist)
{
  va_list argsyslog;

  va_copy(argsyslog, arglist);

  if (cmdline_logtostdout)
  {
    /* Send to normal stdout */
    vprintf(format, arglist);
  }

  if (cmdline_logtosyslog)
  {
    /* Send to syslog */
    vsyslog(level, format, argsyslog);
  }

  va_end(argsyslog);
}


/** Debug printf */
void rdebug_printf(int level, const char *format, ...)
{
  va_list arglist;

  va_start(arglist, format);
  rdebug_vprintf(level, format, arglist);
  va_end(arglist);
}
