Rinstrum Hardware Libraries
=============

## Compiling ##

If [cross compiling] ensure toolchain binaries are added to path.

For M4223 (uses binaries from L000-510):

    export PATH=$PATH:/home/merrick/git/L000.510/factory/build_armv5l-timesys-linux-uclibcgnueabi/toolchain/bin

For WE2111/C500:

    export PATH="/opt/CodeSourcery/Sourcery_G++_Lite/bin:$PATH"

Configure and make:

    ./autogen.sh
    ./configure [--host={HOST}]
    make

{HOST} options are:

    armv5l-timesys-linux-uclibcgnueabi
    m68k-uclinux

Configuring for Linux PC (for debugging):

    ./configure CFLAGS="-O0 -g -Wall -Wextra -Wno-unused-parameter -fPIC" CC=gcc

Configuring for cross compile on Linux for Windows PC:

    sudo apt install mingw-w64
    ./configure CFLAGS="-Wall -Wextra -Wno-unused-parameter" --host=x86_64-w64-mingw32 CC=x86_64-w64-mingw32-gcc
    make
Use the executable(s) out of the .libs folders rather than the one(s) in the source folders.

Configuring for M68k:

    ./configure CFLAGS="-mcpu=5329 -Os -Wall -Wextra -Wno-unused-parameter -fPIC" --host=m68k-uclinux CC=m68k-uclinux-gcc


## Cleaning ##
    make clean
