/*
 * adc_ads1216_we21.c
 *
 * WE21 specific code for the ADS1216
 *
 *  Created on: May 21, 2013
 *      Author: ian
 */
#include <rinhw/rio.h>
#include "_adc_ads1216_local.h"
#include <rinhw/we21hw.h>

#include <rinhw/adc_ads1216_we21.h>


/** User hardware init for ADC on WE2111 */
int adc24bit_user_hw_init_we21(struct sAdcSpiDevice *adcdev)
{
  adc24bit_write_register8(adcdev->fd, ADS1216_REG_DIR, (int8u) 0x0F);  /* 0-3 inputs, 4-7 outputs */
  adc24bit_write_register8(adcdev->fd, ADS1216_REG_DIO, 0x00);
  return RIO_SUCCESS;
}


/** Reset the ADC, and check that it's responding */
int adc24bit_sync_spi_we21(struct sAdcSpiDevice *adcdev)
{

  /*
   * On the WE2111, there is a chip select line, so we simply test whether the ADC is present
   */
  return (adc24bit_check_adc_present(adcdev->fd)) ? RIO_SUCCESS : RIO_ERROR;
}


/* No 4/6 wire switch on WE2111 */


/**
 * Wait for a reading to become available
 *
 * This implementation utilises the /DRDY signal
 * connected to an interrupt line on the processor
 */
int adc24bit_wait_for_reading_we21(struct sAdcSpiDevice *adcdev, unsigned short timeout)
{
  /* Wait for ADC data or timeout */
  return we21hw_adc_wait_data(timeout);
}
