/*
 * buzzer_dummy.c
 *
 *  Created on: Jul 8, 2014
 *      Author: ian
 */
#include <rinhw/buzzer_generic.h>
#include <rinhw/timemath.h>

#include <rinhw/buzzer_dummy.h>


static int buz_dummy_run_seq(struct s_generic_buzzer *gb)
{
  struct timespec ts_req, ts_rem;

  /* Pretend to beep */
  for (gb->current_buz_seq = 0; gb->current_buz_seq < gb->num_buz_seq && !gb->buz_task_quit; gb->current_buz_seq++)
  {
    /* Delay for the desired time */
    OSTicksToTimespec(&ts_req, gb->buz_seq[gb->current_buz_seq].time);
    nanosleep(&ts_req, &ts_rem);
  }

  /* make sure current_buz_seq is larger than num_buz_seq for the buz_read func */
  gb->current_buz_seq = (unsigned char) (gb->num_buz_seq+1);

  return RIO_SUCCESS;
}


/** Function to create and initialise a dummy buzzer device (handles standard buzzer operations, but doesn't beep) */
int rio_create_device_buzzer_dummy(struct t_io_dev *io_dev)
{
  int res;

  /* Create generic buzzer device */
  res = rio_create_device_buzzer_generic(io_dev,
                                         NULL,
                                         NULL,
                                         NULL,
										 buz_dummy_run_seq);
  return res;
}
