#include <rinhw/byteq.h>


/**
 * Destroy an existing byte queue
 *
 * Parameters:
 *   q is a pointer to an existing initialised byte queue struct
 *
 * Returns:
 *   bqrSuccess on success, bqrError otherwise
 */
enum eBQResult ByteQDestroy(struct s_byteq *q)
{
  /* Set some values */
  q->Size = 0;
  q->Count = 0;

  /* Destroy the space semaphore */
  sem_destroy(&q->Sem);

  /* Destroy exclusive access semaphore */
  pthread_mutex_destroy(&q->lock_mutex);
  return bqrSuccess;
}
