#include <pthread.h>

#include <rinhw/byteq.h>


/**
 * Get the number of bytes in the queue
 *
 * Parameters:
 *   q is a pointer to an existing initialised byte queue struct
 *
 * Returns:
 *   The number of bytes in the queue
 */
size_t ByteQGetLevel(struct s_byteq *q)
{
  size_t level;

  /* Lock this section */
  if (pthread_mutex_lock(&q->lock_mutex) != 0)
  {
    /* Not sure what else to return */
    return 0;
  }

  /* Read the level into a temporary variable */
  level = q->Level;

  /* Unlock and return the level */
  pthread_mutex_unlock(&q->lock_mutex);
  return level;
}
