#ifndef _KBD_HW_DOT_H
#define _KBD_HW_DOT_H 1


/*
 * Error result from KeyToIndex() when key not found
 */
#define KEY_LOOKUP_FAIL 0xFF


/*
 * KeyToIndex -
 *
 * Convert a key code into a bit index
 * as per a reverse lookup of the key_lookup table, for internal keys
 * External keys have no translation
 */
unsigned char KeyToIndex(unsigned char key);


/*
 * IndexToKey -
 *
 * Convert a bit index into a key code
 * as per the key_lookup table, for internal keys
 * External keys have no translation
 */
unsigned char IndexToKey(unsigned char idx);


#endif /* #ifndef _KBD_HW_DOT_H */
