#ifndef LCDXLAT_DOT_H
#define LCDXLAT_DOT_H 1


#include "_lcdtbl.h"
#include <rinhw/lcd.h>


/** Number of characters on the R400 LCD */
#define NUM_LCD_DIGITS 28


/*
 * tLcdDigit -
 *
 * Struct containing info on each lcd digit
 * (position in lcd, bit mask, translation table, decimal point)
 */
typedef struct
{
    unsigned short bit_num;
    unsigned long mask;
    const signed short *xlat_tbl;
    unsigned char has_dp;
} tLcdDigit;


/*
 * SEGS_PER_DIGIT - Number of segments in a digit
 */
#define SEGS_PER_DIGIT 10


/*
 * The segment translation table for each different type of digit
 */
extern const signed short digit_xlat[NUM_DIGIT_XLATS][SEGS_PER_DIGIT];


/*
 * The digit list - defines each digit on the LCD
 */
extern const tLcdDigit lcd_digits[NUM_LCD_DIGITS];

#endif
