/*
 * lcd_generic_common.c
 *
 *  Created on: 29/05/2012
 *      Author: ian
 */
#include <rinhw/debug.h>
#include <rinhw/lcd.h>
#include <rinhw/lcd_generic.h>

#include "lcd_generic_common.h"


/** LCD Device file length */
long lcd_generic_common_filelength(struct t_io_dev *io_dev)
{
  struct s_lcd_definition *lcd_definition;
#if HW_DEBUG(LCD_DEBUG, HW_DEBUG_BASIC)
  DEBUG_PRINTF("lcd_generic_common_filelength called\n");
#endif

  /* Check pointers */
  lcd_generic_pointer_check();
  lcd_definition = io_dev->dev_data;

  /*
   * Depending on what we are accessing, return
   * the size of the appropriate buffer (segment or character)
   */
  return (long) ((lcd_definition->lcd_access_segs_not_chars) ? lcd_definition->lcd_num_segment_bytes : lcd_definition->lcd_num_characters);
}
