#include "_lcdtbl.h"


/*
 * The LCD segment table
 */
const unsigned short seg_table[NUM_SEG_TABLE] =
{
    MS_NONE,        /* 0 */
    MSA,            /* 1 */
    MSB,            /* 2 */
    MSC,            /* 3 */
    MSD,            /* 4 */
    MSE,            /* 5 */
    MSF,            /* 6 */
    MSG,            /* 7 */
    MSH,            /* 8 */
    MSI,            /* 9 */
    MSJ,            /* 10 */
    MS_ALL,         /* 11 */
    MS_NONE,        /* 12 */
    MS_NONE,        /* 13 */
    MS_NONE,        /* 14 */
    MS_NONE,        /* 15 */
    MS_NONE,        /* 16 */
    MS_NONE,        /* 17 */
    MS_NONE,        /* 18 */
    MS_NONE,        /* 19 */
    MS_NONE,        /* 20 */
    MS_NONE,        /* 21 */
    MS_NONE,        /* 22 */
    MS_NONE,        /* 23 */
    MS_NONE,        /* 24 */
    MS_NONE,        /* 25 */
    MS_NONE,        /* 26 */
    MS_NONE,        /* 27 */
    MS_NONE,        /* 28 */
    MS_NONE,        /* 29 */
    MS_NONE,        /* 30 */
    MS_NONE,        /* 31 */

    (MS_NONE),                                  /* 32 Space */
    (MSB | MSH), //MSC |                        /* 33 ! */
    (MSB | MSF),                                /* 34 " */
    (MSB | MSF | MSE | MSC),                    /* 35 # */
    (MSA | MSF | MSI | MSG | MSC | MSD | MSJ),  /* 36 $ */
    (MSB | MSG | MSE | MSH),                    /* 37 % */
    (MSA | MSF | MSG | MSI | MSC | MSD | MSE),  /* 38 & */
    (MSB),                                      /* 39 ' */
    (MSA | MSF | MSE | MSD),                    /* 40 ( */
    (MSA | MSB | MSC | MSD),                    /* 41 ) */
    (MSF | MSI | MSB | MSG | MSE | MSJ | MSC),  /* 42 * */
    (MSI | MSG | MSJ),                          /* 43 + */
    (MSC),                                      /* 44 , */
    (MSG),                                      /* 45 - */
    (MSH),                                      /* 46 . */
    (MSB | MSG | MSE),                          /* 47 / */

    (MSA | MSF | MSE | MSD | MSC | MSB),        /* 48 0 */
    (MSB | MSC),                                /* 49 1 */
    (MSA | MSB | MSG | MSE | MSD),              /* 50 2 */
    (MSA | MSB | MSG | MSC | MSD),              /* 51 3 */
    (MSF | MSB | MSG | MSC),                    /* 52 4 */
    (MSA | MSF | MSG | MSC | MSD),              /* 53 5 */
    (MSA | MSF | MSG | MSC | MSD | MSE),        /* 54 6 */
    (MSA | MSB | MSC),                          /* 55 7 */
    (MSA | MSF | MSB | MSG | MSE | MSD | MSC),  /* 56 8 */
    (MSA | MSF | MSB | MSG | MSD | MSC),        /* 57 9 */

    (MSI | MSJ),                                /* 58 : */
    (MSI | MSC),                                /* 59 ; */
    (MSB | MSC | MSG),                          /* 60 < */
    (MSA | MSG),                                /* 61 = */
    (MSE | MSF | MSG),                          /* 62 > */
    (MSA | MSB | MSJ),                          /* 63 ? */
    (MS_ALL),                                   /* 64 @ for want of something better */

    (MSA | MSF | MSB | MSG | MSE | MSC),        /* 65 A */
    (MSA | MSI | MSB | MSG | MSJ | MSC | MSD),  /* 66 B */
    (MSA | MSF | MSE | MSD),                    /* 67 C */
    (MSA | MSI | MSB | MSJ | MSC | MSD),        /* 68 D */
    (MSA | MSF | MSG | MSE | MSD),              /* 69 E */
    (MSA | MSF | MSG | MSE),                    /* 70 F */
    (MSA | MSF | MSE | MSC | MSD),              /* 71 G */
    (MSF | MSB | MSG | MSE | MSC),              /* 72 H */
    (MSA | MSI | MSJ | MSD),                    /* 73 I */
    (MSB | MSC | MSD | MSE),                    /* 74 J */
    (MSF | MSI | MSG | MSE | MSC),              /* 74 K */
    (MSF | MSE | MSD),                          /* 76 L */
    (MSA | MSF | MSI | MSB | MSE | MSJ | MSC),  /* 77 M */
    (MSA | MSF | MSB | MSE | MSC),              /* 78 N */
    (MSA | MSF | MSB | MSE | MSC | MSD),        /* 79 O */
    (MSA | MSF | MSB | MSG | MSE),              /* 80 P */
    (MSA | MSF | MSB | MSE | MSJ | MSC | MSD),  /* 81 Q */
    (MSA | MSF | MSB | MSG | MSE | MSJ),        /* 82 R */
    (MSA | MSF | MSG | MSC | MSD),              /* 83 S */
    (MSA | MSI | MSJ),                          /* 84 T */
    (MSF | MSB | MSE | MSC | MSD),              /* 85 U */
    (MSF | MSB | MSE | MSJ),                    /* 86 V */
    (MSF | MSI | MSB | MSE | MSJ | MSC | MSD),  /* 87 W */
    (MSF | MSI | MSG | MSJ | MSC),              /* 88 X */
    (MSF | MSB | MSG | MSJ),                    /* 89 Y */
    (MSA | MSB | MSG | MSE | MSD),              /* 90 Z */

    (MSA | MSF | MSE | MSD),                    /* 91 [ */
    (MSF | MSG | MSC),                          /* 92 \ */
    (MSA | MSB | MSC | MSD),                    /* 93 ] */
    (MSF | MSA | MSB),                          /* 94 ^ */
    (MSD),                                      /* 95 _ */
    (MSF),                                      /* 96 ` */

    (MSA | MSF | MSB | MSG | MSE | MSC),        /* 97 a */
    (MSF | MSE | MSD | MSC | MSG),              /* 98 b */
    (MSG | MSE | MSD),                          /* 99 c */
    (MSB | MSC | MSD | MSE | MSG),              /* 100 d */
    (MSA | MSF | MSG | MSE | MSD),              /* 101 e */
    (MSA | MSF | MSG | MSE),                    /* 102 f */
    (MSA | MSF | MSB | MSG | MSC | MSD),        /* 103 g */
    (MSF | MSG | MSE | MSC),                    /* 104 h */
    (MSC),                                      /* 105 i */
    (MSC | MSD),                                /* 106 j */
    (MSF | MSI | MSE | MSG | MSC),              /* 107 k */
    (MSB | MSC),                                /* 108 l */
    (MSG | MSE | MSJ | MSC),                    /* 109 m */
    (MSE | MSG | MSC),                          /* 110 n */
    (MSE | MSG | MSC | MSD),                    /* 111 o */
    (MSA | MSF | MSB | MSE | MSG),              /* 112 p */
    (MSA | MSF | MSB | MSC | MSG),              /* 113 q */
    (MSE | MSG),                                /* 114 r */
    (MSA | MSF | MSG | MSC | MSD),              /* 115 s */
    (MSF | MSG | MSE | MSD),                    /* 116 t */
    (MSE | MSD | MSC),                          /* 117 u */
    (MSE | MSJ),                                /* 118 v */
    (MSE | MSJ | MSC | MSD),                    /* 119 w */
    (MSF | MSI | MSG | MSJ | MSC),              /* 120 x */
    (MSF | MSB | MSG | MSC | MSD),              /* 121 y */
    (MSA | MSB | MSG | MSE | MSD),              /* 122 z */

    (MSA | MSF | MSE | MSD),                    /* 123 { */
    (MSI | MSJ),                                /* 124 | */
    (MSA | MSB | MSC | MSD),                    /* 125 } */
    (MSA),                                      /* 126 ~ */
    (MS_NONE),                                  /* 127 Del */
};
