#ifndef _POWER_DOT_H
#define _POWER_DOT_H 1


#define EARLY_INIT_POWER early_init_power


/*
 * early_init_power -
 *
 * Set the power pin as an output, and hold the power on
 * The bootloader should have done this already, but its necessary
 * to let out GPIO code know about the state of the power pin DDR
 */
void early_init_power(void);


/*
 * set_user_flash_fn -
 *
 * Used to set the flash programming function. A pointer to
 * this function is passed from the bootloader
 */
void set_user_flash_fn(void (*FlashFn)(unsigned char sci));


#endif
