#include <unistd.h>
#include <stdlib.h>
#include <rinhw/ucos_ii.h>
#include <rinhw/gpio.h>
#include <rinhw/wdt.h>
#include <rinhw/rstdio.h>
#include "_shutdown.h"
#include <rinhw/power.h>
#include "_power.h"


/*
 * Power pin definitions
 */
//#define POWER_PIN_DDR P_P3.DDR
//#define POWER_PIN_MASK 0x40
//#define POWER_PIN P_P3.DR.BIT.B6


/*
 * Pointer to user flash programming function
 */
static void (*UserFlashFn)(unsigned char sci) = NULL;


/*
 * PowerTurnOn -
 *
 * Turn the power on
 */
void PowerTurnOn(void)
{
  /* TODO */
}


/*
 * PowerTurnOff -
 *
 * Turn the power off. This function will never return
 */
void PowerTurnOff(void)
{
//    OS_DECLARE_CPU_SR();        /* Must be last variable */

    /*
     * Shutdown the system
     */
//    OSSchedLock();
    rshutdown();

    /* Exit the process */
    exit( 0 );
}


/*
 * SystemReset -
 *
 * Reset the system
 */
void SystemReset(void)
{
//    OS_DECLARE_CPU_SR();        /* Must be last variable */

    /*
     * Shutdown the system
     */
//    OSSchedLock();
    rshutdown();

    /* Exit the process */
    exit( 0 );
}


/*
 * early_init_power -
 *
 * Set the power pin as an output, and hold the power on
 * The bootloader should have done this already, but its necessary
 * to let out GPIO code know about the state of the power pin DDR
 */
void early_init_power(void)
{
//    gpio_set_ddr(&POWER_PIN_DDR, POWER_PIN_MASK, doOR);
    PowerTurnOn();
}


/*
 * set_user_flash_fn -
 *
 * Used to set the flash programming function. A pointer to
 * this function is passed from the bootloader
 */
void set_user_flash_fn(void (*FlashFn)(unsigned char sci))
{
    UserFlashFn = FlashFn;
}


/*
 * StartFlashProgrammer -
 *
 * Start the flash programmer in the bootloader, but check the
 * pointer is ok first. If the pointer is ok, then the function
 * is called (and never return), otherwise the function will
 * return.
 */
void StartFlashProgrammer(unsigned char sci)
{
#if 0
    if (UserFlashFn != NULL)
    {
        /*
         * Shutdown the system
         * and start the flash programmer
         */
//        OSSchedLock();
//        rshutdown();
        UserFlashFn(sci);
    }
#endif
}
