/*
 * adc_ads1216_r400.h
 *
 *  Created on: May 21, 2013
 *      Author: ian
 */

#ifndef ADC_ADS1216_R400_H_
#define ADC_ADS1216_R400_H_


/** User hardware init for ADC on R400 */
int adc24bit_user_hw_init_r400(struct sAdcSpiDevice *adcdev);


/** Reset the ADC using the SPI reset sequence, and check that it's responding */
int adc24bit_sync_spi_r400(struct sAdcSpiDevice *adcdev);


/** Set the loadcell 4/6 wire mode on a R400 */
int adc24bit_set_loadcell_wire_mode_r400(struct sAdcSpiDevice *adcdev, int level);


/**
 * Wait for a reading to become available.
 *
 * This implementation has no access to the /DRDY signal
 * and continually polls the ADS1216 until the DRDY bit
 * gets cleared
 */
int adc24bit_wait_for_reading_r400(struct sAdcSpiDevice *adcdev, unsigned short timeout);


#endif /* ADC_ADS1216_R400_H_ */
