#ifndef ADC_UP_DOT_H
#define ADC_UP_DOT_H 1

#include <rinhw/rio.h>


/**
 * rioctl(&dev_adc, IOCTL_ADC_GET_NUM_CHANNELS, int *num_channels);
 *  Return the number of channels supported by this ADC in num_channels
 */
#define IOCTL_ADC_GET_NUM_CHANNELS 700


/**
 * rioctl(&dev_adc, IOCTL_ADC_WRITE_CALIBRATION, int32u *raw_per_millivolt);
 *  Calibrate the ADC channels. raw_per_millivolt is an array of calibration values
 *  (1 for each supported channel). Use IOCTL_ADC_GET_NUM_CHANNELS to determine the number of channels
 */
#define IOCTL_ADC_WRITE_CALIBRATION 701


/**
 * rioctl(&dev_adc, IOCTL_ADC_READ_CALIBRATION, int32u *raw_per_millivolt);
 *  Read the current calibration for the ADC channels. raw_per_millivolt is an array of calibration values
 *  (1 for each supported channel). Use IOCTL_ADC_GET_NUM_CHANNELS to determine the number of channels
 */
#define IOCTL_ADC_READ_CALIBRATION 702


/* Number of ADC channels on the R400 on-chip ADC. Depreciated, use @ref IOCTL_ADC_GET_NUM_CHANNELS */
#define NUM_ADC_CHANNELS 4


/*
 * R400 ADC Channel Assigns
 */
#define ADC_CH_VIN 0
#define ADC_CH_TEMP 1
#define ADC_CH_SNS_MINUS 2
#define ADC_CH_SNS_PLUS 3


#endif /* #ifndef ADC_UP_DOT_H */
