#ifndef BKGRND_DOT_H
#define BKGRND_DOT_H 1

#include <rinhw/tick.h>
#include <pthread.h>

/*
 * BackgroundAddFunction -
 *
 * Add a new function to call to the list of functions
 * Parameter new_tick_fn must have preset and function filled out
 */
void BackgroundAddFunction(struct t_tick_fn *new_tick_fn);


/*
 * BackgroundRemoveFunction -
 *
 * Remove an existing function from the list of functions
 */
void BackgroundRemoveFunction(struct t_tick_fn *remove_tick_fn);


/*
 * BackgroundChangePreset -
 *
 * Change the preset time of the background function. Count is reset when this is called,
 * so the preset inteval will expire before the next function call.
 */
void BackgroundChangePreset(struct t_tick_fn *new_tick_fn, unsigned short preset);


#endif /* #ifndef BKGRND_DOT_H */
