#ifndef BUZZER_DOT_H
#define BUZZER_DOT_H 1

#include <rinhw/rio.h>
#include <rinhw/stdrinstrum.h>


/*
 * This is the best freq to use for loud beeps
 */
#define BUZZER_RESONANT_FREQ 4000


/*
 * Buzzer struct, write 1 or more of this to the
 * buzzer device to make sound sequences.
 * freq is in Hz, 0 will generate a silence
 * Time is in system ticks
 */
typedef struct
{
  int16u time;
  int16u freq;
} tBuzzer;


#endif /* #ifndef BUZZER_DOT_H */
