#ifndef IIC_DOT_H
#define IIC_DOT_H 1

#include <rinhw/rio.h>


/*
 * IO Control functions for the IIC -
 *
 * rioctl(&dev_iic, IOCTL_IIC_SET_SLAVE_ADDR, unsigned char slave_address);
 * rioctl(&dev_iic, IOCTL_IIC_GET_SLAVE_ADDR, unsigned char *slave_address);
 * rioctl(&dev_iic, IOCTL_IIC_SET_SLOT_MASK, unsigned char mask);
 * rioctl(&dev_iic, IOCTL_IIC_GET_SLOT_MASK, unsigned char *mask);
 * rioctl(&dev_iic, IOCTL_IIC_CLEAR_SLOT_MASK);
 * rioctl(&dev_iic, IOCTL_IIC_SET_SPEED, unsigned char speed);
 */
#define IOCTL_IIC_SET_SLAVE_ADDR 300
#define IOCTL_IIC_GET_SLAVE_ADDR 301
#define IOCTL_IIC_SET_SLOT_MASK 302
#define IOCTL_IIC_GET_SLOT_MASK 303
#define IOCTL_IIC_DEFAULT_SLOT_MASK 304
#define IOCTL_IIC_SET_SPEED 305

/*
 * Constants for use with IOCTL_IIC_SET_SPEED
 */
#define IIC_SPEED_CLK_DIV_28 0
#define IIC_SPEED_CLK_DIV_40 1
#define IIC_SPEED_CLK_DIV_48 2
#define IIC_SPEED_CLK_DIV_56 8
#define IIC_SPEED_CLK_DIV_64 3
#define IIC_SPEED_CLK_DIV_80 4
/* #define IIC_SPEED_CLK_DIV_80 9 */
#define IIC_SPEED_CLK_DIV_96 10
#define IIC_SPEED_CLK_DIV_100 5
#define IIC_SPEED_CLK_DIV_112 6
#define IIC_SPEED_CLK_DIV_128 7
/* #define IIC_SPEED_CLK_DIV_128 11 */
#define IIC_SPEED_CLK_DIV_160 12
#define IIC_SPEED_CLK_DIV_200 13
#define IIC_SPEED_CLK_DIV_224 14
#define IIC_SPEED_CLK_DIV_256 15

#define IIC_SPEED_DEFAULT IIC_SPEED_CLK_DIV_128


#endif /* #ifndef IIC_DOT_H */
