#ifndef KBD_LOCAL_DOT_H
#define KBD_LOCAL_DOT_H 1

#include <rinhw/rio.h>
#include <rinhw/kbd.h>


/**
 * Function to create and initialise a local keyboard device
 *
 * @param io_dev is the device structure to be initialised as a keyboard
 * @param kbd_hw_definition is the keyboard hardware device structure, gets copied into driver data, so doesn't have to be allocated for the duration of the device. Can be NULL (in which case driver will run, but no keys will ever appear).
 * @param dev_buzzer is the buzzer device to use for key beeps. Can be NULL (in which case there will be no key beeps).
 */
int rio_create_device_kbd_local(struct t_io_dev *io_dev, struct s_kbd_hw_definition *kbd_hw_definition, struct t_io_dev *dev_buzzer);


#endif /* #ifndef KBD_LOCAL_DOT_H */
