/*
 * rinthread.h
 *
 *  Created on: Jun 29, 2016
 *      Author: ian
 */

#ifndef RINTHREAD_H_
#define RINTHREAD_H_

#include <stdbool.h>


/**
 * Check for problems with thread stacks.
 *
 * Sprinkle calls to rin_thread_check_canary() throughout the suspect code.
 */
void rin_thread_check_canary(void);


/** Exit a thread, rinstrum wrapper for pthread_exit() */
void rin_thread_exit(void *retval) __attribute__ ((__noreturn__));


/**
 * Create a new thread.
 *
 * Rinstrum wrapper for pthread_create().
 * Permits checking of thread stack overflows when THREAD_CANARY_DEBUG is enabled
 */
bool rin_thread_create(pthread_t *thread, void *(*start_routine)(void *), void *arg, bool joinable);

#endif /* RINTHREAD_H_ */
