#ifndef RPRINTF_DOT_H
#define RPRINTF_DOT_H 1

#include <stdarg.h>


/*
 * internal_printf -
 *
 * Ian's implementation of xprintf for R500 and other embedded platforms.
 *
 * Supports all integer/string formatting, no float, and no justify
 *
 * Wrapper this to create printf/sprintf/fprintf, etc
 *
 * outputfn is a function called internally to output a character. It is passed with a void pointer
 * to allow things like output device/output string to be passed in via data param
 */
int internal_printf(int (*outputfn)(void *data, unsigned char ch), void *data, const char *format, va_list args);

#endif
