#ifndef RSTDIO_DOT_H
#define RSTDIO_DOT_H 1

#include <stddef.h>
#include <stdarg.h>
#include <rinhw/rio.h>


/*
 * rvsprintf -
 *
 * Rinstrum version of variable argument string printf. 
 * Uses internal_printf for doing the work
 */
int rvsprintf(char *buffer, const char *format, va_list arglist);


/*
 * rsprintf -
 *
 * Rinstrum version of string printf. Uses internal_printf for doing the work
 */
int rsprintf(char *buffer, const char *format, ...);


/*
 * rvfprintf -
 *
 * Rinstrum version of variable argument file printf. Actually takes
 * out the whole fxxx (eg fwrite) function layer of normal C, and just 
 * calls write functions directly, due to code/ram constraints
 *
 * Uses internal_printf for doing the work
 */
int rvfprintf(struct t_io_dev *stream, const char *format, va_list arglist);


/*
 * rfprintf -
 *
 * Rinstrum version of file printf. Actually takes
 * out the whole fxxx (eg fwrite) function layer of normal C, and just 
 * calls write functions directly, due to code/ram constraints
 *
 * Uses internal_printf for doing the work
 */
int rfprintf(struct t_io_dev *stream, const char *format, ...);


#endif /* #ifndef RSTDIO_DOT_H */
