#ifndef RTC_DOT_H
#define RTC_DOT_H 1

#include <rinhw/rio.h>


/**
 * Date and time struct that can be rread or rwritten to the rtc device
 *
 * Note that date is day of month (1..31), and day is day of week (1..7)
 */
typedef struct
{
    unsigned char second;           /*!< Seconds 0..59 */
    unsigned char minute;           /*!< Minutes 0..59 */
    unsigned char hour;             /*!< Hours 0..23 */
    unsigned char day;              /*!< Day of week 1..7 */
    unsigned char date;             /*!< Day of month 1..31 */
    unsigned char month;            /*!< Month 1..12 */
    unsigned short year;            /*!< Year 2000+ */
} t_datetime;


#endif /* #ifndef RTC_DOT_H */
