#ifndef SHUTDOWN_DOT_H
#define SHUTDOWN_DOT_H 1


/*
 * This is the struct that contains all the info to install a shutdown function
 * You need to declare this in your code, setup the fn, then call
 * ShutdownAddFunction with the struct as a parameter
 */
struct t_shutdown_fn
{
    void (*fn)(void);
    struct t_shutdown_fn *next;
};


/*
 * ShutdownAddFunction -
 *
 * Add a new shutdown function to call to the list of functions
 * Parameter new_shutdown_fn must have the function filled out
 */
void ShutdownAddFunction(struct t_shutdown_fn *new_shutdown_fn);


#endif
