/*
 * sio_local_established_socket.c -
 *
 * This type of rin serial device takes an established socket
 * file descriptor and simply communicates over. Unlike
 * sio_local_socket, it does not deal with the listen socket
 * and accepting a new connection. You should implement that
 * part in your application
 */
#ifndef SIO_LOCAL_ESTABLISHED_SOCKET_H_
#define SIO_LOCAL_ESTABLISHED_SOCKET_H_

#include <rinhw/rio.h>


/**
 * Create a rin serial device for an established socket
 *
 * This type of rin serial device takes an established socket
 * file descriptor and simply communicates over. Unlike
 * sio_local_socket, it does not deal with the listen socket
 * and accepting a new connection. You should implement that
 * part in your application
 *
 * @param io_dev is the un-initialised rin io device structure
 * @param sockfd is the established socket file descriptor to communicate over
 */
int rio_create_device_sio_established_localskt(struct t_io_dev *io_dev, int sockfd);


#endif /* SIO_LOCAL_ESTABLISHED_SOCKET_H_ */
