/*
 * sio_local_printer.h
 *
 *  We deal with Linux line printers (/dev/lpX)
 *  as if they are a serial port.
 *
 *  Paper out is reported by our serial CTS functionality
 */

#ifndef SIO_LOCAL_PRINTER_H_
#define SIO_LOCAL_PRINTER_H_

#include <rinhw/rio.h>


/**
 * Create a serial port connected to local line printer hardware.
 *
 * @param io_dev is an uninitialised io_dev structure to be fill out as a serial port
 * @param port_name is the line printer device name (eg /dev/lp0)
 */
int rio_create_device_sio_localprinter(struct t_io_dev *io_dev, const char *port_name);


#endif /* SIO_LOCAL_PRINTER_H_ */
