/*
 * timemath.h
 *
 *  Created on: 03/03/2011
 *      Author: ian
 */

#ifndef TIMEMATH_H_
#define TIMEMATH_H_

#include <stdint.h>
#include <time.h>
#include <sys/time.h>
#include <semaphore.h>
#include <rinhw/stdrinstrum.h>


bool bGetCurrentTimeAsTimeSpec( struct timespec *pts );


void OSTicksToTimespec( struct timespec *pts, uint16_t ticks );


void OSTicksToTimeval( struct timeval *ptv, uint16_t ticks );


void OSTimespecToTicks( uint32_t *pticks, const struct timespec *pts );


void AddTimespec( struct timespec *pts1, const struct timespec *pts2 );


void SubTimespec( struct timespec *pts1, const struct timespec *pts2 );


int sem_timedwait_ticks(sem_t *sem, uint16_t timeout);


#endif /* TIMEMATH_H_ */
