/*
 * we21hw.h
 *
 *  Created on: 24/05/2010
 *      Author: ian
 */

#ifndef WE21HW_H_
#define WE21HW_H_

#include <rinhw/stdrinstrum.h>


/** De-select all rinblock i2c slots */
#define IIC_SLOT_DESELECT (-1)


/** Initialise access to the WE2111 hardware, via device node at devicename */
int rio_init_we21hw(const char *devicename);


/** Clean up after we21 hardware */
int rio_destroy_we21hw(void);


/**
 * we21hw_set_rs422_termination -
 *
 * Call the Linux IOCTL to control the RS422 terminations
 * 0 = disable, 1 = enable
 */
int we21hw_set_rs422_termination(void *dummy, int enable);


#if 0
/**
 *
 * As of WE21-103-120 RTS line controls transmit enable
 *
 * we21hw_set_rs422_transmitenable -
 *
 * Call the Linux IOCTL to control the RS422 transmit enable
 * 0 = disable, 1 = enable
 */
int we21hw_set_rs422_transmitenable(void *dummy, int enable);
#endif


/**
 * we21hw_select_rs232_not_rs422 -
 *
 * Call the Linux IOCTL to control the RS232/RS422 selection
 * 0 = RS422, 1 = RS232
 */
int we21hw_select_rs232_not_rs422(void *dummy, int select);


/**
 * we21hw_set_slot_select -
 *
 * Call the Linux IOCTL to set the slot select for a rinblock
 * -1 will clear all
 */
int we21hw_set_slot_select(void *dummy, int slot);


/** Wait for ADC data or timeout (in uCOS ticks) */
int we21hw_adc_wait_data(int32u timeout);


#endif /* WE21HW_H_ */
