#include <string.h>
#include <stdio.h>
#include <stdarg.h>
#include <syslog.h>
#include <rinhw/ucos_ii.h>
#include <rinhw/rprintf.h>
#include <rinhw/rio.h>
#include <rinhw/sio.h>

#include <rinhw/debug.h>


/** Setup the debugging device (must be open already) */
void InitDebug(struct t_io_dev *new_dev)
{
  /* Nothing to do if we are outputting debug to the console */
}


/** Hardware library debug printf function pointer */
static t_rinhw_debug_printf_fn rinhw_debug_printf_fn = NULL;


/** Set the debug printf function for the rinblock library */
void rinhw_set_debug_printf_fn(t_rinhw_debug_printf_fn fn)
{
  rinhw_debug_printf_fn = fn;
}


/** Hardware library debug printf function */
void rinhw_debug_printf(const char *format, ...)
{
  va_list args;

  if (NULL != rinhw_debug_printf_fn)
  {
    va_start(args, format);
    rinhw_debug_printf_fn(LOG_ERR, format, args);
    va_end(args);
  }
}


/** Hardware library error printf function - only use when stuff has gone badly wrong */
void rinhw_error_printf(const char *format, ...)
{
  va_list args;

  if (NULL != rinhw_debug_printf_fn)
  {
    va_start(args, format);
    rinhw_debug_printf_fn(LOG_ERR, format, args);
    va_end(args);
  }
}
