#include <stdio.h>
#include <rinhw/rprintf.h>

#include <rinhw/rstdio.h>


/*
 * rvsprintf -
 *
 * Rinstrum version of variable argument string printf.
 * Uses internal_printf for doing the work
 */
int rvsprintf(char *buffer, const char *format, va_list arglist)
{
    int length;

    length = vsprintf( buffer, format, arglist );
    return length;
}


/*
 * rsprintf -
 *
 * Rinstrum version of string printf. Uses internal_printf for doing the work
 */
int rsprintf(char *buffer, const char *format, ...)
{
    va_list args;
    int length;

    va_start(args, format);
    length = rvsprintf(buffer, format, args);

    va_end(args);
    return length;
}
