/*
 * sio_helper.h
 *
 *  Created on: Sep 5, 2014
 *      Author: ian
 */
#ifndef SIO_HELPER_H_
#define SIO_HELPER_H_

#include <stdbool.h>
#include <stddef.h>


/** Close the socket */
void sio_helper_close(int *sockfd);


/** Set blocking on a socket */
int sio_helper_setblocking(int sockfd, bool blocking);


/** Set a timeout on a socket. 0 for indefinite timeout */
int sio_helper_settimeout(int sockfd, bool send_not_recv, unsigned short timeoutticks);


/**
 * Function to receive len bytes (recv doesn't guarantee to return len bytes, unless used
 * with MSG_WAITALL which isn't defined on Windows < Windows server 2003)
 */
int sio_helper_read_all(int sockfd, void *buf, size_t len);


/** Function to send len bytes (send doesn't guarantee to send len bytes) */
int sio_helper_write_all(int sockfd, const void *buf, size_t len);


/** Get the buffer size of a socket */
int sio_helper_getbuffersize(int sockfd, bool send_not_recv);


/** Return the number of bytes available in either the receive or transmit buffers for a socket */
int sio_helper_getbufferlevel(int sockfd, bool send_not_recv);


#endif /* SIO_HELPER_H_ */
