/*
 * winsocket.c
 *
 *  Created on: 23/09/2009
 *      Author: IanB
 */
#include <winsock.h>
#include <rinhw/debug.h>

#include "winsocket.h"


/** Initialise windows sockets interface ready for use */
void WindowsSocketsInit(void *data)
{
  WSADATA wsaData;
  WORD wVersionRequested;

#if HW_DEBUG(REMOTE_IO_DEBUG, HW_DEBUG_BASIC)
    DEBUG_PRINTF("WindowsSocketsInit() called\n");
#endif

  /* Start up windows sockets using version 2.2 */
  wVersionRequested = MAKEWORD(2, 2);
  if ( 0 != WSAStartup( wVersionRequested, &wsaData ) )
  {
#if HW_DEBUG(REMOTE_IO_DEBUG, HW_DEBUG_BASIC)
    DEBUG_PRINTF("WindowsSocketsInit: WSAStartup() failed\n");
#endif
    return;
  }
#if HW_DEBUG(REMOTE_IO_DEBUG, HW_DEBUG_BASIC)
  else
  {
    DEBUG_PRINTF("WindowsSocketsInit: Actual loaded version was: %d.%d\n",
                 HIBYTE(wsaData.wVersion), LOBYTE(wsaData.wVersion));
  }
#endif

#if HW_DEBUG(REMOTE_IO_DEBUG, HW_DEBUG_BASIC)
  DEBUG_PRINTF("WindowsSocketsInit() finished\n");
#endif
}


/** Shut down windows sockets */
void WindowsSocketsDestroy(void)
{
  WSACleanup();
}
