/**
 * we21-hw_access.h
 *
 * IOCTLs for access to WE2111 miscellaneous hardware
 */
#ifndef WE21_HW_ACCESS_H_
#define WE21_HW_ACCESS_H_

#include <linux/ioctl.h>
#include <linux/major.h>


/** It's a misc device */
#define WE21_HW_MAJOR_NUM MISC_MAJOR


/** The name of the device file */
#define WE21_HW_MISC_DEVICE_NAME "we21hw"


/** The name of the kernel driver */
#define WE21_HW_DRVNAME "we21_hw_access"


/** Control the RS422 terminations (0 = off, 1 = on) */
#define IOCTL_WE21HW_RS422_TERM _IOR(WE21_HW_MAJOR_NUM, 0, int)

/* Control the RS422 transmit enable (0 = off, 1 = transmitting). This is now done with the RTS control line of the UART. */
/* #define IOCTL_WE21HW_RS422_TXEN _IOR(WE21_HW_MAJOR_NUM, 1, int) */

/** Select between RS232 and RS422 transmitter (0 = RS422, 1 = RS2332) */
#define IOCTL_WE21HW_SELECT_RS232_NOT_RS422 _IOR(WE21_HW_MAJOR_NUM, 2, int)

/** Select the I2C slot (used to set initial address) */
#define IOCTL_WE21HW_I2C_SLOT_SELECT _IOR(WE21_HW_MAJOR_NUM, 3, int)
#define I2C_SLOT_CLEAR -1
#define I2C_SLOT0_DISPLAY 0
#define I2C_SLOT1_SENSING 1
#define I2C_SLOT2_MODULE0 2
#define I2C_SLOT3_MODULE1 3
#define I2C_SLOT4_MODULE2 4

/** Wait for an ADC reading, parameter = timeout in msecs */
#define IOCTL_WE21HW_ADC_WAIT_DATA _IOR(WE21_HW_MAJOR_NUM, 4, int)


#endif /* #ifndef WE21_HW_ACCESS_H_ */
