#include <rinhw/rio.h>
#include <rinhw/rstdio.h>
#include <rinhw/ucos_ii.h>
#include <rinhw/adc_up.h>

#include "adctest.h"


void TestuPAdc(struct t_io_dev *dev, struct t_io_dev *adcdev)
{
  unsigned char ch;
  unsigned short adc_results[4];

  rfprintf(dev, "uP Internal ADC Test\r\n");

  if (NULL != adcdev)
  {
    ropen(adcdev, 0);

    while (reof(dev))
    {
      rlseek(adcdev, 0L, SEEK_SET);
      rread(adcdev, &adc_results[0], sizeof(adc_results), 0);
      rfprintf(dev, "ADC readings: %06d %06d %06d %06d\r", adc_results[0], adc_results[1], adc_results[2], adc_results[3]);
      OSTimeDly(OS_TICKS_PER_SEC / 10);
    }
    rread(dev, &ch, 1, 0);
    rclose(adcdev);
  }
}
