#include <rinhw/ucos_ii.h>
#include <rinhw/rio.h>
#include <rinhw/buzzer.h>
#include <rinhw/rstdio.h>

#include "buztest.h"

static const tBuzzer beep_seq[6] =
{
    { OS_TICKS_PER_SEC / 10, 2000 },
    { OS_TICKS_PER_SEC / 20, 0 },
    { OS_TICKS_PER_SEC / 10, 2000 },
    { OS_TICKS_PER_SEC / 20, 0 },
    { OS_TICKS_PER_SEC / 10, 2000 },
    { OS_TICKS_PER_SEC / 20, 0 },
};



static void do_beep(struct t_io_dev *dev, unsigned char times)
{
    rwrite(dev, (void *) &beep_seq[0], (unsigned short) (sizeof(tBuzzer) * 2 * times), 0);
}


void beep(struct t_io_dev *dev)
{
    do_beep(dev, 1);
}


void beep_twice(struct t_io_dev *dev)
{
    do_beep(dev, 2);
}


void beep_thrice(struct t_io_dev *dev)
{
    do_beep(dev, 3);
}


void TestBuzzer(struct t_io_dev *dev, struct t_io_dev *buzdev)
{
    unsigned char ch;
    
    rfprintf(dev, "Buzzer Test\r\nOpening buzzer (BUZ0)\r\n");
    if (ropen(buzdev, 0) < 0)
    {
        rfprintf(dev, "Open failed\r\n");
        return;
    }

    rfprintf(dev, "Press a key to beep\r\n");
    rread(dev, &ch, 1, 0);
    beep(buzdev);

    rfprintf(dev, "Press a key to beep twice\r\n");
    rread(dev, &ch, 1, 0);
    beep_twice(buzdev);

    rfprintf(dev, "Press a key to beep thrice\r\n");
    rread(dev, &ch, 1, 0);
    beep_thrice(buzdev);

    rfprintf(dev, "Closing buzzer\r\n");
    rclose(buzdev);
}
