#include <rinhw/rio.h>
#include <rinhw/rstdio.h>
#include <rinhw/ucos_ii.h>
#include <rinhw/sio.h>

#include "irtest.h"


void TestIRHead(struct t_io_dev *dev, struct t_io_dev *dummy)
{
    unsigned char ch = 0;
    unsigned short rx_size, tx_size, rx_lvl, tx_lvl;
    t_ioctl_siocfg siocfg;

    rfprintf(dev, "IR Head Test on channel 0.\nSwitching to 9600 baud\n");

    rfprintf(dev, "Address of siocfg = %p\n", &siocfg);

    rioctl(dev, IOCTL_SER_GET_RX_BUF_LEVEL, &rx_lvl);
    rioctl(dev, IOCTL_SER_GET_TX_BUF_LEVEL, &tx_lvl);
    rioctl(dev, IOCTL_SER_GET_RX_BUF_SIZE, &rx_size);
    rioctl(dev, IOCTL_SER_GET_TX_BUF_SIZE, &tx_size);
    rfprintf(dev, "rx_size = %d, tx_size = %d, rx_lvl = %d, tx_lvl = %d\n", rx_size, tx_size, rx_lvl, tx_lvl);

    rioctl(dev, IOCTL_SER_GET_CONFIG, &siocfg);
    siocfg.baud = 9600UL;
#if 0
    siocfg.data_bits = 8;
    siocfg.parity_bits = 0;
    siocfg.stop_bits = 1;
    siocfg.use_cts = 0;
    siocfg.use_terminations = 0;
#endif
    rioctl(dev, IOCTL_SER_SET_CONFIG, &siocfg);

    OSTimeDly(OS_TICKS_PER_SEC);
    rfprintf(dev, "Now at 9600 baud\n");
//#if 0
    while (ch != 0x1B)
    {
        if (rread(dev, &ch, 1, OS_TICKS_PER_SEC / 2) > 0)
            rwrite(dev, &ch, 1, 0);
        rfprintf(dev, "This is some test data\n");
    }
//#endif

    siocfg.baud = 57600UL;
    rioctl(dev, IOCTL_SER_SET_CONFIG, &siocfg);
}
