/*
 * remotetest.c
 *
 *  Created on: 24/08/2009
 *      Author: ian
 */
#include <rinhw/rio.h>
#include <rinhw/rstdio.h>
#include <rinhw/ucos_ii.h>
#include <rinhw/adc_ads1216.h>
#include <rinhw/adc_up.h>
#include <rinhw/stdrinstrum.h>

#include "remotetest.h"


#if 0 /* Was R400 */

#define TASK_REMOTE_STK_SIZE 200
OS_STK RemoteTaskStk[TASK_REMOTE_STK_SIZE];


static void vTask1( void *data )
{
  struct t_io_dev *dev = (struct t_io_dev *) data;
  int32s i32Data;

  while ( 1 )
  {
    rfprintf( dev, "Task 1 ropen\r\n" );
    if ( ropen( &dev_adc24bit, 0 ) < 0 )
    {
      rfprintf( dev, "Task 1 ropen fail\r\n" );
      continue;
    }

    rfprintf( dev, "Task 1 rread: " );
    if ( rread( &dev_adc24bit, &i32Data, sizeof( i32Data ), 0 ) != sizeof( i32Data ) )
    {
      rfprintf( dev, "fail\r\n" );
    }
    else
    {
      rfprintf( dev, "data %ld\r\n", i32Data );
    }

    rfprintf( dev, "Task 1 rclose\r\n" );
    if ( rclose( &dev_adc24bit ) < 0 )
    {
      rfprintf( dev, "Task 1 rclose fail\r\n" );
    }
  }
}


static void vTask2( void *data )
{
  struct t_io_dev *dev = (struct t_io_dev *) data;
  int16u devdata[ NUM_ADC_CHANNELS ];

  while ( 1 )
  {
    rfprintf( dev, "Task 2 ropen\r\n" );
    if ( ropen( &dev_adc, 0 ) < 0 )
    {
      rfprintf( dev, "Task 2 ropen fail\r\n" );
      continue;
    }

    rfprintf( dev, "Task 2 rread\r\n" );
    if ( rread( &dev_adc, &devdata, sizeof( devdata ), 0 ) != sizeof( devdata ) )
    {
      rfprintf( dev, "Task 2 rread fail\r\n" );
    }

    rfprintf( dev, "Task 2 rclose\r\n" );
    if ( rclose( &dev_adc ) < 0 )
    {
      rfprintf( dev, "Task 2 rclose fail\r\n" );
    }
  }
}
#endif

/** Test concurrent access of remote devices */
void TestRemote(struct t_io_dev *dev, struct t_io_dev *dummy)
{
#if 0 /* Was R400 */
  OSTaskCreate( vTask1, (void *) dev, &RemoteTaskStk[TASK_REMOTE_STK_SIZE - 1], 8);
  vTask2( (void *) dev );
#else
  rfprintf( dev, "Test not implemented\r\n" );
#endif
}
