/*
 * unittests.c
 *
 *  Created on: Jun 9, 2015
 *      Author: ian
 */
#include <stdio.h>
#include <cutest/CuTest.h>
#include "byteq_tests.h"
#include "os_time_tests.h"
#include "rin_thread_test.h"


int main(int argc, char *argv[])
{
  int result;

  CuString *output = CuStringNew();
  CuSuite *suite = CuSuiteNew();

  /* Add tests */
  CuSuiteConsume(suite, CuGetSuite_byteq());
  CuSuiteConsume(suite, CuGetSuite_os_time());
  CuSuiteConsume(suite, CuGetSuite_rin_thread());

  /* Run all tests */
  CuSuiteRun(suite);
  CuSuiteSummary(suite, output);
  CuSuiteDetails(suite, output);

  /* Print results */
  printf("%s\n", output->buffer);
  result = (suite->failCount > 0) ? 1 : 0;

  /* Clean up */
  CuSuiteDelete(suite);
  suite = NULL;
  CuStringDelete(output);
  output = NULL;

  /* Return result */
  return result;
}
