/*
 * driverconfig.h
 *
 *  Created on: 19/09/2009
 *      Author: ian
 */

#ifndef DRIVERCONFIG_H_
#define DRIVERCONFIG_H_

#include "stdrinstrum.h"


#define DRIVER_NAME_STR(x) # x


bool bHwLibXMLConfig_GetRemoteIoSerialPort( char *pszSerialPort, int nMaxLength );


bool bHwLibXMLConfig_GetRemoteIoSocket( char *pszServer, int nMaxLength, int *pnPort );


bool bHwLibXMLConfig_GetRemoteIoEnabled( void );


void vHwLibXMLConfig_GetWe21HardwareDevice( char *pszDevice, int nMaxLength );


bool bHwLibXMLConfig_GetDriverIsRemote( const char *pszDriverName );


bool bHwLibXMLConfig_GetDriverSettingString( const char *pszDriverName, const char *pszSetting, char *pszValue, int nMaxLength );


bool bHwLibXMLConfig_GetDriverSettingInteger( const char *pszDriverName, const char *pszSetting, int *pnValue );


enum eXMLConfigSerialDriverLocalEmulation
{
  leSerial,
  leSocket,
  leFile
};


bool bHwLibXMLConfig_GetSerialDriverLocalEmulation( const char *pszDriverName, enum eXMLConfigSerialDriverLocalEmulation *pLocalEmulation,
                                                    char *pszSetting, int nMaxLength );


/** Initialise the XML configuration, pData should point to a pointer to a string containing the configuration file name (const char **filename) */
void vHwLibXMLConfig_Init( void *pData );


void vHwLibXMLConfig_Destroy( void );


#endif /* DRIVERCONFIG_H_ */
