/*
 * r400_tick.h
 *
 *  Created on: May 20, 2013
 *      Author: ian
 */

#ifndef R400_TICK_H_
#define R400_TICK_H_

#include "r400_config.h"
#include "tick.h"


#if INCLUDE_TICK_FUNCTION


/*
 * TickAddFunction -
 *
 * Add a new function to call to the list of functions
 * Parameter new_tick_fn must have preset and function filled out
 */
void TickAddFunction(struct t_tick_fn *new_tick_fn);


/*
 * TickChangePreset -
 *
 * Change the preset time of the tick function. Count is reset when this is called,
 * so the preset inteval will expire before the next function call.
 */
void TickChangePreset(struct t_tick_fn *new_tick_fn, unsigned short preset);


#endif /* #if INCLUDE_TICK_FUNCTION */


#endif /* R400_TICK_H_ */
