/*
 * cmdline.c
 *
 *  Created on: 28/05/2010
 *      Author: ian
 */
#include <stdio.h>
#include <getopt.h>
#include "config.h"

#include "cmdline.h"


/** Pointer to string containing hardware configuration file name */
const char *hwlib_config_file = HW_LIB_CONFIG_FILE;


/** Print out the command line options */
static void print_commandlineopts(const char *program_name)
{
  fprintf(stderr, "Usage: %s [-options]\n", program_name);
  fprintf(stderr, "  -w <file>  --hwcfg <file>    use hardware configuration from <file>, "
                  "                               default is '" HW_LIB_CONFIG_FILE "'\n"
                  "  -h         --help            print help\n"
         );
}


/** Parse the command line options */
int hwlib_parse_commandline(int argc, char *argv[])
{
  int c;
  int result = 0;
  static const char opts[] = "hw:";
  static const struct option lopts[] =
  {
    { "hwcfg",         1, 0, 'w' },
    { "help",          0, 0, 'h' },
    { NULL, 0, 0, 0 },
  };

  while (1)
  {
    c = getopt_long(argc, argv, opts, lopts, NULL);
    if (-1 == c)
    {
      break;
    }

    switch (c)
    {
      case 'w':
        hwlib_config_file = optarg;
        break;
      case 'h':
      default:
        print_commandlineopts(argv[0]);
        result = -1;
        break;
    }
  }

#if 0
  if (optind >= argc)
  {
    fprintf(stderr, "no file specified\n");
    return -1;
  }
  env_filename = argv[optind];
#endif
  return result;
}
