/***********************************************************************
MODULE:    	CRC
VERSION:   	0.01
CONTAINS:  	Cyclic redundancy checksum calculation
COPYRIGHT: 	Rinstrum Pty Ltd 2004
DATE: 		9 Mar 2004
NOTES:      Many thanks to David Chambers
***********************************************************************/

#ifndef _CRCH_
#define _CRCH_

#include <rinhw/stdrinstrum.h>


/*
 * NAME: CRC16_Calc
 *
 * PARAMETERS: int8u  *pucByte - a pointer to the data to be CRC'ed
 *             int16u uiSize - the number of bytes to calculate for
 *             int16u uiCRC - the initial value for CRC
 *
 * RETURNS:    int16u - the CRC value calculated
 *
 * NOTES:      returns the CRC value (16 bits) for a block of data
 */
int16u CRC16_Calc(int8u *pucByte, int16u uiSize, int16u uiCRC);

#endif /* _CRCH_ */


