/*
 * rb_ethernet.h
 *
 *  Created on: 13/02/2009
 *      Author: ianb
 */
#ifndef RB_ETHERNET_DOT_H
#define RB_ETHERNET_DOT_H 1

#include <rinblock/rinblock.h>


/** Configure the Ethernet module with IP address and associated configuration. */
unsigned char RinBlockEthernetSetConfiguration( struct t_rinblock *rinblock, const struct s_rb_eth_ipconfigure *ethcfg_ptr );


/** Read the IP address and associated configuration from the Ethernet module. */
unsigned char RinBlockEthernetGetConfiguration( struct t_rinblock *rinblock, struct s_rb_eth_ipconfigure *ethcfg_ptr );


/** Restart the Matchport module (but not the Atmel) */
unsigned char RinBlockEthernetRestart( struct t_rinblock *rb );


/** Force the Matchport module to Rinstrum defaults */
unsigned char RinBlockEthernetForceDefaults( struct t_rinblock *rb );


/** Disable the Matchport module watchdog */
extern unsigned char RinBlockEthernetDisableWatchdog( struct t_rinblock *rb, bool val );

#endif /* #ifndef RB_ETHERNET_DOT_H */
