#ifndef RB_STARTUP_DOT_H
#define RB_STARTUP_DOT_H 1

#include <rinblock/rinblock.h>


/*
 * RinBlockSetMode -
 *
 * Set the running mode for the rinblock rb.
 * Mode defined by the defines RB_MODE_xxxx
 */
unsigned char RinBlockSetMode(struct t_rinblock *rb, unsigned char mode);


/*
 * RinBlockGetMode -
 *
 * Find out the current mode of a rinblock.
 * Mode defined by the defines RB_MODE_xxxx
 */
unsigned char RinBlockGetMode(struct t_rinblock *rb, unsigned char *mode);


/*
 * RinBlockInit -
 *
 * Setup the IIC device, open the debugging device, if debugging
 * is enabled. Initialise the rin block structs.
 */
void RinBlockInit(struct t_io_dev *iicdev);


/*
 * RinBlockEnumerate -
 *
 * Assign an address to each rinblock on the bus
 * Must be called first after RinBlockInit()
 */
void RinBlockEnumerate(void);


/*
 * RinBlockStart -
 *
 * Start all programmed rin blocks on the bus running,
 * and find out what they are
 */
void RinBlockStart(void);


/*
 * RinBlockRestart -
 *
 * Restart a rinblock. Sends a reset command, followed by the startup sequence
 */
void RinBlockRestart(struct t_rinblock *rb);

#endif
