#ifndef RB_TILT_DOT_H
#define RB_TILT_DOT_H 1

#include <rinblock/rinblock.h>


/*
 * Common functions
 */

/** Perform a tilt zero calibration */
unsigned char RinBlockTiltZero(struct t_rinblock *rb);


/** Perform a tilt factory zero calibration */
unsigned char RinBlockTiltFactoryZero(struct t_rinblock *rb);


/** Read the configuration from the tilt module */
unsigned char RinBlockTiltReadConfig(struct t_rinblock *rb, struct s_rb_tilt_factors *tilt_factors);


/** Write the tilt configuration to a tilt module */
unsigned char RinBlockTiltWriteConfig(struct t_rinblock *rb, const struct s_rb_tilt_factors *tilt_factors);


/*
 * Basic tilt module functions supported on modules with RB_IFACE_VERS_TILT_ORIGINAL and above
 */


/** Basic read tilt data */
unsigned char RinBlockTiltReadTilt(struct t_rinblock *rb, struct s_rb_tilt_data *tilt_data);


/** Perform a tilt calibration */
unsigned char RinBlockTiltCalibrate(struct t_rinblock *rb, const struct s_rb_tilt_calibrate *tilt_calibrate);


/*
 * Improved tilt module functions supported on modules with RB_IFACE_VERS_TILT_IMPROVED and above
 */


/** Improved read tilt data */
unsigned char RinBlockTiltReadTiltImproved(struct t_rinblock *rb, struct s_rb_tilt_data_improved *tilt_data_improved);


/** Perform an improved tilt calibration */
unsigned char RinBlockTiltCalibrateImproved(struct t_rinblock *rb, const struct s_rb_tilt_calibrate_improved *tilt_calibrate_improved);


#endif /* #ifndef RB_TILT_DOT_H */
