#ifndef RB_WE21_KBD_DOT_H
#define RB_WE21_KBD_DOT_H 1

#include <rinhw/kbd.h>
#include <rinblock/rinblock.h>


/** Function to read the high keybits */
typedef unsigned long (*t_kbd_hw_readhikeybits)(void *hw_data);


/**
 * Create a rinblock keyboard device
 *
 * @param io_dev is an uninitialised io device
 * @param rbs is a pointer to an array of pointers to rinblocks with keyboards
 *            each of which will polled for keyboard data, and ORed together.
 *            The driver keeps it's only copy of the array.
 * @param num_rbs is the number of rinblocks in the array
 * @param dev_buzzer is a buzzer device to produce key beeps. Can be NULL.
 * @param kbd_hw_readhikeybits is a function pointer for reading the high 32 key bits. Can be NULL, in which case IOCTL_KBD_WRITE_HI_KEY_BITS can be used
 */
int RinBlockCreateWE21KbdDevice(struct t_io_dev *io_dev, struct t_rinblock *rbs[], int num_rbs, struct t_io_dev *dev_buzzer, t_kbd_hw_readhikeybits kbd_hw_readhikeybits);


#endif /* #ifndef RB_WE21_KBD_DOT_H */
