#ifndef RINBLOCK_DOT_H
#define RINBLOCK_DOT_H 1


#include <rinhw/rio.h>
#include <rinblock/rb_msg.h>


#define SlotToAddress(x) (unsigned char) ((x + 1) * 2)
#define AddressToSlot(x) (unsigned char) ((x - 2) / 2)


#define MAX_RINBLOCKS 4

#define MAX_DIO_PER_RINBLOCK 8


struct t_rb_msg_handling
{
    unsigned char no_reply : 1;

    OS_EVENT *busy_sem;
};


enum eRBDioHardware { dioNotPresent = 0, dioInput, dioOutput, dioInOut };


struct t_rinblock
{
    struct t_io_dev *iicdev;
    unsigned char iic_address, bus_slot;
    unsigned char present;
    unsigned char programmed;
    unsigned char running;

    /*
     * Tag
     */
    struct s_rb_general_tag tag;

    /*
     * Messaging
     */
    struct t_rb_msg_handling msg_handling;

    /*
     * DIO Hardware on the rinblock
     */
    const enum eRBDioHardware *RBDioHardware;

    unsigned long msg_cnt;
    unsigned long msg_err;
};


extern struct t_rinblock rinblocks[MAX_RINBLOCKS];

#endif
