/***************************************************************************************************
MODULE:    	STATUS
VERSION:   	0.01
CONTAINS:  	Status List for Rin-block elements
COPYRIGHT: 	Rinstrum Pty Ltd 2007
DATE: 		  20070806 AGL Initial version.

NOTES:      1. Requires the project specific include file "version.h"

            @  @  @@@@  @   @  @@@@  @@@         @@@   @@@@   @@    @@    @@   @@@   @@   @  @
            @  @  @     @   @  @     @  @        @  @  @     @  @  @  @  @  @   @   @  @  @  @
            @@ @  @     @   @  @     @  @        @  @  @     @  @  @     @      @   @     @@ @
            @ @@  @@@   @   @  @@@   @@@@        @@@@  @@@   @  @   @@    @@    @   @     @ @@
            @  @  @      @ @   @     @@          @@    @     @@@@     @     @   @   @ @@  @  @
            @  @  @      @ @   @     @ @         @ @   @     @  @  @  @  @  @   @   @  @  @  @
            @  @  @@@@    @    @@@@  @  @        @  @  @@@@  @  @   @@    @@   @@@   @@   @  @  @  @  @  @

            2.  O N C E   A   P R O D U C T   G O E S   T O   R E L E A S E ,
                * N E V E R *   D E L E T E   O R   R E A S S I G N   S T A T U S E S
                F O R   O L D   P R O J E C T S !   STATUSES MUST REMAIN FOR ALL RELEASES.

            3.  Do not use a #ifndef 'fence' in this file: This file can legitimately be multiply
                #included.

            4.  This file should only be included from status.h or in status.c, never directly.

***************************************************************************************************/
#ifndef STATUS_DOT_H
#  error Include status.h instead of this file.
#endif

#define STATUS_STRING_UNKNOWN_ERROR           "Unknown error"

/*****************************************************************************/
/* Add generic statuses here.                  123456789.123456789. */
ST_NEW (STATUS_OK                   ,    0,   "OK"                )
ST_NEXT(STATUS_DATA_MEM_CRC         ,/* +1*/  "Data mem error"    )
ST_NEXT(STATUS_PROG_MEM_CRC         ,/* +2*/  "Prog mem error"    )
ST_NEXT(STATUS_BUSY                 ,/* +3*/  "Device busy"       )
ST_NEXT(STATUS_TIMED_OUT            ,/* +4*/  "Timed out"         )
ST_NEXT(STATUS_UNINITIALISED        ,/* +5*/  "Not ready"         )
ST_NEXT(STATUS_INVALID_COMMAND      ,/* +6*/  "Invalid command"   )
ST_NEXT(STATUS_HARDWARE_NOT_FOUND   ,/* +7*/  "HW not found"      ) /* eg, no Flash found, etc */
ST_NEXT(STATUS_RETRIES_EXCEEDED     ,/* +8*/  "Retries exceeded"  )
ST_NEXT(STATUS_NO_RESPONSE          ,/* +9*/  "No response"       )
ST_NEXT(STATUS_CRC_ERROR            ,/*+10*/  "CRC error"         )
ST_NEXT(STATUS_INVALID_MSG_LEN      ,/*+11*/  "Msg length"        )

/*
 * Add device-specific statuses here. Remove the "5" from the device and multiply by 10,
 * e.g. 517 => 170, 506 => 60.
 */

/*
 * Data Storage Device (DSD) Module 506.
 */
#if defined( STATUS_GROUP ) || defined( WHOLE_STATUS_LIST )

#if STATUS_GROUP == 506 || WHOLE_STATUS_LIST
/*                                             123456789.123456789. */
ST_NEW (STATUS_DSD_DIR_WRITE_FAIL   ,   60,   "Dir write fail"    ) /* 0x3c */
ST_NEXT(STATUS_DSD_DIR_NOT_FOUND    ,/* +1*/  "unused"            ) /* 0x3d Depreciated: now returns STATUS_UNINITIALISED */
ST_NEXT(STATUS_DSD_DIR_CORRUPT      ,/* +2*/  "Dir corrupt"       ) /* 0x3e CRC failure or 'insane' markers. */
ST_NEXT(STATUS_DSD_DIR_VERSION      ,/* +3*/  "Dir old version"   ) /* 0x3f */
ST_NEXT(STATUS_DSD_DIR_MISMATCH     ,/* +4*/  "Dir mismatch"      ) /* 0x40 Different instrument or record length. */
ST_NEXT(STATUS_DSD_DIR_FULL         ,/* +5*/  "Dir full"          ) /* 0x41 */
ST_NEXT(STATUS_DSD_INDEX_FAILURE    ,/* +6*/  "Index fail"        ) /* 0x42 */
ST_NEXT(STATUS_DSD_REC_WRITE_FAIL   ,/* +7*/  "Rec write fail"    ) /* 0x43 */
ST_NEXT(STATUS_DSD_REC_ORDER        ,/* +8*/  "Rec not in order"  ) /* 0x44 */
ST_NEXT(STATUS_DSD_REC_NOT_FOUND    ,/* +9*/  "Rec not found"     ) /* 0x45 */
ST_NEXT(STATUS_DSD_REC_CORRUPT      ,/*+10*/  "Rec corrupt"       ) /* 0x46 */
ST_NEXT(STATUS_DSD_REC_EMPTY        ,/*+11*/  "Rec empty"         ) /* 0x47 */
#endif /* #if STATUS_GROUP == 506 || WHOLE_STATUS_LIST */

/*
 *  xxxxx (xxx) Module 5xx.
 */
#if STATUS_GROUP == 500 || WHOLE_STATUS_LIST
/* ST_NEW (STATUS_xxx                  ,   nn,   "xxx"               ) */
/* ST_NEXT(STATUS_xxxxx                ,*//* +1*//*  "xxxxx"             ) */
#endif /* STATUS_GROUP == 500 || WHOLE_STATUS_LIST */

#endif /* #if defined( STATUS_GROUP ) || defined( WHOLE_STATUS_LIST ) */


/* end of file */
