#ifndef _IIC_ACCESS_DOT_H
#define _IIC_ACCESS_DOT_H 1


/*
 * RinIICWrite -
 *
 * Write length bytes of the message to the rinblock rb, with a timeout.
 *
 * The sequence is: open rinblock iic device, set slot mask if rb not present,
 * write the data, clear mask if set, close the iic device, and return result
 */
int RinIICWrite(struct t_rinblock *rb, const struct s_rb_message *message, unsigned short length, unsigned short timeout);


/*
 * RinIICRead -
 *
 * Read length bytes from the rinblock rb into the message, with a timeout.
 *
 * The sequence is: open rinblock iic device, read the data,
 * close the iic device, and return result
 */
int RinIICRead(struct t_rinblock *rb, struct s_rb_message *message, unsigned short length, unsigned short timeout);


#endif
