/*
 * _rb_c500_lcd_common.h
 *
 *  Created on: 04/12/2014
 *      Author: ian
 */

#ifndef _RB_C500_LCD_COMMON_H_
#define _RB_C500_LCD_COMMON_H_

#include <stdbool.h>
#include <rinhw/lcd_generic.h>


/** Write data to the LCD on the rinblock */
int rb_c500_lcd_write_data(struct s_lcd_definition *lcd_definition);


/**
 * Write a character ch to digit position index on the LCD.
 *
 * cwm is the write mode - either set or or the data
 */
void rb_c500_lcd_put_char(struct s_lcd_definition *lcd_definition, unsigned char index, unsigned char ch, enum eCharWriteMode cwm);


/** Work out if the digit index has a decimal point */
bool rb_c500_lcd_does_digit_have_dp(struct s_lcd_definition *lcd_definition, unsigned char index);


/** Set the backlight (or intensity in the case of the C500) */
int rb_c500_lcd_setbacklight(struct s_lcd_definition *lcd_definition, int lvl_pct);


#endif /* _RB_C500_LCD_COMMON_H_ */
