/*
 * _rb_c500_lcdsegs.h
 *
 *  Created on: 04/12/2014
 *      Author: ianb
 */

#ifndef _RB_C500_LCDSEGS_H_
#define _RB_C500_LCDSEGS_H_

#include <rinhw/stdrinstrum.h>
#if defined(__AVR__)
  #include <avr/pgmspace.h>
  /** On the Atmel uP, put the table into program memory */
  #define LCDSEG_TABLE_MEMORY PROGMEM
#else /* #if defined(__AVR__) */
  /** On everything else nothing special */
  #define LCDSEG_TABLE_MEMORY
#endif /* #else -> #if defined(__AVR__) */


/*
 * The size of the character segment table (ASCII characters 0..127)
 */
#define NUM_SEG_TABLE 128


/*
 * The LCD segment table
 */
extern const int16u rb_c500_seg_table[NUM_SEG_TABLE] LCDSEG_TABLE_MEMORY;


#endif /* _RB_C500_LCDSEGS_H_ */
