/*
 * _rb_we21_lcdsegs.h
 *
 *  Created on: 15/07/2010
 *      Author: ianb
 */

#ifndef _RB_WE21_LCDSEGS_H_
#define _RB_WE21_LCDSEGS_H_

#if defined(__AVR__)
  #include <avr/pgmspace.h>
  /** On the Atmel uP, put the table into program memory */
  #define LCDSEG_TABLE_MEMORY PROGMEM
#else /* #if defined(__AVR__) */
  /** On everything else nothing special */
  #define LCDSEG_TABLE_MEMORY
#endif /* #else -> #if defined(__AVR__) */


/*
 * The size of the character segment table (ASCII characters 0..127)
 */
#define NUM_SEG_TABLE 128


/*
 * The LCD segment table
 */
extern const unsigned char rb_we21_seg_table[NUM_SEG_TABLE] LCDSEG_TABLE_MEMORY;


#endif /* _RB_WE21_LCDSEGS_H_ */
