#include <rinblock/rb_command.h>
#include <rinblock/rb_debug.h>

#include <rinblock/rb_address.h>


/** Get the IIC address of a rinblock */
unsigned char RinBlockGetAddress(struct t_rinblock *rb, unsigned char *address)
{
    RB_DECLARE_CMD_BUFFER( rb_msg, struct s_rb_general_address );
    unsigned char result;

#if RB_DEBUG(RB_STARTUP_DEBUG_LVL, RB_DEBUG_BASIC)
    RB_DEBUG_PRINTF(RB_DEBUG_DEV, "RinBlockGetAddress called\n");
#endif

    result = RinBlockExecuteCommand( rb, rb_msg,
                                     RB_GET_SIZE_CMD_HDR(),
                                     RB_GET_SIZE_COMMAND( struct s_rb_general_address ),
                                     RB_TIMEOUT_INDEFINITE, RB_CMD_READ_ADDRESS );
    if (result)
    {
      *address = rb_msg->data.rb_response.params.rb_general_address.address;
#if RB_DEBUG(RB_STARTUP_DEBUG_LVL, RB_DEBUG_BASIC)
      RB_DEBUG_PRINTF(RB_DEBUG_DEV, "RB_CMD_READ_ADDRESS success\n");
#endif
    }
    return result;
}
