#include <rinhw/rio.h>
#include <rinhw/rstdio.h>
#include <rinblock/rb_debug.h>
#include <rinblock/rinblock.h>
#include <rinblock/rb_command.h>

#include <rinblock/rb_serialno.h>


/*
 * RinBlockSetTagShite -
 *
 * Set the serial number and hardware version number of the rinblock rb
 *
 * Returns 1 for success, 0 otherwise
 */
unsigned char RinBlockSetTagShite(struct t_rinblock *rb, unsigned long serial, unsigned short hw_version)
{
    RB_DECLARE_CMD_BUFFER( rb_msg, struct s_rb_general_tag_shite );

    /*
     * Setup command and data
     */
    rb_msg->data.rb_command.params.rb_general_tag_shite.serial_number = htonl( serial );
    rb_msg->data.rb_command.params.rb_general_tag_shite.hardware_version = htons( hw_version );

    /*
     * Execute command, handle error
     */
    return RinBlockExecuteCommand( rb, rb_msg,
                                   RB_GET_SIZE_COMMAND( struct s_rb_general_tag_shite ),
                                   RB_GET_SIZE_CMD_HDR(),
                                   RB_TIMEOUT_DEFAULT, RB_CMD_WRITE_TAG_SHITE );
}
