/***************************************************************************************************
MODULE:    	STATUSSTR
VERSION:   	0.01
CONTAINS:  	status for Rin-block elements
COPYRIGHT: 	Rinstrum Pty Ltd 2007
DATE: 		  6th Nov 2007
NOTES:      Only add this file to your project if you want printable strings for the status. Unlike
            the ATmegaNNN version, this file for the Renesas CPUs uses 'normal' Flash space (which
            is where literal strings are placed), which is declared as 'const'.

            To get the full list of strings, you need the build switches -DSTATUS_STRINGS=1 and
            -DWHOLE_STATUS_LIST=1 in your Makefile or project file, otherwise it defaults to the
            single string STATUS_STRING_UNKNOWN_ERROR.

                (The ATmegaNNN version of this file, see W:\M400\5xx\501\src, uses 'Program Space'
                (Flash-only) storage of strings because the ATmegas use a Harvard architecture with
                separate memories and buses for program and data. A consequence of this is that
                'normal' variables cannot be directly accessed if they are in the 'Program Space':
                instead special opcodes must be used to copy bytes from Flash to RAM:- even
                so-called 'const' variables must be copied to RAM.)

***************************************************************************************************/

#include <rinhw/debug.h>
#include <rinhw/stdrinstrum.h>
#include <rinblock/status.h>

char *StatusStr(STATUS_T status)
{
  char *str = STATUS_STRING_UNKNOWN_ERROR;

  #if STATUS_STRINGS!=0
    #undef   ST_NEW
    #undef   ST_NEXT
    #define  ST_NEW(VAR,VAL,DESC)   case VAR:  str = DESC; break;
    #define  ST_NEXT(VAR,DESC)      case VAR:  str = DESC; break;
    switch ( status )
    {
      #include <rinblock/statuslist.h>

      default:
        // 'str' si already set.
        break;
    }
  #endif

  return str;
}

// end of status_emb_str.c
