#ifndef DEVICES_DOT_H
#define DEVICES_DOT_H 1

#include <stdbool.h>
#include <rinhw/rio.h>


/** If cmdline_i2c_device is this, then we use libmpsse/libftdi/libusb */
#define LIBMPSSE_FTDI_DEVICE_NAME "ftdi"


extern struct t_io_dev dev_console;
extern struct t_io_dev dev_iic0;
extern struct t_io_dev dev_kbd;
extern struct t_io_dev dev_adc;
extern struct t_io_dev dev_buz;
extern struct t_io_dev dev_lcd;
extern struct t_io_dev dev_lcd_local_skt;


/** Start up the system */
bool init_test_app_devices(const char *remote_device, const char *i2c_device);


/** Shut down the system */
void destroy_test_app_devices(void);


#endif /* #ifndef DEVICES_DOT_H */
