#include <rinhw/gpio.h>
#include <rinhw/rio.h>
#include <rinhw/sio.h>
#include <rinhw/rstdio.h>
#include <rinblock/rb_dio.h>

#include "rb_dio_test.h"


struct t_io_dev *dio_debug_dev = NULL;


#if 0

static void dio_output_test(struct t_io_dev *debug_dev, struct t_io_dev *rb_dio_dev)
{
    unsigned char i;
    int res;

#if 0
    res = rioctl(rb_dio_dev, IOCTL_DIO_CONFIGURE, 0, &rinblocks[1], 0, ioOutput);
    rfprintf(debug_dev, "Configure iio.0->rb1.0 as output with result %d\n", res);
    res = rioctl(rb_dio_dev, IOCTL_DIO_CONFIGURE, 1, &rinblocks[1], 1, ioOutput);
    rfprintf(debug_dev, "Configure iio.1->rb1.1 as output with result %d\n", res);
    res = rioctl(rb_dio_dev, IOCTL_DIO_CONFIGURE, 2, &rinblocks[1], 2, ioOutput);
    rfprintf(debug_dev, "Configure iio.2->rb1.2 as output with result %d\n", res);
    res = rioctl(rb_dio_dev, IOCTL_DIO_CONFIGURE, 3, &rinblocks[1], 3, ioOutput);
    rfprintf(debug_dev, "Configure iio.3->rb1.3 as output with result %d\n", res);

    res = rioctl(rb_dio_dev, IOCTL_DIO_CONFIGURE, 4, &rinblocks[1], 4, ioOutput);
    rfprintf(debug_dev, "Configure iio.4->rb1.4 as output with result %d\n", res);
    res = rioctl(rb_dio_dev, IOCTL_DIO_CONFIGURE, 5, &rinblocks[1], 5, ioOutput);
    rfprintf(debug_dev, "Configure iio.5->rb1.5 as output with result %d\n", res);
    res = rioctl(rb_dio_dev, IOCTL_DIO_CONFIGURE, 6, &rinblocks[1], 6, ioOutput);
    rfprintf(debug_dev, "Configure iio.6->rb1.6 as output with result %d\n", res);
    res = rioctl(rb_dio_dev, IOCTL_DIO_CONFIGURE, 7, &rinblocks[1], 7, ioOutput);
    rfprintf(debug_dev, "Configure iio.7->rb1.7 as output with result %d\n", res);
#endif

    i = 0;
    rfprintf(debug_dev, "Cycling outputs, any key to quit\n");
//    while (rfilelength(debug_dev) == 0)
    while (1)
    {
        res = rwrite(rb_dio_dev, &i, 1, 0);
//        rfprintf(debug_dev, "Wrote char 0x%02x to dio device with result %d\n", i, res);
        if (res != 1)
            return;

        i++;
#if 0
        if (i >= 16)
            i = 0;
#endif
//        OSTimeDly(1);
    }
    rread(debug_dev, &i, 1, 0);
}


#if 0
static void dio_input_test(struct t_io_dev *debug_dev, struct t_io_dev *rb_dio_dev)
{
    unsigned char i;
    int res;

    res = rioctl(rb_dio_dev, IOCTL_DIO_CONFIGURE, 0, &rinblocks[1], 0, ioInput);
    rfprintf(debug_dev, "Configure iio.0->rb1.0 as input with result %d\n", res);
    res = rioctl(rb_dio_dev, IOCTL_DIO_CONFIGURE, 1, &rinblocks[1], 1, ioInput);
    rfprintf(debug_dev, "Configure iio.1->rb1.1 as input with result %d\n", res);
    res = rioctl(rb_dio_dev, IOCTL_DIO_CONFIGURE, 2, &rinblocks[1], 2, ioInput);
    rfprintf(debug_dev, "Configure iio.2->rb1.2 as input with result %d\n", res);
    res = rioctl(rb_dio_dev, IOCTL_DIO_CONFIGURE, 3, &rinblocks[1], 3, ioInput);
    rfprintf(debug_dev, "Configure iio.3->rb1.3 as input with result %d\n", res);

    res = rioctl(rb_dio_dev, IOCTL_DIO_CONFIGURE, 4, &rinblocks[1], 4, ioInput);
    rfprintf(debug_dev, "Configure iio.4->rb1.4 as input with result %d\n", res);
    res = rioctl(rb_dio_dev, IOCTL_DIO_CONFIGURE, 5, &rinblocks[1], 5, ioInput);
    rfprintf(debug_dev, "Configure iio.5->rb1.5 as input with result %d\n", res);
    res = rioctl(rb_dio_dev, IOCTL_DIO_CONFIGURE, 6, &rinblocks[1], 6, ioInput);
    rfprintf(debug_dev, "Configure iio.6->rb1.6 as input with result %d\n", res);
    res = rioctl(rb_dio_dev, IOCTL_DIO_CONFIGURE, 7, &rinblocks[1], 7, ioInput);
    rfprintf(debug_dev, "Configure iio.7->rb1.7 as input with result %d\n", res);

    while (rfilelength(debug_dev) == 0)
    {
        res = rread(rb_dio_dev, &i, 1, 0);
        rfprintf(debug_dev, "Read inputs %08b from dio device with result %d\n", i, res);
        OSTimeDly(10);
    }
    rread(debug_dev, &i, 1, 0);
}
#endif


static void dio_dump_inputs(struct t_io_dev *debug_dev, struct t_io_dev *rb_dio_dev)
{
    unsigned char ipt[MAX_INTERNAL_DIO_BYTES], i;
    int res;

    while (rfilelength(debug_dev) == 0)
    {
        res = rread(rb_dio_dev, &ipt, MAX_INTERNAL_DIO_BYTES, 0);
        rfprintf(debug_dev, "Read %d internal io from dio device, result %d\n", MAX_INTERNAL_DIO, res);
        for (i = 0; i < MAX_INTERNAL_DIO; i++)
        {
            rfprintf(debug_dev, "%c", (i & 0x07) + '0');
        }
        rfprintf(debug_dev, "\n");
        for (i = 0; i < MAX_INTERNAL_DIO_BYTES; i++)
        {
            rfprintf(debug_dev, "%08b", ipt[i]);
        }
        rfprintf(debug_dev, "\n");
        OSTimeDly(10);
    }
    rread(debug_dev, &i, 1, 0);
}
#endif


static unsigned char get_char(struct t_io_dev *debug_dev)
{
    unsigned char ch;

    rread(debug_dev, &ch, 1, 0);
    return ch;
}


static unsigned char get_1_digit_num(struct t_io_dev *debug_dev, unsigned char *num)
{
    unsigned char ch;

    ch = get_char(debug_dev);
    if ((ch < '0') || (ch > '9'))
        return 0;
    *num = (unsigned char) (ch - '0');
    return 1;
}

#if 0
static unsigned char get_2_digit_num(struct t_io_dev *debug_dev, unsigned char *num)
{
    unsigned char ch;

    if (!get_1_digit_num(debug_dev, &ch))
        return 0;

    ch *= 10;

    if (!get_1_digit_num(debug_dev, num))
        return 0;

    *num += ch;
    return 1;
}
#endif


static unsigned char get_n_digit_u_num(struct t_io_dev *debug_dev, unsigned long *num, unsigned char len)
{
    unsigned char ch;

    *num = 0UL;
    while (len-- > 0)
    {
        if (!get_1_digit_num(debug_dev, &ch))
            return 0;
        *num *= 10;
        *num += ch;
    }
    return 1;
}


/*
 * A config line looks like
 *
 * !2 5 I
 */
static unsigned char dio_load_config_line(struct t_io_dev *debug_dev)
{
    unsigned char ch, rb_num, rb_bit, debounce_time;
    unsigned long temp;
    enum eDIOType io_type;
    enum eDIOInversion io_invert;
    unsigned char res;

    /*
     * Look for a ! to start a line
     */
    do
    {
        ch = get_char(debug_dev);
        if (ch == '#')
            return 2;
    }
    while (ch != '!');

    /*
     * Read the rin block number
     */
    if (!get_1_digit_num(debug_dev, &rb_num))
        return 0;

    /*
     * Read a space
     */
    if (get_char(debug_dev) != ' ')
        return 0;

    /*
     * Read the io bit number
     */
    if (!get_1_digit_num(debug_dev, &rb_bit))
        return 0;

    /*
     * Read a space
     */
    if (get_char(debug_dev) != ' ')
        return 0;

    /*
     * Read the io type
     */
    ch = get_char(debug_dev);
    switch (ch)
    {
        case 'I':
            io_type = ioInput;
            break;
        case 'O':
            io_type = ioOutput;
            break;
        default:
            return 0;
    }

    /*
     * Read a space
     */
    if (get_char(debug_dev) != ' ')
        return 0;

    /*
     * Read the io inversion
     */
    ch = get_char(debug_dev);
    switch (ch)
    {
        case 'I':
            io_invert = ioInverted;
            break;
        case 'N':
            io_invert = ioNormal;
            break;
        default:
            return 0;
    }

    /*
     * Read a space
     */
    if (get_char(debug_dev) != ' ')
        return 0;

    /*
     * Get the debounce time
     */
    if (get_n_digit_u_num(debug_dev, &temp, 3) == 0)
    {
        return 0;
    }
    debounce_time = (unsigned char) temp;

    /*
     * Configure the io
     */
    res = RinBlockConfigureIO(&rinblocks[rb_num], rb_bit, io_type, io_invert, debounce_time);
    rfprintf(debug_dev, "Configure io rb%d.%d as type %c with result %d\n", rb_num, rb_bit, ch, res);
    return res;
}


void dio_load_config(struct t_io_dev *debug_dev)
{
    unsigned char res;

    rfprintf(debug_dev, "Load IO config. Send as:\n!r b t i d where \n");
    rfprintf(debug_dev, "! is start, r is the rinblock (0..3), b is the io bit on the rinblock (0..7), and t is the io type (IO),\n");
    rfprintf(debug_dev, "i is bit inversion (NI), d is the debounce time (000..255)\n");
    rfprintf(debug_dev, "# on the last line to end\n");

    do
    {
        res = dio_load_config_line(debug_dev);
        if (res == 0)
            rfprintf(debug_dev, "Load config failed while parsing input\n");
    } while (res != 2);
}

#if 0
static unsigned char write_rb_io_hw(struct t_rinblock *rb, unsigned char data)
{
    unsigned char buf[2];
//    struct t_rb_message *rb_msg = (struct t_rb_message *) &buf[0];

//    rb_msg->data.rb_command.cmd = RB_CMD_WRITE_OUT_LATCH;
//    rb_msg->data.rb_command.params.rb_dio_access.io_data = data;
    buf[0] = RB_CMD_WRITE_OUT_LATCH;
    buf[1] = data;
    if (!RinBlockExecuteCommand(rb, (struct t_rb_message *) buf, 2, 1, 0))
        return 0;
    if ((buf[0] & RB_RESP_ERROR_MASK) != 0)
        return 0;
    return 1;
}

static void dio_direct_drive_output_test(struct t_io_dev *debug_dev)
{
    unsigned char i;
    int res;

    i = 0;
    rfprintf(debug_dev, "DIO Direct Drive Output Test. Cycling outputs, any key to quit\n");
//    while (rfilelength(debug_dev) == 0)
    while (1)
    {
        if (!write_rb_io_hw(&rinblocks[0], i))
            return;
//        res = rwrite(rb_dio_dev, &i, 1, 0);
//        rfprintf(debug_dev, "Wrote char 0x%02x to dio device with result %d\n", i, res);
        i++;
    }
    rread(debug_dev, &i, 1, 0);
}
#endif


static void dio_set_outputs(union u_rb_output_write *rbs_odata, struct s_rb_dio_read *inputs)
{
    unsigned char results[MAX_RINBLOCKS];
    unsigned char i;

//    P_PC.DR.BIT.B0 = 1;
    for (i = 0; i < MAX_RINBLOCKS; i++)
    {
        results[i] = RinBlockWriteOutputs(&rinblocks[i], rbs_odata++);
    }
//    P_PC.DR.BIT.B0 = 0;
//    P_PC.DR.BIT.B0 = 1;
    for (i = 0; i < MAX_RINBLOCKS; i++)
    {
        if (results[i])
        {
            RinBlockReadInputs(&rinblocks[i], &inputs[i]);
        }
    }
//    P_PC.DR.BIT.B0 = 0;
}


static void dio_direct_drive_output_test(unsigned char silent)
{
    union u_rb_output_write rbs_odata[MAX_RINBLOCKS];
    struct s_rb_dio_read inputs[MAX_RINBLOCKS];
    unsigned char ro, rb, count, i, ch, holdoff = 0;

//    gpio_set_ddr(&P_PC.DDR, 0x01, doOR);

    rfprintf(dio_debug_dev, "DIO Direct Drive Output Test. Cycling outputs, +- to change holdoff, Q to quit\n");
    count = 0;
    while (1)
    {

        /*
         * Set all outputs on all cards to count (across 8 bits)
         */
        for (ro = 0; ro < 8; ro++)
        {
            for (rb = 0; rb < MAX_RINBLOCKS; rb++)
            {
                rbs_odata[rb].rb_dio_output_write.rb_output[ro].output_bits.level = (((count >> ro) & 0x01) != 0);
                rbs_odata[rb].rb_dio_output_write.rb_output[ro].output_bits.holdoff = holdoff;
            }
        }

        /*
         * Print debug
         */
        if (!silent)
            rfprintf(dio_debug_dev, "Write DIO with output value %d\n", count);

        /*
         * Drive outputs
         */
        dio_set_outputs(rbs_odata, inputs);

        /*
         * Print results
         */
        if (!silent)
        {
            for (i = 0; i < MAX_RINBLOCKS; i++)
            {
                rfprintf(dio_debug_dev, "Rinblock %d Input Data is %08b. Counts Ch0=%02d, Ch1=%02d\n", i,
                         inputs[i].io_data,
                         inputs[i].pulse_count.pulse_count_bits.pulse_count_1,
                         inputs[i].pulse_count.pulse_count_bits.pulse_count_2);
            }
        }
        count++;

        /*
         * Check for keystrokes
         */
        if (rfilelength(dio_debug_dev) > 0)
        {
            rread(dio_debug_dev, &ch, 1, 0);
            if (ch == '+')
            {
                holdoff++;
                if (holdoff > 127)
                    holdoff = 0;
                rfprintf(dio_debug_dev, "Holdoff = %d\n", holdoff);
            }
            else if (ch == '-')
            {
                holdoff--;
                if (holdoff > 127)
                    holdoff = 127;
                rfprintf(dio_debug_dev, "Holdoff = %d\n", holdoff);
            }
            else if (ch == 'Q')
            {
                break;
            }
        }

//        if (holdoff > 10)
        OSTimeDly(20);

    }
}


static void dio_set_output(unsigned char rb, union u_rb_output_write *rb_odata, struct s_rb_dio_read *inputs)
{
    unsigned char res;

//    P_PC.DR.BIT.B0 = 1;
    res = RinBlockWriteOutputs(&rinblocks[rb], rb_odata);
//    P_PC.DR.BIT.B0 = 0;
//    P_PC.DR.BIT.B0 = 1;
    if (res)
        RinBlockReadInputs(&rinblocks[rb], inputs);
//    P_PC.DR.BIT.B0 = 0;

}


static void dio_output_control(void)
{
    union u_rb_output_write rb_odata;
    struct s_rb_dio_read inputs;
    unsigned char ro, rb, rs;

//    gpio_set_ddr(&P_PC.DDR, 0x01, doOR);

    /*
     * All outputs off
     */
    for (ro = 0; ro < 8; ro++)
    {
        rb_odata.rb_dio_output_write.rb_output[ro].output_bits.level = 0;
        rb_odata.rb_dio_output_write.rb_output[ro].output_bits.holdoff = 0;
    }

    /*
     * Get rinblock
     */
    rfprintf(dio_debug_dev, "\nDIO Output Control Test.\nEnter a rinblock to play with (0..%d): ", MAX_RINBLOCKS - 1);
    if ((!get_1_digit_num(dio_debug_dev, &rb)) || (rb >= MAX_RINBLOCKS))
    {
        rfprintf(dio_debug_dev, "\nYou twit! That's not a valid rinblock.\n");
        return;
    }

    /*
     * Loopy
     */
    while (1)
    {

        /*
         * Set outputs, get inputs
         */
        dio_set_output(rb, &rb_odata, &inputs);
        rfprintf(dio_debug_dev, "\nOutputs written, input data is %08b (%02x)\n", inputs, inputs);

        /*
         * Get bit and state
         */
        rfprintf(dio_debug_dev, "Enter output bit to twiddle (0..%d): ", 8 - 1);
        if ((!get_1_digit_num(dio_debug_dev, &ro)) || (ro >= 8))
        {
            rfprintf(dio_debug_dev, "\nBad output bit\n");
            return;
        }
        rfprintf(dio_debug_dev, "\nEnter state (0..1): ");
        if ((!get_1_digit_num(dio_debug_dev, &rs)) || (rs >= 2))
        {
            rfprintf(dio_debug_dev, "\nBad state\n");
            return;
        }

        /*
         * Put output data into struct
         */
        rb_odata.rb_dio_output_write.rb_output[ro].output_bits.level = rs;
        rb_odata.rb_dio_output_write.rb_output[ro].output_bits.holdoff = 0;
    }
}


/*
 * dio_test -
 *
 */
void dio_test(struct t_io_dev *debug_dev)
{
    unsigned char ch = 0;

    dio_debug_dev = debug_dev;

    while (ch != 'Q')
    {
        rfprintf(debug_dev, "Rin Block DIO Test\n");
        rfprintf(debug_dev, "Commands:\nL - load io config\nD - Direct Drive Ouputs\nS - Silent Direct Drive Ouputs\nM - Manual Output Control\nQ - quit\n");
        rread(debug_dev, &ch, 1, 0);
        switch (ch)
        {
            case 'L':
                dio_load_config(debug_dev);
                break;
            case 'D':
                dio_direct_drive_output_test(0);
                break;
            case 'S':
                dio_direct_drive_output_test(1);
                break;
            case 'M':
                dio_output_control();
                break;
        }
    }
}
