/*
 * rb_ethernet_test.c
 *
 *  Created on: 13/02/2009
 *      Author: ianb
 */
#include <rinhw/rio.h>
#include <rinhw/rstdio.h>
#include <rinblock/rb_ethernet.h>

#include "rb_ethernet_test.h"


#if 0
static void configure_ethernet( struct t_io_dev *debug_dev, struct t_rinblock *rb )
{

}
#endif


static void print_ip_address( struct t_io_dev *debug_dev, unsigned long ip_address )
{
  unsigned char ui8IpA = (unsigned char) ( ( ip_address >> 24 ) & 0x000000FF );
  unsigned char ui8IpB = (unsigned char) ( ( ip_address >> 16 ) & 0x000000FF );
  unsigned char ui8IpC = (unsigned char) ( ( ip_address >> 8 ) & 0x000000FF );
  unsigned char ui8IpD = (unsigned char) ( ip_address & 0x000000FF );

  rfprintf( debug_dev, "%d.%d.%d.%d", ui8IpA, ui8IpB, ui8IpC, ui8IpD );
}


static void ethernet_dump_config( struct t_io_dev *debug_dev, struct t_rinblock *rb )
{
  struct s_rb_eth_ipconfigure ethcfg;

  if ( 0 != RinBlockEthernetGetConfiguration( rb, &ethcfg ) )
  {
    rfprintf( debug_dev,  "Ethernet configuration:\n" );
    rfprintf( debug_dev,  "  Use DHCP: %s\n", (ethcfg.bUseDHCP) ? "enabled" : "disabled" );
    rfprintf( debug_dev,  "  IP Address: " );
    print_ip_address( debug_dev, ethcfg.ui32IpAddress );
    rfprintf( debug_dev,  "\n  Subnet Mask: " );
    print_ip_address( debug_dev, ethcfg.ui32IpNetMask );
    rfprintf( debug_dev,  "\n  Default Gateway: " );
    print_ip_address( debug_dev, ethcfg.ui32IpGateway );
    rfprintf( debug_dev,  "\n  Primary DNS: " );
    print_ip_address( debug_dev, ethcfg.ui32IpDns1 );
    rfprintf( debug_dev,  "\n  Secondary DNS: " );
    print_ip_address( debug_dev, ethcfg.ui32IpDns2 );
    rfprintf( debug_dev,  "\n" );
  }
  else
  {
    rfprintf( debug_dev,  "Could not retrieve Ethernet configuration\n" );
  }
}


/*
 * ethernet_test -
 *
 * Test commands for the Ethernet module
 */
void ethernet_test(struct t_io_dev *debug_dev, struct t_rinblock *rb)
{
  unsigned char ch = 0;

  while (ch != 'q')
  {
    rfprintf(debug_dev,  "\nRin Block Ethernet Test:\n"
                         "  q - Quit\n"
                         "  r - Read current IP configuration\n"
                         "  w - Write IP configuration\n" );

    rread( debug_dev, &ch, 1, 0 );
    switch (ch)
    {
      case 'r':
        ethernet_dump_config( debug_dev, rb );
        break;
      default:
        break;
    }
  }
}
