#include <rinhw/rio.h>

#include "rb_getnum.h"


static unsigned char get_char(struct t_io_dev *debug_dev)
{
  unsigned char ch;

  rread(debug_dev, &ch, 1, 0);
  return ch;
}


unsigned char get_long(struct t_io_dev *debug_dev, signed long *num)
{
  unsigned char ch;
  int minus;

  *num = 0;
  minus = 0;
  do
  {
    ch = get_char(debug_dev);
    if (ch >= '0' && ch <= '9')
    {
      *num *= 10;
      *num += (unsigned char) (ch - '0');
      rwrite(debug_dev, &ch, 1, 0);
    }
    if (ch == '-')
    {
      minus = !minus;
      rwrite(debug_dev, &ch, 1, 0);
    }
  }
  while ('\r' != ch && '\n' != ch);

  /* Apply sign */
  if (minus)
  {
    *num = -*num;
  }

  /* Clear out CRLF */
  if (ch == '\r')
  {
    get_char(debug_dev);
  }

  return 1;
}
