/*
 * slipio.c
 *
 *  Created on: 23/10/2008
 *      Author: ianb
 */
#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <rinhw/rio.h>
#include <rinhw/sio.h>
#include <rinremote/slip.h>

#include <rinremote/slip_io.h>


static void slip_send_char_rio_dev(void *data, uint8_t ch)
{
  struct t_io_dev *iodev = data;

  if (NULL != iodev)
    rwrite(iodev, &ch, 1, 0);
}


static uint8_t slip_recv_char_rio_dev(void *data)
{
  struct t_io_dev *iodev = data;
  uint8_t ch = '\0';

  if (NULL != iodev)
    rread(iodev, &ch, 1, 0);
  return ch;
}


static void slip_destroy_rio_dev(void *data)
{
  struct t_io_dev *iodev = data;

  if (NULL != iodev)
    rclose(iodev);
}


/** Initialise slip using a rinstrum device */
int slip_init_rio_dev(struct s_slipio *slipio, struct t_io_dev *iodev)
{
  /* Open debug device if not already open */
  if (iodev->status & O_OPEN)
  {
    ropen(iodev, 0);
  }

  memset(slipio, 0, sizeof(struct s_slipio));
  slipio->data = iodev;
  slipio->slip_send_char = slip_send_char_rio_dev;
  slipio->slip_pre_send = NULL;
  slipio->slip_post_send = NULL;
  slipio->slip_recv_char = slip_recv_char_rio_dev;
  slipio->slip_destroy = slip_destroy_rio_dev;

  return RIO_SUCCESS;
}
