/*
 * remoteexec.h
 *
 *  Created on: 23/10/2008
 *      Author: ianb
 */
#ifndef REMOTEEXEC_H_
#define REMOTEEXEC_H_

#include <rinhw/stdrinstrum.h>
#include <rinremote/remote.h>


/**
 * Initialise remote execution.
 *
 * @param serial_port is the serial port to use, if NULL server/port is used instead
 * @param server is the server to connect to if serial_port is NULL
 * @param port is the TCP socket on server to if serial_port is NULL
 */
int vRemoteExecuteInit(const char *serial_port, const char *server, int port);


/** Shut down remote execution */
void vRemoteExecuteDestroy(void);


/** Execute a remote command */
bool bRemoteExecuteCommand(const struct s_rem_device_command *pCommand, int nCmdLength,
                           struct s_rem_device_response *pResponse, int nRespLength);


#endif /* REMOTEEXEC_H_ */
