/*
 * devices.c
 *
 *  Created on: 24/10/2008
 *      Author: ianb
 */
#include "rio.h"
#include "remote.h"
#include "adc_up.h"
#include "adc_ads1216.h"
#include "buzzer.h"
#include "iic.h"
#include "kbd.h"
#include "lcd.h"
#include "rtc.h"
#include "sio.h"
#include "framdev.h"

#include "devices_r400.h"


static struct t_io_dev *system_devices[REMOTE_MAX_DEV + 1] =
{
    &dev_adc,      /* REMOTE_DEV_CPU_ADC */
    &dev_buz,      /* REMOTE_DEV_BUZZER */
    0,             /* REMOTE_DEV_FLASH */
    &dev_fram,     /* REMOTE_DEV_FRAM */
    &dev_iic0,     /* REMOTE_DEV_IIC0 */
    &dev_iic1,     /* REMOTE_DEV_IIC1 */
    &dev_kbd,      /* REMOTE_DEV_KBD */
    &dev_lcd,      /* REMOTE_DEV_LCD */
    &dev_rtc,      /* REMOTE_DEV_RTC */
    0,             /* REMOTE_DEV_SER0 */
    0,             /* REMOTE_DEV_SER1 */
    &dev_com2,     /* REMOTE_DEV_SER2 */
    &dev_com3,     /* REMOTE_DEV_SER3 */
    &dev_com4,     /* REMOTE_DEV_SER4 */
    &dev_adc24bit, /* REMOTE_DEV_ADC_24BIT */
    0,             /* REMOTE_DEV_RESET */
};


struct t_io_dev *GetDevice(int8u ui8Device)
{
  if (ui8Device > REMOTE_MAX_DEV)
  {
    return 0;
  }
  return system_devices[ui8Device];
}
