/*
 * devices_we.h
 *
 *  Created on: Apr 24, 2012
 *      Author: ian
 */

#ifndef DEVICES_WE_H_
#define DEVICES_WE_H_

#include <rinhw/stdrinstrum.h>
#include <rinhw/rio.h>


/** SER 1 - onboard RS232/RS422 secondary serial port */
extern struct t_io_dev dev_ser1_local;


/** SER 2 - onboard RS232 secondary serial port */
extern struct t_io_dev dev_ser2_local;


/** Buzzer device (located on display rinblock) */
extern struct t_io_dev dev_buz_we;


/** Primary keyboard device, (located on display rinblock) */
extern struct t_io_dev dev_kbd_we;


/** Real time clock device */
extern struct t_io_dev dev_rtc_we;


/** I2C device */
extern struct t_io_dev dev_iic0;


/** 24bit ADC device */
extern struct t_io_dev dev_adc24bit_we;


/** LCD device */
extern struct t_io_dev dev_lcd_we;


/** ADC device */
extern struct t_io_dev dev_adc_we;


/** Console device */
extern struct t_io_dev dev_ser_console;


struct t_io_dev *GetDevice(int8u ui8Device);


/** Start up the system */
int init_test_app_devices(void);


/** Shut down the system */
void destroy_test_app_devices(void);


#endif /* DEVICES_WE_H_ */
