#ifndef REMOTE_DEBUG_DOT_H
#define REMOTE_DEBUG_DOT_H 1

#include <syslog.h>
#include <stdarg.h>


#define RDEBUG_LVL_OFF 0
#define RDEBUG_LVL_BASIC 1
#define RDEBUG_LVL_FULL 2


#define RDEBUG_ENABLED(mod, lvl) (mod >= lvl)


#define RDEBUG_OFF(modlvl, sllvl, format, args...)
#define RDEBUG_BASIC(modlvl, sllvl, format, args...) if (modlvl <= RDEBUG_LVL_BASIC) rdebug_printf(sllvl, format, ##args)
#define RDEBUG_FULL(modlvl, sllvl, format, args...) if (modlvl <= RDEBUG_LVL_FULL) rdebug_printf(sllvl, format, ##args)

#if 0
/* For example */
#define WE_ADC_THREAD_DEBUG_PRINTF RDEBUG_BASIC

#endif


/** Debug vprintf */
void rdebug_vprintf(int level, const char *format, va_list arglist);


/** Debug printf */
void rdebug_printf(int level, const char *format, ...);


#endif /* #ifndef REMOTE_DEBUG_DOT_H */
