/*
 * remotedemuxioctl_iic.c
 *
 *  Created on: 26/10/2008
 *      Author: ianb
 */

#include <rinhw/iic.h>
#include <rinhw/rio.h>
#include <rinhw/rinendian.h>
#include <rinhw/rstdio.h>
#include <rinhw/sio.h>
#include "devices.h"
#include "remotehelper.h"
#include "remotedemux.h"

#include "remotedemuxioctl_iic.h"


bool bHandleCommandIoCtl_Iic( const struct s_rem_device_command *prdCmd,
                              struct s_rem_device_response *prdResponse, int *pnLength )
{
  int nResult = RIO_ERROR;
  struct t_io_dev *dev = GetDevice( prdCmd->rem_dev_cmd_header.ui8Device );
  int nFunc = ntohs( prdCmd->rem_device_command.rem_dev_cmd_ioctl.rem_dev_cmd_ioctl_header.ui16IoCtlFunction );
  int8u ui8Level;
  bool bDefaultResponse = true;

//  rfprintf( &dev_com2, "IIC IOCTL %d\n", nFunc );
  if ( 0 != dev && slip_device != dev )
  {
    switch ( nFunc )
    {
      case IOCTL_IIC_SET_SLAVE_ADDR:
      case IOCTL_IIC_SET_SLOT_MASK:
      case IOCTL_IIC_SET_SPEED:
        ui8Level = prdCmd->rem_device_command.rem_dev_cmd_ioctl.remote_ioctl_command.rem_dev_cmd_ioctl_iic_set_level.ui8Level;
//        rfprintf( &dev_com2, "IIC IOCTL %d, level %u\n", nFunc, ui8Level );
        nResult = rioctl( dev, nFunc, ui8Level );
        break;

      case IOCTL_IIC_DEFAULT_SLOT_MASK:
        nResult = rioctl( dev, IOCTL_IIC_DEFAULT_SLOT_MASK );
        break;

      case IOCTL_IIC_GET_SLAVE_ADDR:
      case IOCTL_IIC_GET_SLOT_MASK:
        nResult = rioctl( dev, nFunc, &ui8Level );
        bDefaultResponse = false;
        vInitRemoteIoCtlRespHdr( prdResponse, prdCmd->rem_dev_cmd_header.ui8Device, (int16u) nFunc );
        prdResponse->rem_device_response.rem_dev_resp_ioctl.remote_ioctl_response.rem_dev_resp_ioctl_iic_get_level.i32Result = htonl( nResult );
        prdResponse->rem_device_response.rem_dev_resp_ioctl.remote_ioctl_response.rem_dev_resp_ioctl_iic_get_level.ui8Level = ui8Level;
        *pnLength = GET_SIZE_REMOTE_RESP_IOCTL_IIC_GET_LEVEL();
        break;

      default:
        nResult = RIO_ERROR;
        break;
    }
  }
//  rfprintf( &dev_com2, "IIC IOCTL result %d\n", nResult );

  if ( bDefaultResponse )
  {
    vInitRemoteIoCtlResp_Default( prdResponse, prdCmd->rem_dev_cmd_header.ui8Device,
                                  (int16u) nFunc, (int32s) nResult );
    *pnLength = GET_SIZE_REMOTE_RESP_IOCTL_DEFAULT();
  }
//  rfprintf( &dev_com2, "IIC result length %d\n", *pnLength );
  return true;
}


/** Get the packet size of an IIC IOCTL */
int nGetCmdPacketSizeIoCtl_Iic( const struct s_rem_device_command *prdCmd )
{
  return GET_SIZE_REMOTE_CMD_IOCTL_IIC_SET_LEVEL();
}
