/*
 * remotedemuxioctl_lcd.c
 *
 *  Created on: 26/10/2008
 *      Author: ianb
 */
#include <rinhw/lcd.h>
#include <rinhw/rio.h>
#include <rinhw/rinendian.h>
#include <rinhw/rstdio.h>
#include <rinhw/sio.h>
#include "devices.h"
#include "remotehelper.h"
#include "remotedemux.h"

#include "remotedemuxioctl_lcd.h"


bool bHandleCommandIoCtl_Lcd( const struct s_rem_device_command *prdCmd,
                              struct s_rem_device_response *prdResponse, int *pnLength )
{
  int nResult = RIO_ERROR;
  struct t_io_dev *dev = GetDevice( prdCmd->rem_dev_cmd_header.ui8Device );
  int nFunc = ntohs( prdCmd->rem_device_command.rem_dev_cmd_ioctl.rem_dev_cmd_ioctl_header.ui16IoCtlFunction );
  bool bDefaultResponse = true;

//  rfprintf( &dev_com2, "LCD IOCTL %d\n", nFunc );
  if ( 0 != dev && slip_device != dev )
  {
    switch ( nFunc )
    {
      case IOCTL_LCD_SET_BACKLIGHT:
        nResult = rioctl( dev, nFunc,
                          prdCmd->rem_device_command.rem_dev_cmd_ioctl.remote_ioctl_command.rem_dev_cmd_ioctl_lcd_set_backlight.ui8Level );
        break;

      /*
      case IOCTL_LCD_GET_DATAPTR:
      case IOCTL_LCD_GET_FLASHPTR:
      */

      case IOCTL_LCD_ACCESS_DATA:
#if INCLUDE_LCD_SEG_FLASH
      case IOCTL_LCD_ACCESS_FLASH:
#endif /* #if INCLUDE_LCD_SEG_FLASH */
      case IOCTL_LCD_ACCESS_OUTPUT:
      case IOCTL_LCD_ACCESS_CHAR:
        nResult = rioctl( dev, nFunc );
        break;

      default:
        nResult = RIO_ERROR;
        break;
    }
  }
//  rfprintf( &dev_com2, "LCD IOCTL result %d\n", nResult );

  if ( bDefaultResponse )
  {
    vInitRemoteIoCtlResp_Default( prdResponse, prdCmd->rem_dev_cmd_header.ui8Device,
                                  nFunc, nResult );
    *pnLength = GET_SIZE_REMOTE_RESP_IOCTL_DEFAULT();
  }
//  rfprintf( &dev_com2, "LCD result length %d\n", *pnLength );
  return true;
}


/** Get the packet size of an Lcd IOCTL */
int nGetCmdPacketSizeIoCtl_Lcd( const struct s_rem_device_command *prdCmd )
{
  return GET_SIZE_REMOTE_CMD_IOCTL_LCD_SET_BACKLIGHT();
}
