/*
 * alibi_datetime.c
 *
 *  Created on: Apr 24, 2012
 *      Author: ian
 */
#include <stdio.h>
#include <string.h>

#include "alibi_datetime.h"


/** Convert struct tm into t_datetime */
void AdcIntAlibiTmToDateTime(const struct tm *ts, t_datetime *dt)
{
  dt->year = ts->tm_year + 1900;
  dt->month = ts->tm_mon + 1;
  dt->date = ts->tm_mday;
  dt->hour = ts->tm_hour;
  dt->minute = ts->tm_min;
  dt->second = ts->tm_sec;
}


/** Convert a date to a string, suitable for displaying (yy.mm.dd) */
void AdcIntAlibiDateToStr(const t_datetime *dt, char *str, size_t length)
{
  int year;

  /* Only 2 digits of year */
  year = dt->year % 100;

  /* Convert date to string */
  snprintf(str, length, "%02u.%02u.%02u", year, dt->month, dt->date);
}


/** Convert a time to a string, suitable for displaying (hh.mm.ss) */
void AdcIntAlibiTimeToStr(const t_datetime *dt, char *str, size_t length)
{
  /* Convert time to string */
  snprintf(str, length, "%02u.%02u.%02u", dt->hour, dt->minute, dt->second);
}


/** Display a date on a single display */
void AdcIntAlibiSingleDisplayDate(struct s_adc_alibi_info *adc_alibi_info, const t_datetime *dt)
{
  const char *s_ptrs[1];
  AdcInfo info;

  /* Convert date to string */
  AdcIntAlibiDateToStr(dt, adc_alibi_info->display_work_buffers[aadtSingleDisplay], ADC_ALIBI_DISPLAY_WORK_BUF_LEN(adc_alibi_info->num_digits[aadtSingleDisplay]));

  /* No annunciators */
  memset(&info, 0, sizeof(info));

  /* Display the date */
  s_ptrs[0] = adc_alibi_info->display_work_buffers[aadtSingleDisplay];
  adc_alibi_info->adc_alibi_display(adc_alibi_info->implementer_data, adc_alibi_info->adc_alibi_display_type, s_ptrs, &info);
}


/** Display a time on a single display */
void AdcIntAlibiSingleDisplayTime(struct s_adc_alibi_info *adc_alibi_info, const t_datetime *dt)
{
  const char *s_ptrs[1];
  AdcInfo info;

  /* Convert time to string */
  AdcIntAlibiTimeToStr(dt, adc_alibi_info->display_work_buffers[aadtSingleDisplay], ADC_ALIBI_DISPLAY_WORK_BUF_LEN(adc_alibi_info->num_digits[aadtSingleDisplay]));

  /* No annunciators */
  memset(&info, 0, sizeof(info));

  /* Display the date */
  s_ptrs[0] = adc_alibi_info->display_work_buffers[aadtSingleDisplay];
  adc_alibi_info->adc_alibi_display(adc_alibi_info->implementer_data, adc_alibi_info->adc_alibi_display_type, s_ptrs, &info);
}
