/*
 * alibi_datetime.h
 *
 *  Created on: Apr 24, 2012
 *      Author: ian
 */

#ifndef ALIBI_DATETIME_H_
#define ALIBI_DATETIME_H_

#include <stddef.h>
#include <time.h>
#include <rinhw/rtc.h>
#include <rinweigh/adcalibi.h>


/** Convert struct tm into t_datetime */
void AdcIntAlibiTmToDateTime(const struct tm *ts, t_datetime *dt);


/** Convert a date to a string, suitable for displaying (yy.mm.dd) */
void AdcIntAlibiDateToStr(const t_datetime *dt, char *str, size_t length);


/** Convert a time to a string, suitable for displaying (hh.mm.ss) */
void AdcIntAlibiTimeToStr(const t_datetime *dt, char *str, size_t length);


/** Display a date on a single display */
void AdcIntAlibiSingleDisplayDate(struct s_adc_alibi_info *adc_alibi_info, const t_datetime *dt);


/** Display a time on a single display */
void AdcIntAlibiSingleDisplayTime(struct s_adc_alibi_info *adc_alibi_info, const t_datetime *dt);


#endif /* ALIBI_DATETIME_H_ */
