/*
 * alibi_display.h
 *
 * Implements display function for the alibi software.
 *
 *  Created on: Feb 21, 2012
 *      Author: ian
 */

#ifndef ALIBI_DISPLAY_H_
#define ALIBI_DISPLAY_H_

#include <rinhw/stdrinstrum.h>
#include <rinweigh/adcdatatypes.h>
#include <rinweigh/adcalibi.h>


/** Display a weight reading on the display */
void AdcIntAlibiSingleDisplayWeight(struct s_adc_alibi_info *adc_alibi_info, const AdcRdg *rdg);


/** Set or clear all segments on the display */
void AdcIntAlibiSetAllSegs(struct s_adc_alibi_info *adc_alibi_info, bool on_not_off);


/** Display a string on a single display indicator */
void AdcIntAlibiSingleDisplayStr(struct s_adc_alibi_info *adc_alibi_info, const char *s, const AdcInfo *info);


/** Display a string on a single display indicator, with no anunciators */
void AdcIntAlibiSingleDisplayStrNoAnnun(struct s_adc_alibi_info *adc_alibi_info, const char *s);


/** Display both strings on a dual display indicator (with annunciators) */
void AdcIntAlibiDualDisplayStr(struct s_adc_alibi_info *adc_alibi_info, const char *s1, const AdcInfo *i1, const char *s2, const AdcInfo *i2);


/** Display a string on display 1, and a weight on display 2 */
void AdcIntAlibiDualDisplayStrNoAnnunAndWeight(struct s_adc_alibi_info *adc_alibi_info, const char *s1, AdcRdg *rdg2);


/** Display both strings on a dual display indicator (with no annunciators) */
void AdcIntAlibiDualDisplayStrNoAnnun(struct s_adc_alibi_info *adc_alibi_info, const char *s1, const char *s2);


/** Get an internationisation string */
const char *AdcIntAlibiGetInternationisation(struct s_adc_alibi_info *adc_alibi_info, enum eAdcAlibiInternationisationStringIdx stridx);


#endif /* ALIBI_DISPLAY_H_ */
