/*
 * alibi_error.h
 *
 *  Created on: Feb 21, 2012
 *      Author: ian
 */

#ifndef ALIBI_ERROR_H_
#define ALIBI_ERROR_H_

#include <rinweigh/adcalibi.h>


/** Show a message */
enum eAdcAlibiKeystroke AdcIntAlibiShowMessage(struct s_adc_alibi_info *adc_alibi_info, const char *s, int16u timeout);


/** Show a message using internationalisation indexes, rather than strings */
enum eAdcAlibiKeystroke AdcIntAlibiShowMessageIndex(struct s_adc_alibi_info *adc_alibi_info, enum eAdcAlibiInternationisationStringIdx idx, int16u timeout);


/** Show an error */
enum eAdcAlibiKeystroke AdcIntAlibiShowError(struct s_adc_alibi_info *adc_alibi_info, const char *s1, const char *s2, int16u timeout);


/** Show an error using internationalisation indexes, rather than strings */
enum eAdcAlibiKeystroke AdcIntAlibiShowErrorIndexes(struct s_adc_alibi_info *adc_alibi_info, enum eAdcAlibiInternationisationStringIdx idx1, enum eAdcAlibiInternationisationStringIdx idx2, int16u timeout);


/** Convert ADC errors to application errors, which allows Alibi to display the same errors as the main application (for consistency) */
int32u AdcIntConvertAdcErrorsToApplicationErrors(struct s_adc_alibi_info *adc_alibi_info, AdcErrors adcerrors);


#endif /* ALIBI_ERROR_H_ */
