/*
 * alibi_select.c
 *
 *  Created on: Mar 15, 2012
 *      Author: ian
 */
#include "alibi_editlist.h"
#include "alibi_display.h"

#include "alibi_mode.h"


/** Select a new alibi mode */
void AdcIntAlibiSelectMode(struct s_adc_alibi_info *adc_alibi_info)
{
  const char *mode_strs[aamNumAlibiModes];
  enum eAdcAlibiMode modes[aamNumAlibiModes];
  int8u intmode;
  int8u nummodes;

  /* Clear display */
  AdcIntAlibiSetAllSegs(adc_alibi_info, false);

  /* Set up mode string list */
  nummodes = 0;

  mode_strs[nummodes] = AdcIntAlibiGetInternationisation(adc_alibi_info, aaisiModeWeighing);
  modes[nummodes] = aamWeighing;
  nummodes++;
  if (!adc_alibi_info->no_piece_counting)
  {
    mode_strs[nummodes] = AdcIntAlibiGetInternationisation(adc_alibi_info, aaisiModeCounting);
    modes[nummodes] = aamCounting;
    nummodes++;
  }
  mode_strs[nummodes] = AdcIntAlibiGetInternationisation(adc_alibi_info, aaisiModeDSDView);
  modes[nummodes] = aamDSDView;
  nummodes++;
  mode_strs[nummodes] = AdcIntAlibiGetInternationisation(adc_alibi_info, aaisiModeChangeLog);
  modes[nummodes] = aamChangelogView;
  nummodes++;
  mode_strs[nummodes] = AdcIntAlibiGetInternationisation(adc_alibi_info, aaisiModeQuitAlibi);
  modes[nummodes] = aamQuitAlibi;
  nummodes++;

  /* Run the editor */
  intmode = adc_alibi_info->alibi_mode;
  if (AdcIntAlibiEditList(adc_alibi_info, &intmode, mode_strs, nummodes))
  {
    /* Mode has changed */
    adc_alibi_info->alibi_mode = modes[intmode];
  }

}
