/*
 * alibi_scroll.h
 *
 *  Created on: May 24, 2012
 *      Author: ian
 */

#ifndef ALIBI_SCROLL_H_
#define ALIBI_SCROLL_H_

#include <stddef.h>
#include <rinhw/stdrinstrum.h>
#include <rinweigh/adcdatatypes.h>
#include <rinweigh/adcalibi.h>


/** Calculate the number of steps when scrolling */
size_t AdcIntAlibiScrollSingleDirnGetNumScrollSteps(const char *str, size_t display_length);


/** Calculate the number of steps when scrolling in both directions */
size_t AdcIntAlibiScrollDualDirnGetNumScrollSteps(const char *str, size_t display_length);


/** Display a scrolling string on a single display indicator */
void AdcIntAlibiSingleDisplayStrScroll(struct s_adc_alibi_info *adc_alibi_info,
                                       const char *s, const AdcInfo *info, bool scroll, int32u start_ticks, bool dual_direction);


/** Display scrolling strings on a dual display indicator */
void AdcIntAlibiDualDisplayStrScroll(struct s_adc_alibi_info *adc_alibi_info,
                                     const char *s1, const AdcInfo *i1, bool scroll_s1, int32u start_ticks1,
                                     const char *s2, const AdcInfo *i2, bool scroll_s2, int32u start_ticks2);


#endif /* ALIBI_SCROLL_H_ */
