/*
 * alibi_weight.h
 *
 *  Created on: Mar 29, 2012
 *      Author: ian
 */

#ifndef ALIBI_WEIGHT_H_
#define ALIBI_WEIGHT_H_

#include <stddef.h>
#include <rinweigh/adcalibi.h>


/**
 * Convert a weight to a string
 * (number, sign and decimal point, right justified
 * ready for display or printing)
 *
 * @param adc_alibi_info is the alibi information structure
 * @param rdg is the reading to convert to a string (only the reading and decimal point are used)
 * @param num_digits is the number of digits on the display (not including decimal points)
 * @param str is a string to put the weight into
 * @param strlength is the length of str in bytes (including the null terminator)
 */
void AdcIntAlibiWeightToStr(struct s_adc_alibi_info *adc_alibi_info, const AdcRdg *rdg, int num_digits, char *str, size_t strlength);


/**
 * Convert an ADC error to a string
 *
 * @param adc_alibi_info is the alibi information structure
 * @param error is the error bit mask (adcData.error)
 * @param num_digits is the number of digits on the display (not including decimal points)
 * @param str is a string to put the weight into
 * @param strlength is the length of str in bytes (including the null terminator)
 */
void AdcIntAlibiErrorToStr(struct s_adc_alibi_info *adc_alibi_info, int32u error, int num_digits, char *str, size_t strlength);


#endif /* ALIBI_WEIGHT_H_ */
