'''
Created on Sep 15, 2017

@author: ian
'''
import os


xmlfilename = "registers_test.xml"


class TestRegistersConstants(object):
    """Constants to match those used in the XML file"""

    TEST_INT8_MIN = -128
    TEST_INT8_MAX = 127

    TEST_UINT8_MIN = 0
    TEST_UINT8_MAX = 0xFF

    TEST_INT16_MIN = -32768
    TEST_INT16_MAX = 32767

    TEST_UINT16_MIN = 0
    TEST_UINT16_MAX = 0xFFFF

    TEST_INT32_MIN = -0x80000000
    TEST_INT32_MAX = 0x7FFFFFFF

    TEST_UINT32_MIN = 0
    TEST_UINT32_MAX = 0xFFFFFFFF

    TEST_STRING_LENGTH = 100

    TEST_BINBUFFER_LENGTH = 200

    TEST_REGISTER_MIN = 0
    TEST_REGISTER_MAX = 0xFFFF

    h_template = \
"""/*
 * {filename}
 *
 * Dummy header file referenced by registers_test.xml,
 * and required for test TestXMLRegisterToC.test_xml_to_c_and_compile()
 *
 * Automatically generated by TestRegistersConstants() python class
 */

#ifndef {hifndef}
#define {hifndef}

{hashdefines}

{externs}

#endif /* {hifndef} */
"""

    def to_header_str(self, filename, registers):

        hashdefines = []
        for key in filter(lambda a: a.startswith('TEST_'), dir(self)):
            val = getattr(self, key)
            hashdefine = "#define {} {}".format(key, val)
            hashdefines.append(hashdefine)

        externs = "" if (registers is None) else registers.xml_registers_to_c_variable_declarations(extern=True)

        fonly = os.path.basename(filename)
        fn, fext = os.path.splitext(fonly)
        hifndef = "{}_DOT_{}".format(fn.upper().replace(".", ""), fext.upper().replace(".", ""))
        return self.h_template.format(filename=filename,
                                      hifndef=hifndef,
                                      hashdefines="\n".join(hashdefines),
                                      externs=externs)

    def to_header_file(self, filename, registers):

        h_str = self.to_header_str(filename=filename, registers=registers)

        f = open(filename, 'w')
        f.write(h_str)
        f.close()
