/*
 * rc_cli_async_stream.h
 *
 *  Created on: Dec 12, 2017
 *      Author: ian
 */

#ifndef RC_CLI_ASYNC_STREAM_H_
#define RC_CLI_ASYNC_STREAM_H_

#include <time.h>
#include <rincmd/rc_cli_comms.h>
#include <rincmd/rc_cli_async.h>
#include <rincmd/rc_parser.h>
#include <rincmd/rc_public.h>
#include <rincmd/rc_streaming.h>


/**
 * Setup a streaming set for an asynchronous client
 *
 * Sequence is write steam registers, write mode register, execute data register
 */
enum e_rc_cli_result rc_async_client_streaming_setup(struct s_rc_async_client *rac,
                                                     rc_RegId_t stream_reg_base,
                                                     t_rc_async_callback_fn callback, void *userdata,
                                                     enum e_rc_stream_mode stream_mode,
                                                     const int regs[RC_STREAM_DATA_REGISTERS],
                                                     const struct timespec *setup_timeout,
                                                     const struct timespec *stream_timeout);


/**
 * Teardown a streaming set for an asynchronous client
 *
 * Sequence is execute data register, write steam registers, write mode register
 */
enum e_rc_cli_result rc_async_client_streaming_teardown(struct s_rc_async_client *rac,
                                                        rc_RegId_t stream_reg_base,
                                                        t_rc_async_callback_fn callback, void *userdata,
                                                        const struct timespec *setup_timeout);


#endif /* RC_CLI_ASYNC_STREAM_H_ */
