/*
 * rc_cli_gettime.h
 *
 *  Created on: 25 May 2018
 *      Author: ian
 */

#ifndef RC_CLI_GETTIME_H_
#define RC_CLI_GETTIME_H_

#include <time.h>
#include <rincmd/rc_cli_error.h>


/**
 * Callback from the rincmd client library to get the current time
 *
 * This is implemented (by you) externally to the library, usually by:
 *
 * enum e_rc_cli_result rc_cli_external_gettime(struct timespec *ts)
 * {
 *   if (NULL == ts)
 *     return rcr_paramfail;
 *   else
 *     return (clock_gettime(CLOCK_MONOTONIC, ts) == 0) ? rcr_success : rcr_failure;
 * }
 *
 */
extern enum e_rc_cli_result rc_cli_external_gettime(struct timespec *ts);


#endif /* RC_CLI_GETTIME_H_ */
