/*
 * rc_cli_sync_stream.h
 *
 *  Created on: Dec 13, 2017
 *      Author: ian
 */

#ifndef RC_CLI_SYNC_STREAM_H_
#define RC_CLI_SYNC_STREAM_H_

#include <time.h>
#include <rincmd/rc_cli_comms.h>
#include <rincmd/rc_cli_sync.h>
#include <rincmd/rc_public.h>
#include <rincmd/rc_streaming.h>


/** Setup a streaming set for a synchronous client */
enum e_rc_cli_result rc_sync_client_streaming_setup(struct s_rc_sync_client *rsc,
                                                    rc_RegId_t stream_reg_base,
                                                    enum e_rc_stream_mode stream_mode,
                                                    const int regs[RC_STREAM_DATA_REGISTERS],
                                                    const struct timespec *timeout);


/** Read a streaming response from a synchronous client */
enum e_rc_cli_result rc_sync_client_streaming_read(struct s_rc_sync_client *rsc,
                                                   rc_RegId_t stream_reg_base,
                                                   int64_t regs[RC_STREAM_DATA_REGISTERS],
                                                   const struct timespec *timeout);



/** Teardown a streaming set for a synchronous client */
enum e_rc_cli_result rc_sync_client_streaming_teardown(struct s_rc_sync_client *rsc,
                                                       rc_RegId_t stream_reg_base,
                                                       const struct timespec *timeout);


#endif /* RC_CLI_SYNC_STREAM_H_ */
