#include <stdio.h>
#include <stdarg.h>

#include <rincmd/rc_private.h>
#include <rincmd/rc_public.h>


/** Rincmd debug printf function pointer */
static t_rc_debug_printf_fn rc_debug_printf_fn = NULL;


/** Set the debug printf function for the Rincmd library */
void rc_set_debug_printf_fn(t_rc_debug_printf_fn fn)
{
  rc_debug_printf_fn = fn;
}


/** Debug printf function for the Rincmd library, calls the application implemented handler */
int rc_debug_printf(int priority, const char *format, ...)
{
  va_list args;

  if (NULL != rc_debug_printf_fn)
  {
    va_start(args, format);
    rc_debug_printf_fn(priority, format, args);
    va_end(args);
  }
  return 0;
}
