/*
 * rc_timespec.h
 *
 *  Created on: Nov 29, 2017
 *      Author: ian
 */

#ifndef RC_TIMESPEC_H_
#define RC_TIMESPEC_H_

#include <time.h>


#define RC_NANO_SEC_PER_SEC 1000000000


/**
 * Add the 'struct timespec' values x and y, storing the result in result.
 * ie: result = x+y
 */
void rc_timespec_add(struct timespec *result, const struct timespec *x, const struct timespec *y);


/**
 * Subtract the 'struct timespec' values X and Y, storing the result in RESULT.
 * ie: result = x-y
 */
void rc_timespec_subtract(struct timespec *result, const struct timespec *x, const struct timespec *y);


/**
 * Compare two 'struct timespec' values x and y
 *
 * Return -1 if the difference is negative (x < y), 1 if positive (x > y), 0 if equal (x = y)
 */
int rc_timespec_compare(const struct timespec *x, const struct timespec *y);


#endif /* RC_TIMESPEC_H_ */
