/*
 * test_rc_timespec.h
 *
 *  Created on: Nov 29, 2017
 *      Author: ian
 */

#ifndef TEST_RC_TIMESPEC_H_
#define TEST_RC_TIMESPEC_H_

#include <time.h>
#include <cutest/CuTest.h>


void CuAssertTimeSpecEquals_LineMsg(CuTest* tc, const char* file, int line, const char* message,
                                    struct timespec expected, struct timespec actual);


#define CuAssertTimeSpecEquals(tc,ex,ac) CuAssertTimeSpecEquals_LineMsg((tc),__FILE__,__LINE__,NULL,(ex),(ac))


#define SET_TIMESPEC_NSEC(sec, intsec) \
  (intsec > 0) ? (int) ((sec - intsec) * RC_NANO_SEC_PER_SEC + 0.5) \
               : (intsec < 0) ? (int) ((intsec - sec) * RC_NANO_SEC_PER_SEC + 0.5) \
                              : (int) (sec * RC_NANO_SEC_PER_SEC)


/** Set a timespec from a double or an integer (if no sub-second precision required) */
#define SET_TIMESPEC(ts, sec) \
do \
{ \
  ts.tv_sec = (int) sec; \
  ts.tv_nsec = SET_TIMESPEC_NSEC(sec, ts.tv_sec); \
} \
while (0)


/** Declare a timespec from a double or an integer (if no sub-second precision required) */
#define DECLARE_TIMESPEC(pre, ts, sec) \
pre struct timespec ts = { .tv_sec=(int) sec, .tv_nsec=SET_TIMESPEC_NSEC(sec, (int) sec) }

/** Pass this as pre to DECLARE_TIMESPEC if you want "struct timespec... */
#define tsnoprefix


CuSuite *CuGetSuite_rc_timespec(void);


#endif /* TEST_RC_TIMESPEC_H_ */
