/*
 * db_database_search.c
 *
 *  Created on: Jun 26, 2012
 *      Author: ian
 */
#include <string.h>
#include <rindb/db_database.h>
#include <rindb/db_element.h>

#include <rindb/db_database_search.h>


/** Retrieve a database element by database element name */
enum eDBError db_database_get_element_by_dbname(struct s_db_database *database, const char *name, struct s_db_element **elem)
{
  size_t i;
  enum eDBError res;
  struct s_db_element *de;

  /* Check pointers */
  if (NULL == database || NULL == name || NULL == elem)
  {
    return dbeNullPointer;
  }

  /* Search for element in list */
  for (*elem = NULL, i = 0, res = dbeNotFound; i < database->db_num_elements; i++)
  {
    de = &database->db_elements[i];
    if (0 == strcmp(name, de->elem_db_name))
    {
      res = dbeSuccess;
      *elem = de;
      break;
    }
  }

  return res;
}


/** Retrieve a database element by menu name */
enum eDBError db_database_get_element_by_username(struct s_db_database *database, const char *name, struct s_db_element **elem)
{
  size_t i;
  enum eDBError res;
  struct s_db_element *de;

  /* Check pointers */
  if (NULL == database || NULL == name || NULL == elem)
  {
    return dbeNullPointer;
  }

  /* Search for element in list */
  for (*elem = NULL, i = 0, res = dbeNotFound; i < database->db_num_elements; i++)
  {
    de = &database->db_elements[i];
    if (0 == strcmp(name, de->elem_menu_name))
    {
      res = dbeSuccess;
      *elem = de;
      break;
    }
  }

  return res;
}

