/*
 * db_strncpy.c
 *
 *  Created on: Jun 8, 2012
 *      Author: ian
 */
#include <string.h>

#include <rindb/db_strncpy.h>


/** Safer strncpy that terminates the end of the string with '\0' regardless */
char *db_safe_strncpy(char *dest, const char *src, size_t n)
{
  if (n > 0 && NULL != dest && NULL != src)
  {
    strncpy(dest, src, n);
    dest[n - 1] = '\0';
  }
  return dest;
}
