﻿/*
 * db_we2111.c
 *
 *  Created on: 12/11/2010
 *      Author: ian
 */
#include <limits.h>
#include <rindb/db_interp.h>
#include <rindb/db_database.h>
#include <rindb/db_element.h>

#include "db_we2111.h"


/*
 * Factory database
 */

/** Application factory database */
struct s_db_app_factory db_app_factory;


const int32_t db_we21_zoffs_default[NUM_ADC_SYNC_FREQ] = { WE21_DB_F_ADCZOFFS_DEFAULT, WE21_DB_F_ADCZOFFS_DEFAULT, WE21_DB_F_ADCZOFFS_DEFAULT, WE21_DB_F_ADCZOFFS_DEFAULT, WE21_DB_F_ADCZOFFS_DEFAULT, WE21_DB_F_ADCZOFFS_DEFAULT, WE21_DB_F_ADCZOFFS_DEFAULT, WE21_DB_F_ADCZOFFS_DEFAULT, WE21_DB_F_ADCZOFFS_DEFAULT };
const int32_t db_we21_zoffs_minimum[NUM_ADC_SYNC_FREQ] = { WE21_DB_F_ADCZOFFS_MIN,     WE21_DB_F_ADCZOFFS_MIN,     WE21_DB_F_ADCZOFFS_MIN,     WE21_DB_F_ADCZOFFS_MIN,     WE21_DB_F_ADCZOFFS_MIN,     WE21_DB_F_ADCZOFFS_MIN,     WE21_DB_F_ADCZOFFS_MIN,     WE21_DB_F_ADCZOFFS_MIN,     WE21_DB_F_ADCZOFFS_MIN };
const int32_t db_we21_zoffs_maximum[NUM_ADC_SYNC_FREQ] = { WE21_DB_F_ADCZOFFS_MAX,     WE21_DB_F_ADCZOFFS_MAX,     WE21_DB_F_ADCZOFFS_MAX,     WE21_DB_F_ADCZOFFS_MAX,     WE21_DB_F_ADCZOFFS_MAX,     WE21_DB_F_ADCZOFFS_MAX,     WE21_DB_F_ADCZOFFS_MAX,     WE21_DB_F_ADCZOFFS_MAX,     WE21_DB_F_ADCZOFFS_MAX };

#if 0
const int32_t db_we21_spancal_default[NUM_ADC_SYNC_FREQ] = { WE21_DB_F_ADCSCAL_DEFAULT, WE21_DB_F_ADCSCAL_DEFAULT, WE21_DB_F_ADCSCAL_DEFAULT, WE21_DB_F_ADCSCAL_DEFAULT, WE21_DB_F_ADCSCAL_DEFAULT, WE21_DB_F_ADCSCAL_DEFAULT, WE21_DB_F_ADCSCAL_DEFAULT, WE21_DB_F_ADCSCAL_DEFAULT, WE21_DB_F_ADCSCAL_DEFAULT };
const int32_t db_we21_spancal_minimum[NUM_ADC_SYNC_FREQ] = { WE21_DB_F_ADCSCAL_MIN,     WE21_DB_F_ADCSCAL_MIN,     WE21_DB_F_ADCSCAL_MIN,     WE21_DB_F_ADCSCAL_MIN,     WE21_DB_F_ADCSCAL_MIN,     WE21_DB_F_ADCSCAL_MIN,     WE21_DB_F_ADCSCAL_MIN,     WE21_DB_F_ADCSCAL_MIN,     WE21_DB_F_ADCSCAL_MIN };
const int32_t db_we21_spancal_maximum[NUM_ADC_SYNC_FREQ] = { WE21_DB_F_ADCSCAL_MAX,     WE21_DB_F_ADCSCAL_MAX,     WE21_DB_F_ADCSCAL_MAX,     WE21_DB_F_ADCSCAL_MAX,     WE21_DB_F_ADCSCAL_MAX,     WE21_DB_F_ADCSCAL_MAX,     WE21_DB_F_ADCSCAL_MAX,     WE21_DB_F_ADCSCAL_MAX,     WE21_DB_F_ADCSCAL_MAX };
#endif

struct s_db_element we2111_factory_elements[] =
{
  DB_DECLARE_INT32_ARRAY_ELEM_INDIVIDUAL(    WE21_DB_F_ADCZOFFS_STR,       WE21_DB_F_ADCZOFFS_STR,           db_app_factory.adc_factory_database.zeroOffset,     NUM_ADC_SYNC_FREQ,        db_we21_zoffs_minimum,       db_we21_zoffs_maximum,        db_we21_zoffs_default,          DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_FACTORY),
  DB_DECLARE_INT32_ELEM(                     WE21_DB_F_ADCZDRIFT_STR,      WE21_DB_F_ADCZDRIFT_STR,          &db_app_factory.adc_factory_database.zeroDrift,                               WE21_DB_F_ADCZDRIFT_MIN,     WE21_DB_F_ADCZDRIFT_MAX,      WE21_DB_F_ADCZDRIFT_DEFAULT,    DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_FACTORY),
  DB_DECLARE_INT32_ARRAY_ELEM_SINGLE(        WE21_DB_F_ADCSCAL_STR,        WE21_DB_F_ADCSCAL_STR,            db_app_factory.adc_factory_database.spanCal,        NUM_ADC_SYNC_FREQ,        WE21_DB_F_ADCSCAL_MIN,       WE21_DB_F_ADCSCAL_MAX,        WE21_DB_F_ADCSCAL_DEFAULT,      DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_FACTORY),
  DB_DECLARE_INT32_ELEM(                     WE21_DB_F_ADCSDRIFT_STR,      WE21_DB_F_ADCSDRIFT_STR,          &db_app_factory.adc_factory_database.spanDrift,                               WE21_DB_F_ADCSDRIFT_MIN,     WE21_DB_F_ADCSDRIFT_MAX,      WE21_DB_F_ADCSDRIFT_DEFAULT,    DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_FACTORY),
  DB_DECLARE_UINT32_ELEM(                    WE21_DB_F_ADCCALTEMP_STR,     WE21_DB_F_ADCCALTEMP_STR,         &db_app_factory.adc_factory_database.calTemp,                                 WE21_DB_F_ADCCALTEMP_MIN,    WE21_DB_F_ADCCALTEMP_MAX,     WE21_DB_F_ADCCALTEMP_DEFAULT,   DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_FACTORY),
  DB_DECLARE_UINT8_ELEM(                     WE21_DB_F_ADCCALFLAG_STR,     WE21_DB_F_ADCCALFLAG_STR,         &db_app_factory.adc_factory_database.calFlag,                                 WE21_DB_F_ADCCALFLAG_MIN,    WE21_DB_F_ADCCALFLAG_MAX,     WE21_DB_F_ADCCALFLAG_DEFAULT,   DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_FACTORY),
  DB_DECLARE_UINT8_ELEM(                     WE21_DB_F_ADCGAINFLAG_STR,    WE21_DB_F_ADCGAINFLAG_STR,        &db_app_factory.adc_factory_database.gainFlag,                                WE21_DB_F_ADCGAINFLAG_MIN,   WE21_DB_F_ADCGAINFLAG_MAX,    WE21_DB_F_ADCGAINFLAG_DEFAULT,  DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_FACTORY),

  DB_DECLARE_UINT32_ELEM(                    WE21_DB_F_SERIALNO_STR,       WE21_DB_F_SERIALNO_STR,           &db_app_factory.serial_no,                                                    WE21_DB_F_SERIALNO_MIN,      WE21_DB_F_SERIALNO_MAX,       WE21_DB_F_SERIALNO_DEFAULT,     DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_FACTORY),
  DB_DECLARE_UINT8_ELEM(                     WE21_DB_F_CALFLAG_STR,        WE21_DB_F_CALFLAG_STR,            &db_app_factory.cal_flag,                                                     WE21_DB_F_CALFLAG_MIN,       WE21_DB_F_CALFLAG_MAX,        WE21_DB_F_CALFLAG_DEFAULT,      DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_FACTORY),
  DB_DECLARE_UINT8_ELEM(                     WE21_DB_F_ECONOMY_STR,        WE21_DB_F_ECONOMY_STR,            &db_app_factory.economy,                                                      WE21_DB_F_ECONOMY_MIN,       WE21_DB_F_ECONOMY_MAX,        WE21_DB_F_ECONOMY_DEFAULT,      DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_FACTORY),
  DB_DECLARE_UINT32_ELEM(                    WE21_DB_F_APPLICID_STR,       WE21_DB_F_APPLICID_STR,           &db_app_factory.application_id,                                               WE21_DB_F_APPLICID_MIN,      WE21_DB_F_APPLICID_MAX,       WE21_DB_F_APPLICID_DEFAULT,     DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_FACTORY),
  DB_DECLARE_UINT8_ELEM(                     WE21_DB_F_TRADEENABLE_STR,    WE21_DB_F_TRADEENABLE_STR,        &db_app_factory.trade_enable,                                                 WE21_DB_F_TRADEENABLE_MIN,   WE21_DB_F_TRADEENABLE_MAX,    WE21_DB_F_TRADEENABLE_DEFAULT,  DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_FACTORY),
  DB_DECLARE_STRING_ELEM(                    WE21_DB_F_MODEL_STR,          WE21_DB_F_MODEL_STR,              &db_app_factory.model_str[0],                                                 WE21_DB_F_MODEL_MAXLEN,                                    WE21_DB_F_MODEL_DEFAULT,        DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_FACTORY),
};


struct s_db_database we2111_factory_database =
{
  .db_database_version = WE_DB_F_VERSION1,
  .db_database_chksum_seed = WE21_DB_F_CHECKSUM_SEED,
  .db_elements = we2111_factory_elements,
  .db_num_elements = DB_NUM_ELEMENTS(we2111_factory_elements),
  .db_name = WE21_DB_F_NAME,
  .db_checksum_buffer = NULL
};


/*
 * User database
 */


struct s_db_we2111_d1 db_we2111_d1;


/** Defaults for setpoint types */
const uint8_t setpointtype_defaults[NUM_SETPOINTS] = WE21_DB_D1_SETPTYPES_DEFAULT;
const uint8_t setpointtype_minimums[NUM_SETPOINTS] = WE21_DB_D1_SETPTYPES_MINIMUM;
const uint8_t setpointtype_maximums[NUM_SETPOINTS] = WE21_DB_D1_SETPTYPES_MAXIMUM;


static char *const teststrarray_ptrs[WE21_DB_D1_TESTSTRARRAY_NUM] =
{
  db_we2111_d1.teststrarray[0],
  db_we2111_d1.teststrarray[1],
  db_we2111_d1.teststrarray[2],
  db_we2111_d1.teststrarray[3],
  db_we2111_d1.teststrarray[4],
  db_we2111_d1.teststrarray[5],
  db_we2111_d1.teststrarray[6],
  db_we2111_d1.teststrarray[7],
  db_we2111_d1.teststrarray[8],
  db_we2111_d1.teststrarray[9],
};


struct s_db_element we2111_user_elements_v1[] =
{
  DB_DECLARE_UINT32_ELEM(                    WE21_DB_D1_SAFEPASSCODE_STR,  WE21_DB_D1_SAFEPASSCODE_STR,      &db_we2111_d1.safe_passcode,                                                  WE21_DB_D1_SAFEPASSCODE_MIN,  WE21_DB_D1_SAFEPASSCODE_MAX,   WE21_DB_D1_SAFEPASSCODE_DEFAULT,   DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_TRADE),
  DB_DECLARE_UINT32_ELEM(                    WE21_DB_D1_FULLPASSCODE_STR,  WE21_DB_D1_FULLPASSCODE_STR,      &db_we2111_d1.full_passcode,                                                  WE21_DB_D1_FULLPASSCODE_MIN,  WE21_DB_D1_FULLPASSCODE_MAX,   WE21_DB_D1_FULLPASSCODE_DEFAULT,   DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_USER),
  DB_DECLARE_UINT8_ELEM(                     WE21_DB_D1_BUTTONPERMS_STR,   WE21_DB_D1_BUTTONPERMS_STR,       &db_we2111_d1.button_permissions,                                             WE21_DB_D1_BUTTONPERMS_MIN,   WE21_DB_D1_BUTTONPERMS_MAX,    WE21_DB_D1_BUTTONPERMS_DEFAULT,    DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_USER),
  DB_DECLARE_INT32_ELEM(                     WE21_DB_D1_ZEROBAND_STR,      WE21_DB_D1_ZEROBAND_STR,          &db_we2111_d1.zero_band,                                                      WE21_DB_D1_ZEROBAND_MIN,      WE21_DB_D1_ZEROBAND_MAX,       WE21_DB_D1_ZEROBAND_DEFAULT,       DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_USER),
  DB_DECLARE_UINT8_ARRAY_ELEM_INDIVIDUAL(    WE21_DB_D1_SETPTYPES_STR,     WE21_DB_D1_SETPTYPES_STR,         db_we2111_d1.setpoint_types,            WE21_DB_D1_SETPTYPES_LENGTH,          setpointtype_minimums,        setpointtype_maximums,         setpointtype_defaults,             DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_USER),
  DB_DECLARE_UINT8_ELEM(                     WE21_DB_D1_INFLIGHTADJ_STR,   WE21_DB_D1_INFLIGHTADJ_STR,       &db_we2111_d1.flt_adj,                                                        WE21_DB_D1_INFLIGHTADJ_MIN,   WE21_DB_D1_INFLIGHTADJ_MAX,    WE21_DB_D1_INFLIGHTADJ_DEFAULT,    DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_USER),
  DB_DECLARE_UINT8_ELEM(                     WE21_DB_D1_PULSETIME_STR,     WE21_DB_D1_PULSETIME_STR,         &db_we2111_d1.pulse_time,                                                     WE21_DB_D1_PULSETIME_MIN,     WE21_DB_D1_PULSETIME_MAX,      WE21_DB_D1_PULSETIME_DEFAULT,      DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_USER),
  DB_DECLARE_UINT8_ELEM(                     WE21_DB_D1_QAOPTION_STR,      WE21_DB_D1_QAOPTION_STR,          &db_we2111_d1.qaopt,                                                          WE21_DB_D1_QAOPTION_MIN,      WE21_DB_D1_QAOPTION_MAX,       WE21_DB_D1_QAOPTION_DEFAULT,       DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_USER),
  DB_DECLARE_INT32_ELEM(                     WE21_DB_D1_ANALOGOUTSPAN_STR, WE21_DB_D1_ANALOGOUTSPAN_STR,     &db_we2111_d1.analog_span_cal,                                                WE21_DB_D1_ANALOGOUTSPAN_MIN, WE21_DB_D1_ANALOGOUTSPAN_MAX,  WE21_DB_D1_ANALOGOUTSPAN_DEFAULT,  DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_USER),
  DB_DECLARE_INT32_ELEM(                     WE21_DB_D1_ANALOGOUTZERO_STR, WE21_DB_D1_ANALOGOUTZERO_STR,     &db_we2111_d1.analog_zero_cal,                                                WE21_DB_D1_ANALOGOUTZERO_MIN, WE21_DB_D1_ANALOGOUTZERO_MAX,  WE21_DB_D1_ANALOGOUTZERO_DEFAULT,  DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_USER),
  DB_DECLARE_STRING_ARRAY_ELEM_SINGLE(       WE21_DB_D1_TESTSTRARRAY_STR,  NULL,                             teststrarray_ptrs,                      WE21_DB_D1_TESTSTRARRAY_NUM,          WE21_DB_D1_TESTSTRARRAY_MAXLEN,                              WE21_DB_D1_TESTSTRARRAY_DEFAULT,   DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_USER),
  DB_DECLARE_STRING_ELEM(                    WE21_DB_D1_TESTSTRING_STR,    NULL,                             db_we2111_d1.teststring,                                                                                    WE21_DB_D1_TESTSTRING_MAXLEN,   WE21_DB_D1_TESTSTRING_DEFAULT,    DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_USER),
};


struct s_db_element we2111_user_elements_v2[] =
{
  DB_DECLARE_UINT32_ELEM(                    WE21_DB_D1_SAFEPASSCODE_STR,  WE21_DB_D1_SAFEPASSCODE_STR,      &db_we2111_d1.safe_passcode,                                                  WE21_DB_D1_SAFEPASSCODE_MIN,  WE21_DB_D1_SAFEPASSCODE_MAX,   WE21_DB_D1_SAFEPASSCODE_DEFAULT,   DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_USER),
  DB_DECLARE_UINT32_ELEM(                    WE21_DB_D1_FULLPASSCODE_STR,  WE21_DB_D1_FULLPASSCODE_STR,      &db_we2111_d1.full_passcode,                                                  WE21_DB_D1_FULLPASSCODE_MIN,  WE21_DB_D1_FULLPASSCODE_MAX,   WE21_DB_D1_FULLPASSCODE_DEFAULT,   DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_USER),
  DB_DECLARE_UINT8_ELEM(                     WE21_DB_D1_BUTTONPERMS_STR,   WE21_DB_D1_BUTTONPERMS_STR,       &db_we2111_d1.button_permissions,                                             WE21_DB_D1_BUTTONPERMS_MIN,   WE21_DB_D1_BUTTONPERMS_MAX,    WE21_DB_D1_BUTTONPERMS_DEFAULT,    DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_USER),
  DB_DECLARE_INT32_ELEM(                     WE21_DB_D1_ZEROBAND_STR,      WE21_DB_D1_ZEROBAND_STR,          &db_we2111_d1.zero_band,                                                      WE21_DB_D1_ZEROBAND_MIN,      WE21_DB_D1_ZEROBAND_MAX,       WE21_DB_D1_ZEROBAND_DEFAULT,       DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_USER),
  DB_DECLARE_UINT8_ARRAY_ELEM_INDIVIDUAL(    WE21_DB_D1_SETPTYPES_STR,     WE21_DB_D1_SETPTYPES_STR,         db_we2111_d1.setpoint_types,            WE21_DB_D1_SETPTYPES_LENGTH,          setpointtype_minimums,        setpointtype_maximums,         setpointtype_defaults,             DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_USER),
  DB_DECLARE_UINT8_ELEM(                     WE21_DB_D1_INFLIGHTADJ_STR,   WE21_DB_D1_INFLIGHTADJ_STR,       &db_we2111_d1.flt_adj,                                                        WE21_DB_D1_INFLIGHTADJ_MIN,   WE21_DB_D1_INFLIGHTADJ_MAX,    WE21_DB_D1_INFLIGHTADJ_DEFAULT,    DB_NO_MINIMUM_VERSION, WE_DB_U_VERSION1,      WE21_DB_CLMASK_USER), /* Disappears in V2+ */
  DB_DECLARE_UINT8_ELEM(                     WE21_DB_D1_PULSETIME_STR,     WE21_DB_D1_PULSETIME_STR,         &db_we2111_d1.pulse_time,                                                     WE21_DB_D1_PULSETIME_MIN,     WE21_DB_D1_PULSETIME_MAX,      WE21_DB_D1_PULSETIME_DEFAULT,      DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_USER),
  DB_DECLARE_UINT8_ELEM(                     WE21_DB_D1_QAOPTION_STR,      WE21_DB_D1_QAOPTION_STR,          NULL,                                                                         WE21_DB_D1_QAOPTION_MIN,      WE21_DB_D1_QAOPTION_MAX,       WE21_DB_D1_QAOPTION_DEFAULT,       DB_NO_MINIMUM_VERSION, WE_DB_U_VERSION1,      WE21_DB_CLMASK_USER),  /* Was &db_we2111_d1.qaopt, disappears in V2+ */
  DB_DECLARE_INT32_ELEM(                     WE21_DB_D1_ANALOGOUTSPAN_STR, WE21_DB_D1_ANALOGOUTSPAN_STR,     &db_we2111_d1.analog_span_cal,                                                WE21_DB_D1_ANALOGOUTSPAN_MIN, WE21_DB_D1_ANALOGOUTSPAN_MAX,  WE21_DB_D1_ANALOGOUTSPAN_DEFAULT,  DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_USER),
  DB_DECLARE_INT32_ELEM(                     WE21_DB_D1_ANALOGOUTZERO_STR, WE21_DB_D1_ANALOGOUTZERO_STR,     &db_we2111_d1.analog_zero_cal,                                                WE21_DB_D1_ANALOGOUTZERO_MIN, WE21_DB_D1_ANALOGOUTZERO_MAX,  WE21_DB_D1_ANALOGOUTZERO_DEFAULT,  DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_USER),
  DB_DECLARE_STRING_ARRAY_ELEM_SINGLE(       WE21_DB_D1_TESTSTRARRAY_STR,  NULL,                             teststrarray_ptrs,                      WE21_DB_D1_TESTSTRARRAY_NUM,          WE21_DB_D1_TESTSTRARRAY_MAXLEN,                              WE21_DB_D1_TESTSTRARRAY_DEFAULT,   DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_USER),
  DB_DECLARE_STRING_ELEM(                    WE21_DB_D1_TESTSTRING_STR,    NULL,                             db_we2111_d1.teststring,                                                                                    WE21_DB_D1_TESTSTRING_MAXLEN,   WE21_DB_D1_TESTSTRING_DEFAULT,    DB_NO_MINIMUM_VERSION, DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_USER),

  DB_DECLARE_UINT32_ELEM(                    WE21_DB_D1_TESTVAR_STR,       WE21_DB_D1_TESTVAR_STR,           &db_we2111_d1.test_var,                                                       WE21_DB_D1_TESTVAR_MIN,       WE21_DB_D1_TESTVAR_MAX,        WE21_DB_D1_TESTVAR_DEFAULT,        WE_DB_U_VERSION2,      DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_USER), /* Appears in V2+ */
  DB_DECLARE_INT32_ARRAY_ELEM_INDIVIDUAL(    WE21_DB_F_ADCZOFFS_STR,       WE21_DB_F_ADCZOFFS_STR,           db_we2111_d1.zeroOffset,                NUM_ADC_SYNC_FREQ,                    db_we21_zoffs_minimum,        db_we21_zoffs_maximum,         db_we21_zoffs_default,             WE_DB_U_VERSION2,      DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_FACTORY),
  DB_DECLARE_INT32_ARRAY_ELEM_SINGLE(        WE21_DB_F_ADCSCAL_STR,        WE21_DB_F_ADCSCAL_STR,            db_we2111_d1.spanCal,                   NUM_ADC_SYNC_FREQ,                    WE21_DB_F_ADCSCAL_MIN,        WE21_DB_F_ADCSCAL_MAX,         WE21_DB_F_ADCSCAL_DEFAULT,         WE_DB_U_VERSION2,      DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_FACTORY),
  DB_DECLARE_STRING_ELEM(                    WE21_DB_F_MODEL_STR,          WE21_DB_F_MODEL_STR,              &db_we2111_d1.model_str[0],                                                                                 WE21_DB_F_MODEL_MAXLEN,        WE21_DB_F_MODEL_DEFAULT,           WE_DB_U_VERSION2,      DB_NO_MAXIMUM_VERSION, WE21_DB_CLMASK_FACTORY),
};


/*
 * Database definition
 */


struct s_db_database we2111_user_database_v1 =
{
  .db_database_version = WE_DB_U_VERSION1,
  .db_database_chksum_seed = WE21_DB_D1_CHECKSUM_SEED,
  .db_elements = we2111_user_elements_v1,
  .db_num_elements = DB_NUM_ELEMENTS(we2111_user_elements_v1),
  .db_name = WE21_DB_D1_NAME,
  .db_checksum_buffer = NULL
};


struct s_db_database we2111_user_database_v2 =
{
  .db_database_version = WE_DB_U_VERSION2,
  .db_database_chksum_seed = WE21_DB_D1_CHECKSUM_SEED,
  .db_elements = we2111_user_elements_v2,
  .db_num_elements = DB_NUM_ELEMENTS(we2111_user_elements_v2),
  .db_name = WE21_DB_D1_NAME,
  .db_checksum_buffer = NULL
};

