#include <stdio.h>
#include <cutest/CuTest.h>
#include "test_db_create.h"
#include "test_db_base64.h"
#include "test_db_version.h"
#include "test_db_changelog.h"
#include "test_db_strings.h"
#include "test_db_strescape.h"
#include "test_db_uboot.h"
#include "test_db_array_change_size.h"


int main(int argc, char *argv[])
{
  int result;

  CuString *output = CuStringNew();
  CuSuite *suite = CuSuiteNew();

  /* Create database objects */
  CuSuiteConsume(suite, CuGetSuite_DB_Create());

  /* Add our test suites here */
  CuSuiteConsume(suite, CuGetSuite_DB_Base64());
  CuSuiteConsume(suite, CuGetSuite_DB_StringEscape());
  CuSuiteConsume(suite, CuGetSuite_DB_Version());
  CuSuiteConsume(suite, CuGetSuite_DB_Changelog());
  CuSuiteConsume(suite, CuGetSuite_DB_Strings());
  CuSuiteConsume(suite, CuGetSuite_DB_uboot());
  CuSuiteConsume(suite, CuGetSuite_DB_ArrayChangeSize());

  /* Clean up */
  CuSuiteConsume(suite, CuGetSuite_DB_Destroy());

  /* Run all tests */
  CuSuiteRun(suite);
  CuSuiteSummary(suite, output);
  CuSuiteDetails(suite, output);

  /* Print results */
  printf("%s\n", output->buffer);
  result = (suite->failCount > 0) ? 1 : 0;

  /* Clean up */
  CuSuiteDelete(suite);
  suite = NULL;
  CuStringDelete(output);
  output = NULL;

  /* Return result */
  return result;
}
