/*
 * dsd_byteorder.h
 *
 *  Created on: Mar 7, 2012
 *      Author: ian
 */

#ifndef DSD_BYTEORDER_H_
#define DSD_BYTEORDER_H_


#include <rinweigh/adcdsd.h>


/** Change the DSD record header from host to network byte order */
void AdcIntDSDRecHdrToNetworkByteOrder(struct s_adc_dsd_record_header *rec_hdr);


/** Change the DSD record header from network to host byte order */
void AdcIntDSDRecHdrFromNetworkByteOrder(struct s_adc_dsd_record_header *rec_hdr);


/** Change the DSD file index from host to network byte order */
void AdcIntDSDFileIndexToNetworkByteOrder(struct s_adc_dsd_file_index *fi);


/** Change the DSD file index from network to host byte order */
void AdcIntDSDFileIndexFromNetworkByteOrder(struct s_adc_dsd_file_index *fi);


/**
 * Calculate the checksum on a file index taking into account
 * the following:
 *
 * Checksum is special: so it will work irrespective of machine endianness, we
 * first put the file index contents into network byte order, then calculate the
 * checksum, then set the network order version in the header.
 *
 * The checksum returned will be in host order, it's up to you to htons() it
 *
 * This assumes the file index is already in network byte order
 */
void AdcIntDSDCalculateFileIndexChecksum(const struct s_adc_dsd_file_index *fi_netorder, int16u *checksum);


#endif /* DSD_BYTEORDER_H_ */
