/*
 * dsd_copy.h
 *
 *  Created on: Mar 26, 2012
 *      Author: ian
 */

#ifndef DSD_COPY_H_
#define DSD_COPY_H_

#include <rinweigh/adcdsd.h>


/**
 * Copy the DSD file to copyfd (no locking).
 *
 * Writing within copyfd occurs from the write position in the file when the function is called.
 * No truncation is performed.
 *
 * @param dsd is the DSD structure
 * @param copyfd is a file descriptor open for writing.
 * @param bytes_written is set to the number of bytes written to copyfd. Can be NULL
 */
enum eAdcDsdError AdcIntDSDFileCopyFD(struct s_adc_dsd *dsd, int copyfd, int32u *bytes_written);


/**
 * Copy the DSD file to filename (no locking)
 *
 * @param dsd is the DSD structure
 * @param filename is the name of a writeable file to copy the DSD to. File will be overwritten.
 * @param bytes_written is set to the number of bytes written to copyfd. Can be NULL
 */
enum eAdcDsdError AdcIntDSDFileCopyFilename(struct s_adc_dsd *dsd, const char *filename, int32u *byteswritten);


#endif /* DSD_COPY_H_ */
