/*
 * dsd_init.h
 *
 *  Created on: Mar 26, 2012
 *      Author: ian
 */

#ifndef DSD_INIT_H_
#define DSD_INIT_H_

#include <rinweigh/adcdsd.h>


/** Close the current DSD. dsd structure remains. (no locking) */
enum eAdcDsdError AdcIntDSDClose(struct s_adc_dsd *dsd);


/**
 * Create a new DSD and ready it for use.
 * Will wipe the file if it already exists
 * DSD parameters will be retrieved from the file.
 * (no locking)
 */
enum eAdcDsdError AdcIntDSDCreateNew(struct s_adc_dsd *dsd, const char *filename, int32u recordsize, int32u maxrecords, int16u recordcrcseed, int32u serialnumber);


/**
 * Open an existing DSD read for use.
 * Will fail if file doesn't exist.
 * DSD parameters will be retrieved from the file. (no locking)
 */
enum eAdcDsdError AdcIntDSDOpenExisting(struct s_adc_dsd *dsd, const char *filename);


/** Check if the DSD is up and working (file has been opened) */
enum eAdcDsdError AdcIntDSDIsRunning(struct s_adc_dsd *dsd);


#endif /* DSD_INIT_H_ */
