/*
 * el_readpipe_bufalloc.h
 *
 *  Created on: Sep 17, 2012
 *      Author: ian
 */

#ifndef EL_READPIPE_BUFALLOC_H_
#define EL_READPIPE_BUFALLOC_H_

#include <stddef.h>
#include <stdbool.h>
#include <rinexec/el_runcmd.h>


struct s_runcmd_bufferalloc
{
  char *data;                       /*!< Buffer of data retrieved from command, allocated automatically */
  size_t data_posn;                 /*!< Current position in buffer */
  size_t data_alloc_increments;     /*!< Number of bytes allocated at a time */
  size_t data_max_len;              /*!< Current number of bytes allocated */
  bool null_terminate;              /*!< The data should be terminated with '\0' */
};


/** Create a buffer allocator for data read from a process (length set by rcba->data_posn) */
void el_init_read_cmd_pipe_bufferalloc(struct s_runcmd_pipe_config *rcpc, struct s_runcmd_bufferalloc *rcba, size_t data_alloc_increments, enum e_el_read_pipe read_pipe);


/** Create a string allocator for data read from a process (length set by null termination) */
void el_init_read_cmd_pipe_stringalloc(struct s_runcmd_pipe_config *rcpc, struct s_runcmd_bufferalloc *rcba, size_t data_alloc_increments, enum e_el_read_pipe read_pipe);


/** Free the buffers within a buffer allocator */
void el_free_read_cmd_pipe_bufferalloc(struct s_runcmd_bufferalloc *rcba);


/** Free the buffers within a string allocator */
#define el_free_read_cmd_pipe_stringalloc el_free_read_cmd_pipe_bufferalloc


#endif /* EL_READPIPE_BUFALLOC_H_ */
