/*
 * el_readpipe_buffer.h
 *
 *  Created on: Sep 14, 2012
 *      Author: ian
 */

#ifndef EL_READPIPE_BUFFER_H_
#define EL_READPIPE_BUFFER_H_

#include <stddef.h>
#include <stdbool.h>
#include <rinexec/el_runcmd.h>


struct s_runcmd_buffer
{
  char *data;                       /*!< Buffer of data retrieved from command */
  size_t data_posn;                 /*!< Current position in buffer */
  size_t data_max_len;              /*!< Maximum size of buffer */
  bool null_terminate;              /*!< The data should be terminated with '\0' */
};


/** Create a buffer reader for reading data from a process (length set by rcba->data_posn) */
void el_init_read_cmd_pipe_buffer(struct s_runcmd_pipe_config *rcpc, struct s_runcmd_buffer *rcb, char *data, size_t data_max_len, enum e_el_read_pipe read_pipe);


/** Create a string reader for reading data from a process (length set by null termination) */
void el_init_read_cmd_pipe_string(struct s_runcmd_pipe_config *rcpc, struct s_runcmd_buffer *rcb, char *data, size_t data_max_len, enum e_el_read_pipe read_pipe);


#endif /* EL_READPIPE_BUFFER_H_ */
