/*
 * el_readpipe_file.c
 *
 *  Created on: Sep 14, 2012
 *      Author: ian
 */
#include <stdio.h>
#include <unistd.h>
#include <rinexec/el_runcmd.h>
#include <rinexec/el_pipe.h>

#include <rinexec/el_readpipe_file.h>


/** Write data that was read from pipe from execv'd process to outf */
static enum e_el_result el_read_cmd_pipe_file(void *user_data, const char *data, size_t bytes_read)
{
  struct s_runcmd_file *rcf = user_data;
  size_t bytes_written;

  /* Write data to outf */
  bytes_written = fwrite(data, sizeof(char), bytes_read, rcf->file);

  return (bytes_written == bytes_read) ? elr_success : elr_iofail;
}


/** Setup the pipe configuration to read from executed command stdout/stderr and write into file outf */
void el_init_read_cmd_pipe_file(struct s_runcmd_pipe_config *rcpc, struct s_runcmd_file *rcf, FILE *outf, enum e_el_read_pipe read_pipe)
{
  rcf->file = outf;

  el_init_read_cmd_pipe_callback(rcpc, read_pipe, el_read_cmd_pipe_file, rcf);
}
