/*
 * el_writepipe_buffer.c
 *
 *  Created on: Sep 14, 2012
 *      Author: ian
 */
#include <string.h>
#include <stddef.h>
#include <unistd.h>
#include <rinexec/el_readpipe_buffer.h>
#include <rinexec/el_runcmd.h>
#include <rinexec/el_pipe.h>

#include <rinexec/el_writepipe_buffer.h>


static enum e_el_result el_write_cmd_pipe_buffer(void *user_data, char *data, size_t max_data_len, size_t *data_len)
{
  struct s_runcmd_buffer *rcb = user_data;
  size_t bytes_to_write;
  size_t bytes_left;

  /* Work out how many bytes to write */
  bytes_left = rcb->data_max_len - rcb->data_posn;
  bytes_to_write = (max_data_len < bytes_left) ? max_data_len : bytes_left;

  /* Copy data over */
  memcpy(data, &rcb->data[rcb->data_posn], bytes_to_write);
  rcb->data_posn += bytes_to_write;

  *data_len = bytes_to_write;
  return elr_success;
}


void el_init_write_cmd_pipe_buffer(struct s_runcmd_pipe_config *rcpc, struct s_runcmd_buffer *rcb, const char *data, size_t data_length)
{
  rcb->data = (char *) data;
  rcb->data_posn = 0;
  rcb->data_max_len = data_length;

  el_init_write_cmd_pipe_callback(rcpc, el_write_cmd_pipe_buffer, rcb);
}
