/*
 * el_writepipe_file.c
 *
 *  Created on: Sep 14, 2012
 *      Author: ian
 */
#include <stdio.h>
#include <stddef.h>
#include <unistd.h>
#include <rinexec/el_readpipe_file.h>
#include <rinexec/el_runcmd.h>
#include <rinexec/el_pipe.h>

#include <rinexec/el_writepipe_file.h>


static enum e_el_result el_write_cmd_pipe_file(void *user_data, char *data, size_t max_data_len, size_t *data_len)
{
  struct s_runcmd_file *rcf = user_data;
  ssize_t bytes_read;
  enum e_el_result result;

  bytes_read = fread(data, sizeof(char), max_data_len, rcf->file);
  if (ferror(rcf->file))
  {
    result = elr_iofail;
    *data_len = 0;
  }
  else
  {
    result = elr_success;
    *data_len = bytes_read;
  }
  return result;
}


void el_init_write_cmd_pipe_file(struct s_runcmd_pipe_config *rcpc, struct s_runcmd_file *rcf, FILE *infile)
{
  rcf->file = infile;

  el_init_write_cmd_pipe_callback(rcpc, el_write_cmd_pipe_file, rcf);
}
