/*
 * execlibtest_echo.c
 *
 * A special echo that lets us write to both stdout and stderr
 *
 *  Created on: Aug 4, 2014
 *      Author: ian
 */
#include <stdio.h>
#include <string.h>


/** Command line is pairs of "stdxxx", "message" -> message gets written to stdxxx */
int main(int argc, char *argv[])
{
  int arg;
  FILE *fout;

  if ((argc % 2) == 0)
  {
    fprintf(stderr, "Need an even number of arguments (librinexectest_echo stdout/stderr message1 stdout/stderr message2 ...\n");
    return 1;
  }

  for (arg = 1; arg < argc; )
  {
    if (strcasecmp("stderr", argv[arg]) == 0)
    {
      fout = stderr;
    }
    else if (strcasecmp("stdout", argv[arg]) == 0)
    {
      fout = stdout;
    }
    else
    {
      fprintf(stderr, "Invalid command line \"%s\"\n", argv[arg]);
      return 1;
    }
    arg++;

    fprintf(fout, "%s\n", argv[arg]);
    arg++;
  }
  return 0;
}
