/*
 * execlibtest_fdchild.c
 *
 *  Created on: Aug 4, 2014
 *      Author: ian
 */
#include <stdbool.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>


/** Check that all file descriptors are closed, except stdin, stdout, stderr */
static bool check_closed_fds(void)
{
  int num_handles;
  int fd;
  int fd_flags;
  bool at_least_one_open;

  num_handles = getdtablesize();
  for (fd = 0, at_least_one_open = false; fd < num_handles; fd++)
  {
    if (STDIN_FILENO != fd && STDOUT_FILENO != fd && STDERR_FILENO != fd)
    {
      fd_flags = fcntl(fd, F_GETFD);
      if (fd_flags >= 0)
      {
        at_least_one_open = true;
      }
    }
  }
  return !at_least_one_open;
}


/** Returns 0 if all file descriptors, except stdio, stdout, stderr are closed, 1 otherwise */
int main(int argc, char *argv[])
{
  return (check_closed_fds()) ? 0 : 1;
}
