/*
 * rlc_assemble.h
 *
 *  Created on: 1 Jan. 2019
 *      Author: ian
 */

#ifndef RLC_ASSEMBLE_H_
#define RLC_ASSEMBLE_H_

#include <stddef.h>
#include <rincmd/rc_cli_error.h>
#include <rinlegacycmd/rlc_parameter.h>


/**
 * Convert a rinstrum legacy command or query request into a string suitable for sending to the indicator
 *
 * @param buffer is the buffer to output the message to
 * @param buffer_len is the length of buffer
 * @param rlc_cmd is the rinstrum legacy command (ie IDN)
 * @param request_not_response true if the message is a request, false if the message is a response
 * @return e_rc_cli_result result code
 */
enum e_rc_cli_result rlc_command_request_to_string(char *buffer, size_t buffer_len,
                                                   const struct s_rlc_command *rlc_cmd);


/**
 * Convert a rinstrum legacy response into a string suitable for the indicator to reply with
 *
 * @param buffer is the buffer to output the message to
 * @param buffer_len is the length of buffer
 * @param rlc_cmd is the rinstrum legacy command (ie IDN)
 * @param request_not_response true if the message is a request, false if the message is a response
 * @return e_rc_cli_result result code
 */
enum e_rc_cli_result rlc_command_response_to_string(char *buffer, size_t buffer_len,
                                                    const struct s_rlc_command *rlc_cmd);


#endif /* RLC_ASSEMBLE_H_ */
