/*
 * rlc_parse.h
 *
 *  Created on: 4 Jan. 2019
 *      Author: ian
 */

#ifndef RLC_PARSE_H_
#define RLC_PARSE_H_

#include <stddef.h>
#include <stdbool.h>
#include <rincmd/rc_cli_error.h>
#include <rinlegacycmd/rlc_parameter.h>


/**
 * Parse rinstrum legacy comms message string from buf into msg
 *
 * @param buf is the incoming message buffer
 * @param buflen is the length of the incoming message buffer
 * @param request_not_response true if this is a request we are parsing, false if this a response
 * @param rlc_cmd is the command/parameter structure to parse the data into
 *
 * @return result of the parsing
 */
enum e_rc_cli_result rlc_parser_buflen(const char *buf, size_t buflen,
                                       bool request_not_response,
                                       struct s_rlc_command *rlc_cmd);


#endif /* RLC_PARSE_H_ */
