/*
 * rlc_server_register.h
 *
 *  Created on: 14 Jan. 2019
 *      Author: ian
 */

#ifndef RLC_SERVER_REGISTER_H_
#define RLC_SERVER_REGISTER_H_

#include <stdbool.h>
#include <rincmd/rc_cli_error.h>
#include <rinlegacycmd/rlc_server_handle.h>
#include <rinlegacycmd/rlc_parse.h>


/** Convert a command into an integer */
enum e_rc_cli_result rlc_command_to_int(const char command[RLC_COMMAND_LENGTH], unsigned *command_int);


/** Register a command handler using a match function */
enum e_rc_cli_result rlc_server_register_command_matchfn(struct s_rlc_server *server,
                                                         t_rlc_server_cmd_match_fn cmd_match_fn, t_rlc_server_cmd_handler_fn cmd_handler_fn, void *userdata,
                                                         bool run_unselected);


/** Register a command handler using a command */
enum e_rc_cli_result rlc_server_register_command(struct s_rlc_server *server,
                                                 const char command[RLC_COMMAND_LENGTH], t_rlc_server_cmd_handler_fn cmd_handler_fn, void *userdata,
                                                 bool run_unselected);


#endif /* RLC_SERVER_REGISTER_H_ */
