/*
 * rlc_server_reply.c
 *
 *  Created on: 14 Jan. 2019
 *      Author: ian
 */
#include <stdbool.h>
#include <rinlegacycmd/rlc_parameter.h>

#include <rinlegacycmd/rlc_server_reply.h>


/**
 * Setup a server response to a command
 *
 * @param response is the response to be sent
 * @param reply true if a reply should be sent
 * @param code is the response code to be sent. RLC_REPLY_SUCCESS, RLC_REPLY_ERROR, or other integer
 */
enum e_rc_cli_result rlc_server_command_reply(struct s_rlc_command *response, bool reply, unsigned code)
{
  enum e_rc_cli_result result;

  if (reply)
  {
    /* If we are sending a reply, there is one parameter that may be ? or a number */
    response->num_parameters = 1;
    if (RLC_REPLY_ERROR == code)
    {
      result = rlc_command_parameter_error_set(response, 0);
    }
    else
    {
      result = rlc_command_parameter_integer_set(response, 0, code);
    }
  }
  else
  {
    /* No reply */
    response->num_parameters = 0;
    result = rcr_success;
  }
  return result;
}
