/*
 * rlc_server_reply.h
 *
 *  Created on: 14 Jan. 2019
 *      Author: ian
 */

#ifndef RLC_SERVER_REPLY_H_
#define RLC_SERVER_REPLY_H_

#include <limits.h>
#include <stdbool.h>
#include <rincmd/rc_cli_error.h>
#include <rinlegacycmd/rlc_parameter.h>


/** Command executed successfully */
#define RLC_REPLY_SUCCESS 0


/** Command failed to execute successfully */
#define RLC_REPLY_ERROR UINT_MAX


/**
 * Setup a server response to a command
 *
 * @param response is the response to be sent
 * @param reply true if a reply should be sent
 * @param code is the response code to be sent. RLC_REPLY_SUCCESS, RLC_REPLY_ERROR, or other integer
 */
enum e_rc_cli_result rlc_server_command_reply(struct s_rlc_command *response, bool reply, unsigned code);


#endif /* RLC_SERVER_REPLY_H_ */
