#include <stdio.h>
#include <cutest/CuTest.h>
#include "test_rlc_assemble.h"
#include "test_rlc_assemble_va.h"
#include "test_rlc_parameter.h"
#include "test_rlc_parameter_escape.h"
#include "test_rlc_parse.h"
#include "test_rlc_server_handle.h"


int main(void)
{
  int result;

  CuString *output = CuStringNew();
  CuSuite *suite = CuSuiteNew();

  /* Add tests */
  CuSuiteConsume(suite, CuGetSuite_rlc_assemble());
  CuSuiteConsume(suite, CuGetSuite_rlc_assemble_va());
  CuSuiteConsume(suite, CuGetSuite_rlc_parameter());
  CuSuiteConsume(suite, CuGetSuite_rlc_parameter_escape());
  CuSuiteConsume(suite, CuGetSuite_rlc_parse());
  CuSuiteConsume(suite, CuGetSuite_rlc_server_handle());

  /* Run all tests */
  CuSuiteRun(suite);
  CuSuiteSummary(suite, output);
  CuSuiteDetails(suite, output);

  /* Print results */
  printf("%s\n", output->buffer);
  result = (suite->failCount > 0) ? 1 : 0;

  /* Clean up */
  CuSuiteDelete(suite);
  suite = NULL;
  CuStringDelete(output);
  output = NULL;

  /* Return result */
  return result;
}
