/*
 * rl_generate_c500.h
 *
 *  Created on: Nov 4, 2016
 *      Author: ian
 */

#ifndef RL_GENERATE_C500_H_
#define RL_GENERATE_C500_H_


#include <stdint.h>
#include <stdlib.h>
#include <rinlicence/rl_licence.h>


/**
 * Munge up serial number and package name into a buffer.
 * This is the security by obscurity part of our licensing and should be kept secret.
 * Caller must free buffer
 *
 * Function not static so we can test it in the unit tests
 */
enum e_rl_result rl_munge_serial_and_package(const char *package_name, uint32_t serial_number, uint8_t **munge_buffer, size_t *munge_buffer_length);


/** Generate a C500 licence code for given package name and serial number */
enum e_rl_result rl_generate_licence_code_c500(struct s_rl_licence *rl_licence, const char *package_name, uint32_t *licence_code);


#endif /* RL_GENERATE_C500_H_ */
