/*
 * rl_pkgtype_c500.c
 *
 *  Created on: 4 Sep. 2018
 *      Author: ian
 */
#include <rinlicence/rl_licence.h>
#include "rl_opkg.h"

#include "rl_pkgtype_c500.h"


/** Get the package type for package_name on a C500 */
enum e_rl_result rl_get_package_type_c500(struct s_rl_licence *rl_licence, const char *package_name, enum e_rl_package_type *package_type)
{
  enum e_rl_result result;

  if (NULL == rl_licence || NULL == package_name || NULL == package_type)
    return rlr_paramfail;

  /* Primary package? */
  result = rl_opkg_package_match_regex(rl_licence, rl_licence->primary_package_regex, package_name);
  if (rlr_success == result)
  {
    *package_type = rlpt_primary;
    return rlr_success;
  }

  /* Secondary package? */
  result = rl_opkg_package_match_regex(rl_licence, rl_licence->addon_package_regex, package_name);
  if (rlr_success == result)
  {
    *package_type = rlpt_addon;
    return rlr_success;
  }

  /* Must be another type of package */
  *package_type = rlpt_other;
  return rlr_success;
}
