/*
 * rl_rx00_list.h
 *
 *  Created on: Nov 11, 2016
 *      Author: ian
 */

#ifndef RL_RX00_LIST_H_
#define RL_RX00_LIST_H_

#include <stdint.h>
#include <utarray.h>
#include <rinlicence/rl_licence.h>


/** Struct for linking passes and package names */
struct s_rx00_licence_passes
{
  uint32_t passes;
  char *package;
};


/** Create a list of licences and passes */
enum e_rl_result rl_rx00_licence_passes_list_init(UT_array **list);


/** Lookup the pass for a given package name */
enum e_rl_result rl_rx00_lookup_pass(UT_array *list, const char *package_name, uint32_t *pass);


/** Calculate the licence code divisor */
uint32_t rl_rx00_licence_code_divisor(struct s_rl_licence *rl_licence);


#endif /* RL_RX00_LIST_H_ */
