#include <stdio.h>
#include <cutest/CuTest.h>
#include "rl_test_generate_c500.h"
#include "rl_test_generate_r400.h"
#include "rl_test_generate_r300.h"
#include "rl_test_string.h"
#include "rl_test_license.h"
#include "rl_test_remove.h"
#include "rl_test_init.h"
#include "rl_test_regex.h"
#include "rl_test_pkgtype.h"


int main(int argc, char *argv[])
{
  int result;

  CuString *output = CuStringNew();
  CuSuite *suite = CuSuiteNew();

  /* Add tests */
  CuSuiteConsume(suite, CuGetSuite_rinlicence_init());
  CuSuiteConsume(suite, CuGetSuite_rinlicence_generate_c500());
  CuSuiteConsume(suite, CuGetSuite_rinlicence_generate_r400());
  CuSuiteConsume(suite, CuGetSuite_rinlicence_generate_r300());
  CuSuiteConsume(suite, CuGetSuite_rinlicence_string());
  CuSuiteConsume(suite, CuGetSuite_rinlicence_licensing());
  CuSuiteConsume(suite, CuGetSuite_rinlicence_remove());
  CuSuiteConsume(suite, CuGetSuite_rinlicence_regex());
  CuSuiteConsume(suite, CuGetSuite_rinlicence_package_type());

  /* Run all tests */
  CuSuiteRun(suite);
  CuSuiteSummary(suite, output);
  CuSuiteDetails(suite, output);

  /* Print results */
  printf("%s\n", output->buffer);
  result = (suite->failCount > 0) ? 1 : 0;

  /* Clean up */
  CuSuiteDelete(suite);
  suite = NULL;
  CuStringDelete(output);
  output = NULL;

  /* Return result */
  return result;
}
