/*
 * rp_serial.h
 *
 *  Created on: Aug 16, 2017
 *      Author: ian
 */

#ifndef RP_SERIAL_H_
#define RP_SERIAL_H_

#include <stdint.h>
#include <stdbool.h>
#include <rinprog/rinprog.h>


/** Initialise the serial port structure with the port name. Doesn't open port. */
enum e_rp_result rp_serial_init(struct s_rp_serial_port **serial_port, const char *port_name);


/** Close port if open and clean up allocated memory in struct */
enum e_rp_result rp_serial_shutdown(struct s_rp_serial_port *serial_port);


/** Open the serial port */
enum e_rp_result rp_serial_open(struct s_rp_serial_port *serial_port);


/** Close the serial port */
enum e_rp_result rp_serial_close(struct s_rp_serial_port *serial_port);


/** Set the configuration for the serial port */
enum e_rp_result rp_serial_set_config(struct s_rp_serial_port *serial_port, uint32_t baud_rate,
                                      uint8_t data_bits, char parity, uint8_t stop_bits, bool use_cts);


#endif /* RP_SERIAL_H_ */
