/*
 * rp_util.c
 *
 *  Created on: Aug 18, 2017
 *      Author: ian
 */
#include <stdio.h>
#include <rinprog/rinprog.h>

#include "rp_util.h"


/** Get the length of a file. Changes file pointer, but resets it before returning */
enum e_rp_result rp_get_file_length(FILE *f, uint32_t *length)
{
  long curpos;
  long size;

  if (NULL == f || NULL == length)
    return rpr_paramfail;

  /* Save current position */
  curpos = ftell(f);
  if (curpos < 0)
    return rpr_iofail;

  /* Find size of stream */
  if (fseek(f, 0, SEEK_END) != 0)
    return rpr_iofail;
  size = ftell(f);
  if (size < 0)
    return rpr_iofail;

  /* Seek back to current position */
  if (fseek(f, curpos, SEEK_SET) != 0)
    return rpr_iofail;

  *length = (uint32_t) size;
  return rpr_success;
}
