#include <stdio.h>
#include <cutest/CuTest.h>
#include "rp_test_devini.h"
#include "rp_test_srecord.h"
#include "rp_test_checksum.h"
#include "rp_test_teacrypt.h"


int main(int argc, char *argv[])
{
  int result;

  CuString *output = CuStringNew();
  CuSuite *suite = CuSuiteNew();

  /* Add tests */
  CuSuiteConsume(suite, CuGetSuite_rinprog_devini());
  CuSuiteConsume(suite, CuGetSuite_rinprog_srecord());
  CuSuiteConsume(suite, CuGetSuite_rinprog_checksum());
  CuSuiteConsume(suite, CuGetSuite_rinprog_teacrypt());

  /* Run all tests */
  CuSuiteRun(suite);
  CuSuiteSummary(suite, output);
  CuSuiteDetails(suite, output);

  /* Print results */
  printf("%s\n", output->buffer);
  result = (suite->failCount > 0) ? 1 : 0;

  /* Clean up */
  CuSuiteDelete(suite);
  suite = NULL;
  CuStringDelete(output);
  output = NULL;

  /* Return result */
  return result;
}
