#ifndef ADC_AVERAGE_DOT_H
#define ADC_AVERAGE_DOT_H 1
                 
#include <rinhw/stdrinstrum.h>
#include <rinweigh/adcdatatypes.h>
#include <rinweigh/adcdebug.h>


#if ADC_DEBUG(ADC_AVERAGE_DUMP_DEBUG_LVL, ADC_DEBUG_FULL)
/** Dump the contents of the ADC averaging structure */
void AdcIntDebugDumpAverage(const AdcAverageData *ad);
#endif


/**
 * Initialise averaging structure with the number of readings to average
 *
 * @param ad is the averaging structure
 * @param numRdg is the number of readings to average, if greater than @ref ADC_AVERAGE_MAX_RDGS, then pre-averaging is employed to make up the extra averaging
 */
void AdcIntInitAverage(AdcAverageData *ad, int32u numRdg);


/** Run the averaging process, taking new data rdg */
int32s AdcIntAverageReading(AdcAverageData *ad, int32s rdg);


/** Return true if average buffer is full (to configured limit) */
bool AdcIntAverageIsFull(AdcAverageData *ad);


/** Clear averaging buffer without changing averaging configuration */
void AdcIntAverageClearData(AdcAverageData *ad);


#endif /* #ifndef ADC_AVERAGE_DOT_H */
