#include <stdlib.h>
#include <string.h>
#include <rinhw/stdrinstrum.h>
#include <rinhw/rstdio.h>
#include <rinweigh/adcoperations.h>
#include <rinweigh/adcreadings.h>
#include <rinweigh/adcmotion.h>
#include <rinweigh/adcinterface.h>

#include <rinweigh/adcdatatypes.h>


/* Constants for use with AdcUserDatabase.resolution */
const int8u AdcResolutions[ADC_NUM_RESOLUTION] = ADC_RESOLUTIONS;                                /*!< The possible ADC library resolutions (count-bys). Array is indexed by @ref AdcUserDatabase::resolution. */
const int8u AdcResolutionLengths[ADC_NUM_RESOLUTION] = ADC_RESOLUTION_LENGTHS;                   /*!< The number of digits in each of the resolutions (ie res=1 has reslen=1, res=100 has reslen=3). Array is indexed by @ref AdcUserDatabase::resolution. */


/* Constants for use with AdcUserDatabase.motion */
const int16u AdcMotionDelta[ADC_NUM_MOTION_DETECT] = ADC_MOTION_DELTAS;                          /*!< The number of divisions of disturbance required to indicate motion. Array indexed by @ref AdcUserDatabase::motion. */
const int8u AdcMotionWindowInv[ADC_NUM_MOTION_DETECT] = ADC_MOTION_WINDOW_DIVISORS;              /*!< SampleFreq / AdcMotionWindowInv = the time in seconds that the disturbance must occur in to indicate motion. Array indexed by @ref AdcUserDatabase::motion. */


/* Constants for use with AdcUserDatabase.zeroTracking */
const int16u AdcZeroTrackingDelta[ADC_NUM_ZERO_TRACKING] = ADC_ZERO_TRACKING_DELTAS;             /*!< The maximum amount (in counts=divisions * 16) of zero cancellation applied by the zero tracking in any zero tracking window period. Array indexed by @ref AdcUserDatabase::zeroTracking. */
const int8u AdcZeroTrackingWindowInv[ADC_NUM_ZERO_TRACKING]= ADC_ZERO_TRACKING_WINDOW_DIVISORS;  /*!< SampleFreq / AdcZeroTrackingWindowInv = the time in seconds over which a maximum of AdcZeroTrackingDelta zero cancellation can be applied. Array indexed by @ref AdcUserDatabase::zeroTracking. */


/* Constants for use with AdcUserDatabase.rangeOfZero */
const int8s AdcZeroRangePos[ADC_NUM_ZERO_RANGE] = ADC_ZERO_RANGES_PLUS;                          /*!< ADC range of zero setting for positive readings. Array indexed by @ref AdcUserDatabase::rangeOfZero */
const int8s AdcZeroRangeNeg[ADC_NUM_ZERO_RANGE] = ADC_ZERO_RANGES_NEGATIVE;                      /*!< ADC range of zero setting for negative readings. Array indexed by @ref AdcUserDatabase::rangeOfZero */


/* Constants for use with AdcUserDatabase.syncFreqIdx */
const int16u AdcSyncFrequencies[ADC_NUM_SYNC_FREQ] = ADC_SYNC_FREQUENCIES;                       /*!< ADC sync frequencies. Array indexed by @ref AdcUserDatabase::syncFreqIdx */
