/**
 * @file adcdatabase.h
 *
 * @brief Global variables and functions associated with the ADC library databases
 */
#ifndef ADC_DATABASE_DOT_H
#define ADC_DATABASE_DOT_H 1

#include <stddef.h>
#include <rinhw/stdrinstrum.h>
#include <rinweigh/adcdatatypes.h>


/**
 * Calculate a 16bit CCITT CRC checksum for a block of data
 *
 * @param byt is an array of bytes to calculate the checksum for
 * @param size is the number of bytes to calculate the checksum over
 * @param crc is the checksum seed
 * @return the checksum of the given data
 */
int16u AdcCalcCRC16(const int8u *byt, size_t size, int16u crc);


#endif /* #ifndef ADC_DATABASE_DOT_H */
