/*
 * adcdbdefault.h
 *
 *  Created on: Apr 17, 2012
 *      Author: ian
 */

#ifndef ADCDBDEFAULT_H_
#define ADCDBDEFAULT_H_

#include "adcdatatypes.h"


/**
 * Internal defaulting of databases without locking
 *
 * @param ass is the ADC super structure.
 * @param afd is a pointer to a factory database to be defaulted. Can be NULL in which case shouldn't be defaulted.
 * @param aud is a pointer to a user database to be defaulted. Can be NULL in which case shouldn't be defaulted.
 * @param ard is a pointer to a runtime database to be defaulted. Can be NULL in which case shouldn't be defaulted.
 * @param preserve_cal_counters means the calibration counters should be preserved and incremented over the default.
 * @param cal_only means only the calibration settings should be defaulted (this applies to aud only) (settings to be defaulted are zeroRaw, spanRaw, spanCnt, linearisation).
 */
void AdcIntDefaultDatabases(AdcSuperStructure *ass,
                            AdcFactoryDatabase *afd,
                            AdcUserDatabase *aud,
                            AdcRuntimeDatabase *ard,
                            bool preserve_cal_counters,
                            bool cal_only);


#endif /* ADCDBDEFAULT_H_ */
