/*
 * adcdbsave.h
 *
 *  Created on: May 9, 2012
 *      Author: ian
 */

#ifndef ADCDBSAVE_H_
#define ADCDBSAVE_H_

#include "adcdatatypes.h"


/**
 * Internal saving of ADC databases without locking
 *
 * @param ass is the ADC super structure, provided for your reference. Don't save the databases included in this.
 * @param afd is a pointer to a factory database to be saved. Can be NULL in which case shouldn't be saved.
 * @param aud is a pointer to a user database to be saved. Can be NULL in which case shouldn't be saved.
 * @param ard is a pointer to a runtime database to be saved. Can be NULL in which case shouldn't be saved.
 * @param aud_reference is a pointer to a user database used as a reference to determine whether to increment the calibration counters. Can be NULL only if aud is NULL
 *
 * @return result of the save
 */
bool AdcIntSaveDatabases(AdcSuperStructure *ass,
                         AdcFactoryDatabase *afd,
                         AdcUserDatabase *aud,
                         AdcRuntimeDatabase *ard,
                         const AdcUserDatabase *aud_reference);


#endif /* ADCDBSAVE_H_ */
