/*
 * AdcDbUser.h
 *
 *  Created on: Apr 17, 2012
 *      Author: ian
 */

#ifndef ADCDBUSER_H_
#define ADCDBUSER_H_

#include "adcdatatypes.h"


/**
 * Set a user database to defaults
 *
 * @param aud is the user database to be defaulted
 * @param preserve_cal_counters causes the calibration counters to preserved (and incremented)
 * @param cal_only causes only the calibration settings to be defaulted (zero, span, span count, linearisation points)
 */
void AdcIntUserDatabaseDefault(AdcUserDatabase *aud, bool preserve_cal_counters, bool cal_only);


/** Check the user database checksum */
bool AdcIntUserDatabaseCheckChecksum(const AdcUserDatabase *aud);


/** Set the user database checksum */
void AdcIntUserDatabaseSetChecksum(AdcUserDatabase *aud);


/** Increment the calibration counters if trade relevant settings have changed */
void AdcIntUserDatabaseIncrementCalCountersOnChanges(AdcSuperStructure *ass, AdcUserDatabase *changed_db, const AdcUserDatabase *ref_db);


/** Compare user databases, return true if different */
bool AdcIntUserDatabaseDiff(const AdcUserDatabase *aud1, const AdcUserDatabase *aud2);


#endif /* ADCDBUSER_H_ */
