/*
 * adcdebug.c
 *
 *  Created on: Apr 24, 2013
 *      Author: ian
 */
#include <stdarg.h>
#include "adcdatatypes.h"

#include "adcdebug.h"


/** Note this is a global within the ADC library */
static AdcDebugVPrintfImplementerFn adcDebugVPrintfImplementerFn = NULL;


/** Set the debug printf function */
void AdcIntDebugSetVPrintfImplementerFn(AdcDebugVPrintfImplementerFn fn)
{
  adcDebugVPrintfImplementerFn = fn;
}


/** Debug printf function for the ADC library, calls the application implemented handler */
void AdcIntDebugPrintf(int priority, const char *format, ...)
{
  va_list args;

  if (NULL != adcDebugVPrintfImplementerFn)
  {
    va_start(args, format);
    adcDebugVPrintfImplementerFn(priority, format, args);
    va_end(args);
  }
}
