/**
 * @file adcdlong.h
 *
 * @brief Multiply divide routine
 */
#ifndef ADCDLONG_DOT_H
#define ADCDLONG_DOT_H 1

#include <rinhw/stdrinstrum.h>


/** Union of 2 long words, 4 words and 8 bytes */
typedef union
{
  int32u lw[2];
  int16u w[4];
  int8u b[8];
} dlong;


/** Union of 1 long word, 2 words and 4 bytes */
typedef union
{
  int32u l;
  int16u w[2];
  int8u b[4];
} ulor2w;


/** Union of 1 long int, 2 words and 4 bytes */
typedef union
{
  int32s l;
  int16u w[2];
  int8u b[4];
} lor2w;


#endif /* #ifndef ADCDLONG_DOT_H */
