/*
 * adcfactory.c
 *
 * These are factory function that you really don't want to run in
 * normal operation of the ADC library
 *
 *  Created on: Jun 23, 2012
 *      Author: ian
 */
#include "adcdatatypes.h"
#include "adcaverage.h"
#include "adcmutex.h"
#include "adcinterface.h"

#include "adcfactory.h"


/** Clear averaging buffer without changing averaging configuration */
void AdcFactoryMainAverageBufferClear(AdcSuperStructure *ass, bool lock)
{
  ADC_INT_IFACE_LOCK();
  AdcIntAverageClearData(&ass->adcAveraging);
  ADC_INT_IFACE_UNLOCK();
}


/** Check if main averaging buffer is full */
bool AdcFactoryMainAverageBufferIsFull(AdcSuperStructure *ass, bool lock)
{
  bool result;

  ADC_INT_IFACE_LOCK();
  result = AdcIntAverageIsFull(&ass->adcAveraging);
  ADC_INT_IFACE_UNLOCK();
  return result;
}
