#ifndef ADC_LIN_DOT_H
#define ADC_LIN_DOT_H 1
                 
#include <rinhw/stdrinstrum.h>
#include <rinweigh/adcdatatypes.h>


void AdcIntLinearisationInit(const AdcUserDatabase *aud, AdcLinearisation *linear, int32s cntFullscale);


int32s AdcIntLinearisationCorrection(const AdcLinearisation *linear, int32s rdg);


/**
 * Get linearisation point at a weight
 *
 * @param rdg is the weight to get the linearisation point for
 * @return the linearisation point at rdg
 */
int8u AdcIntLinearisationGetLinPt(const AdcLinearisation *linear, int32s rdg);


/**
 * Get the weight at a linearisation point
 *
 * @param pnt is the point to return the weight for
 * @return the weight at linearisation point pnt
 */
int32s AdcIntLinearisationGetLinWgt(const AdcLinearisation *linear, int8u pnt);


/** Clear a particular linearisation point in the database */
void AdcIntClearDbLinear(AdcSuperStructure *ass, int8u pnt);


/** Clear all linearisation points in the database */
void AdcIntClearAllDbLinear(AdcSuperStructure *ass);


#endif /* #ifndef ADC_LIN_DOT_H */
