/*
 * adcliveimpl.c
 *
 *  Created on: Mar 31, 2012
 *      Author: ian
 */
#include <stdlib.h>
#include <string.h>
#include "adcdatatypes.h"
#include "adcdatafiller.h"

#include "adcliveimpl.h"
#include "adcliveimpl_int.h"


static enum eAdcLiveWeighResult AdcIntLiveWeighALWIRun(AdcLiveWeighImplementer *alwi, int32s rdg, int32s *resultrdg)
{
  enum eAdcLiveWeighResult result = alwrNotImplemented;

  if (NULL != alwi && NULL != alwi->AdcLiveWeighRun)
  {
    result = alwi->AdcLiveWeighRun(alwi, rdg, resultrdg);
  }
  return result;
}


static enum eAdcLiveWeighResult AdcIntLiveWeighALWIInitiate(AdcLiveWeighImplementer *alwi)
{
  enum eAdcLiveWeighResult result = alwrNotImplemented;

  if (NULL != alwi && NULL != alwi->AdcLiveWeighInitiate)
  {
    result = alwi->AdcLiveWeighInitiate(alwi);
  }
  return result;
}


static enum eAdcLiveWeighResult AdcIntLiveWeighALWIDisable(AdcLiveWeighImplementer *alwi)
{
  enum eAdcLiveWeighResult result = alwrNotImplemented;

  if (NULL != alwi && NULL != alwi->AdcLiveWeighDisable)
  {
    result = alwi->AdcLiveWeighDisable(alwi);
  }
  return result;
}


static enum eAdcLiveWeighResult AdcIntLiveWeighALWIRunning(AdcLiveWeighImplementer *alwi)
{
  enum eAdcLiveWeighResult result = alwrNotImplemented;

  if (NULL != alwi && NULL != alwi->AdcLiveWeighRunning)
  {
    result = alwi->AdcLiveWeighRunning(alwi);
  }
  return result;
}


enum eAdcLiveWeighResult AdcIntLiveWeighRun(AdcSuperStructure *ass)
{
  int32s rawRdg;
  int32s rawResult;
  int32s cntSysRdg;
  int32s cntGross;
  int32s cntNet;
  AdcInfo info;
  enum eAdcLiveWeighResult result;

  rawRdg = ass->adcDataWorking.rawRdg;
  result = AdcIntLiveWeighALWIRun(ass->adcLiveWeigh, rawRdg, &rawResult);
  if (alwrComplete == result)
  {
    /* Calculate cntSysRdg, cntGross, cntNet */
    AdcIntCalculateCounts(ass, rawResult,
                          &cntSysRdg, &cntGross, &cntNet);

    /* Full out held ADC data structure */
    AdcIntFillOutAdcData(ass,
                         &ass->adcHeldData,
                         &info,
                         rawResult,
                         cntSysRdg,
                         cntGross,
                         cntNet,
                         ass->adcInternalData.cntOload,
                         ass->adcMiscellaneous.adcInfo.status.bit.range);

    /* Set held bits */
    AdcIntAdcDataSetHeld(&ass->adcHeldData, true);
    ass->adcHeldData.dataValid = true;
  }
  return result;
}


enum eAdcLiveWeighResult AdcIntLiveWeighInitiate(AdcSuperStructure *ass)
{
  return AdcIntLiveWeighALWIInitiate(ass->adcLiveWeigh);
}


enum eAdcLiveWeighResult AdcIntLiveWeighDisable(AdcSuperStructure *ass)
{
  return AdcIntLiveWeighALWIDisable(ass->adcLiveWeigh);
}


enum eAdcLiveWeighResult AdcIntLiveWeighRunning(AdcSuperStructure *ass)
{
  return AdcIntLiveWeighALWIRunning(ass->adcLiveWeigh);
}


/** Destroy a live weigh implementer */
void AdcLiveWeighDestroy(AdcLiveWeighImplementer *alwi)
{
  if (NULL != alwi)
  {
    if (NULL != alwi->AdcLiveWeighDestroy)
    {
      alwi->AdcLiveWeighDestroy(alwi);
    }
    memset(alwi, 0, sizeof(*alwi));
    free(alwi);
    alwi = NULL;
  }
}
