/*
 * adcmiscellaneous.c
 *
 *  Created on: Feb 29, 2012
 *      Author: ian
 */
#include <string.h>
#include "adcinterface.h"

#include "adcmiscellaneous.h"


/** Initialise the AdcMiscellaneous structure */
void AdcIntInitMiscellaneous(AdcMiscellaneous *misc,
                             t_adc_get_datetime_fn adc_get_datetime_fn,
                             AdcDatabaseDefaultImplementerFn adcDatabaseDefaultImplementerFn,
                             AdcDatabaseSaveImplementerFn adcDatabaseSaveImplementerFn,
                             AdcAppCallbackImplementerFn adcAppCallbackImplementerFn,
                             AdcDatabaseCalCountCheckImplementerFn adcDatabaseCalCountCheckImplementerFn)
{
  memset(misc, 0, sizeof(AdcMiscellaneous));

  misc->adc_get_datetime_fn = adc_get_datetime_fn;
  misc->adcDatabaseDefaultImplementerFn = adcDatabaseDefaultImplementerFn;
  misc->adcDatabaseSaveImplementerFn = adcDatabaseSaveImplementerFn;
  misc->adcAppCallbackImplementerFn = adcAppCallbackImplementerFn;
  misc->adcDatabaseCalCountCheckImplementerFn = adcDatabaseCalCountCheckImplementerFn;

/*
  AdcInfo adcInfo;
  int32s jitterAvMaxStep;
  int16u jitterAvLength;
  int32u adcErrors;
*/
  misc->updateBlocked = true;
  misc->overloaded = false;
/*
  int32s cntOverloadCntLevel;
*/
  misc->adcRdgFreq = AdcSyncFrequencies[ADC_DB_USER_SYNCFREQIDX_DEFAULT];
}


/** Function to get the current date and time */
bool AdcIntGetDateTime(AdcSuperStructure *ass, t_datetime *datetime)
{
  bool result = false;

  if (NULL != ass && NULL != ass->adcMiscellaneous.adc_get_datetime_fn && NULL != datetime)
  {
    result = ass->adcMiscellaneous.adc_get_datetime_fn(ass, datetime);
  }
  return result;
}


/** Callback to the application at select locations */
void AdcAppCallbackLocation(AdcSuperStructure *ass, enum eAdcCallbackFunctionLocation callbackLocation)
{
  if (NULL != ass->adcMiscellaneous.adcAppCallbackImplementerFn)
  {
    ass->adcMiscellaneous.adcAppCallbackImplementerFn(ass, callbackLocation);
  }
}
