#ifndef ADC_MOTION_DOT_H
#define ADC_MOTION_DOT_H 1
                 
#include <rinhw/stdrinstrum.h>
#include <rinweigh/adcdatatypes.h>


/** Disable motion detection, Motion() will always return false */
void AdcIntMotionDetectionDisable(AdcMotionDetection *motion);


/** Initialise motion detection
 *
 * Must be called with correct values of rawDelta (in counts) and
 * window length in samples and onTime in samples.
 * Note: OnTime should be greater than averaging length.
 */
void AdcIntMotionDetectionInit(AdcMotionDetection *motion, int16u rawDelta, int8u window, int8u onTime);


/** Update motion status */
void AdcIntMotionDetectionUpdate(AdcMotionDetection *motion, int32s delta);


/** Return true if motion detected */
bool AdcIntMotionDetectionGetMotion(const AdcMotionDetection *motion);


#endif /* #ifndef ADC_MOTION_DOT_H */
