/*
 * adcmuteximplementer.c
 *
 *  Created on: Mar 19, 2012
 *      Author: ian
 */
#include <stdio.h>

#include "adcmuteximpl.h"


/** Lock the ADC mutex implementer */
bool AdcMutexImplementerLock(AdcMutexImplementer *ami)
{
  bool result;

  if (NULL == ami ||
      NULL == ami->mutex_lock_fn)
  {
    /* No mutex implemented */
    result = true;
  }
  else
  {
    /* Use implementer to lock the mutex */
    result = ami->mutex_lock_fn(ami);
  }
  return result;
}


/** Unlock the ADC mutex implementer */
bool AdcMutexImplementerUnlock(AdcMutexImplementer *ami)
{
  bool result;

  if (NULL == ami ||
      NULL == ami->mutex_unlock_fn)
  {
    /* No mutex implemented */
    result = true;
  }
  else
  {
    /* Use implementer to unlock the mutex */
    result = ami->mutex_unlock_fn(ami);
  }
  return result;
}
