/*
 * adcmuteximpl.h
 *
 *  Created on: Mar 19, 2012
 *      Author: ian
 */
#ifndef ADCMUTEXIMPL_H_
#define ADCMUTEXIMPL_H_

#include <rinhw/stdrinstrum.h>


/* Forward declaration */
struct sAdcMutexImplementer;


/** Structure used to implement a mutex for the ADC library */
typedef struct sAdcMutexImplementer AdcMutexImplementer;


/** Typedef of the mutex locking function */
typedef bool (*AdcMutexLockFn)(AdcMutexImplementer *ami);


/** Typedef of the mutex unlocking function */
typedef bool (*AdcMutexUnlockFn)(AdcMutexImplementer *ami);


/** Mutex implementer */
struct sAdcMutexImplementer
{
  void *implementer_data;
  AdcMutexLockFn mutex_lock_fn;
  AdcMutexUnlockFn mutex_unlock_fn;
};


/** Lock the ADC mutex implementer */
bool AdcMutexImplementerLock(AdcMutexImplementer *ami);


/** Unlock the ADC mutex implementer */
bool AdcMutexImplementerUnlock(AdcMutexImplementer *ami);


#endif /* ADCMUTEXIMPL_H_ */
