/*
 * adcmuteximpl_pthreads_timed.h
 *
 *  Created on: 31 Jul. 2018
 *      Author: ian
 */

#ifndef ADCMUTEXIMPL_PTHREADS_TIMED_H_
#define ADCMUTEXIMPL_PTHREADS_TIMED_H_

#include "adcmuteximpl.h"


/**
 * Create a timed mutex implementer using pthreads
 *
 * This mutex is for debugging purposes. It calculates the
 * time spent locked vs unlocked and prints the result
 * every 60 seconds via ADC_DEBUG_PRINTF().
 *
 * It shouldn't be used in production code, as it will
 * have a performance impact with the additional calculations
 * and debug prints.
 */
AdcMutexImplementer *AdcMutexImplementerPthreadsTimedCreate(void);


/** Destroy a timed mutex implementer using pthreads */
bool AdcMutexImplementerPthreadsTimedDestroy(AdcMutexImplementer *ami);


#endif /* ADCMUTEXIMPL_PTHREADS_TIMED_H_ */
