/*
 * adcversion.h
 *
 * ADC library version information
 *
 *  Created on: Jun 23, 2012
 *      Author: ian
 */

#ifndef ADCVERSION_H_
#define ADCVERSION_H_

#include <rinhw/stdrinstrum.h>


/*
 * Version as defines
 */


/* Do not change the library version defines ADC_LIB_VERSION_*, because the make process parses this file, so it can know the version. */


/** Major ADC library version 0+. Change it here */
#define ADC_LIB_VERSION_MAJOR 1


/** Minor ADC library version 0-9. Change it here */
#define ADC_LIB_VERSION_MINOR 0


/** Minor ADC library version 0-9. Change it here */
#define ADC_LIB_VERSION_REVISION 1


/** ADC library version as an integer */
#define ADC_LIB_VERSION_INT (ADC_LIB_VERSION_MAJOR * 100 + ADC_LIB_VERSION_MINOR * 10 + ADC_LIB_VERSION_REVISION)


/** Convert to string */
#define ADC_AS_STRING(s) ADC_STRINGIFY(s)
#define ADC_STRINGIFY(s) #s


/** ADC library version as a string nnn */
#define ADC_LIB_VERSION_STR ADC_AS_STRING(ADC_LIB_VERSION_MAJOR) ADC_AS_STRING(ADC_LIB_VERSION_MINOR) ADC_AS_STRING(ADC_LIB_VERSION_REVISION)


/** ADC library version as a formatted string (Vn.nn) */
#define ADC_LIB_VERSION_FORMATTED_STR "V" ADC_AS_STRING(ADC_LIB_VERSION_MAJOR) "." ADC_AS_STRING(ADC_LIB_VERSION_MINOR) ADC_AS_STRING(ADC_LIB_VERSION_REVISION)


/** The ADC library drawing number as an integer in the form pppdddvvv (400-534-123), where ppp is the product (400), ddd is the drawing (534) and vvv is the version. */
#define ADC_LIB_DRAWING_NUMBER_INT (400534 * 1000 + ADC_LIB_VERSION_INT)


/** The ADC library drawing number as a string in the form R400-534-vvv, where vvv is the version */
#define ADC_LIB_DRAWING_NUMBER_STR "R400-534-" ADC_LIB_VERSION_STR


/*
 * Version as constants
 */


/** ADC library version constant as an integer */
extern const int32u AdcLibVersionInt;


/** ADC library version constant as a string (nnn) */
extern const char AdcLibVersionStr[];


/** ADC library version constant as a formatted string (Vn.nn) */
extern const char AdcLibVersionFormattedStr[];


/** ADC library drawing number as an integer */
extern const int32u AdcLibDrawingNumberInt;


/** ADC library version string as a human readable string eg R400-534-123 */
extern const char AdcLibDrawingNumberStr[];


#endif /* ADCVERSION_H_ */
