#ifndef ADC_ZEROTRACK_DOT_H
#define ADC_ZEROTRACK_DOT_H 1
                 
#include <rinhw/stdrinstrum.h>
#include <rinweigh/adcdatatypes.h>


/**
 * Initialise zero tracking
 *
 * maxDelta is the maximum number of counts (weight * 16) to be canceled in skipSamples period. If 0, zero tracking will be disabled
 * skipSamples is the number of samples (at ADC reading frequency) to skip before applying up to maxDelta counts of zero tracking
 * opBlocked is whether zero tracking should be disabled
 */
void AdcIntZeroTrackingInit(AdcZeroTracking *zt, int32u maxDelta, int32u skipSamples, bool opBlocked);


/** Disable or enable zero tracking */
void AdcIntZeroTrackingBlock(AdcZeroTracking *zt, bool block);


/** Run the zero tracking, based on settings in ass->adcZeroTracking */
bool AdcIntZeroTrackingDo(AdcSuperStructure *ass);


#endif /* #ifndef ADC_ZEROTRACK_DOT_H */
