/*
 * changelog.h
 *
 *  Created on: Apr 30, 2012
 *      Author: ian
 */

#ifndef APP_DB_CHANGELOG_H_
#define APP_DB_CHANGELOG_H_

#include <rinhw/stdrinstrum.h>
#include <rindb/db_database.h>


extern struct s_db_changelog *app_changelog;
extern struct s_db_changelog_reader *app_changelog_reader;


/** Create the database change log */
bool app_changelog_init(const char *changelog_file);


/** Shut down the change log */
bool app_changelog_destroy(void);


/** Determine if the changelog is full, in which case the databases can't be saved */
bool app_can_save_databases(void);


/** Update the changelog with any changes */
bool app_changelog_update(struct s_db_database *database);


#endif /* APP_DB_CHANGELOG_H_ */
