/*
 * dsdtest.c
 *
 *  Created on: Mar 7, 2012
 *      Author: ian
 */
#include <stdio.h>
#include <cutest/CuTest.h>
#include "dsdtest_init.h"
#include "dsdtest_add.h"
#include "dsdtest_circular.h"
#include "dsdtest_purge.h"
#include "dsdtest_endian.h"

#include <rinweigh/adcdsd.h>


/** The DSD we are testing */
struct s_adc_dsd *test_dsd = NULL;


int main(int argc, char *argv[])
{
  CuString *output = CuStringNew();
  CuSuite *suite = CuSuiteNew();

  /* Must come first, creates test_dsd */
  CuSuiteAddSuite(suite, CuGetSuite_DSD_Init());

  /* Add our test suites */
  CuSuiteAddSuite(suite, CuGetSuite_DSD_Add());
  CuSuiteAddSuite(suite, CuGetSuite_DSD_Purge());
  CuSuiteAddSuite(suite, CuGetSuite_DSD_CircularBuffer());
  CuSuiteAddSuite(suite, CuGetSuite_Traceable_Packing());

  /* Must come last, cleans up test_dsd */
  CuSuiteAddSuite(suite, CuGetSuite_DSD_Destroy());

  /* Run all tests */
  CuSuiteRun(suite);
  CuSuiteSummary(suite, output);
  CuSuiteDetails(suite, output);
  printf("%s\n", output->buffer);

  return (suite->failCount > 0) ? 1 : 0;
}
