/*
 * dsdtest_endian.c
 *
 *  Created on: Mar 19, 2012
 *      Author: ian
 */
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <cutest/CuTest.h>
#include <rinweigh/adcpacked.h>
#include "dsdtest.h"

#include "dsdtest_endian.h"


#define TEST_PACKED_BIT(name, val, shifts, idx) \
  memset(&as, 0, sizeof(as)); \
  memset(&asp, 0, sizeof(asp)); \
  as.bit.name = val; \
  AdcStatusPackToNetwork(&as, &asp); \
  CuAssertIntEquals(tc, val << shifts, buf[idx])


/** Test packing of bits into adc status structure */
static void test_dsd_adc_status_packing(CuTest *tc)
{
  AdcStatus as;
  AdcStatusPacked asp;
  int8u *buf = (int8u *) &asp;

  /* Byte 0 */
  TEST_PACKED_BIT(range, 0x03, 0, 0);
  TEST_PACKED_BIT(hiRes, 1, 2, 0);
  TEST_PACKED_BIT(grossOrNet, 1, 3, 0);
  TEST_PACKED_BIT(gradPos, 0x0F, 4, 0);

  /* Byte 1 */
  TEST_PACKED_BIT(oload, 1, 0, 1);
  TEST_PACKED_BIT(uload, 1, 1, 1);
  TEST_PACKED_BIT(gross, 1, 2, 1);
  TEST_PACKED_BIT(coz, 1, 3, 1);
  TEST_PACKED_BIT(motion, 1, 4, 1);
  TEST_PACKED_BIT(zeroBand, 1, 5, 1);
  TEST_PACKED_BIT(zeroRange, 1, 6, 1);
  TEST_PACKED_BIT(held, 1, 7, 1);

  /* Byte 2 */
  /* TEST_PACKED_BIT(unused1, 0x1F, 0, 2); */
  TEST_PACKED_BIT(multiRange, 1, 5, 2);
  TEST_PACKED_BIT(preTare, 1, 6, 2);
  TEST_PACKED_BIT(tare, 1, 7, 2);
}


/** Test packing & endian of traceable weights */
CuSuite *CuGetSuite_Traceable_Packing(void)
{
  CuSuite *suite = CuSuiteNew();

  SUITE_ADD_TEST(suite, test_dsd_adc_status_packing);

  return suite;
}

