/*
 * getchar.c
 *
 *  Created on: 29/03/2011
 *      Author: ian
 */
#include <stdio.h>
#include <sys/types.h>
#include <string.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <termios.h>
#include <rinhw/rio.h>
#include <rinhw/stdrinstrum.h>
#include "devices.h"

#include "getchar.h"


/** Determine if a character is available */
bool is_char_avail(void)
{
  return (rfilelength(&dev_console) > 0);
}


/** Get character with immediate return if no chars available */
bool get_stdin_char(char *ch)
{
  bool result;

  if (is_char_avail())
  {
    result = (sizeof(*ch) == rread(&dev_console, ch, sizeof(*ch), 0));
  }
  else
  {
    result = false;
  }
  return result;
}


/** Get character with indefinite timeout */
bool get_stdin_char_block(char *ch)
{
  return (sizeof(*ch) == rread(&dev_console, ch, sizeof(*ch), 0));
}


/** Get a character from stdin with a timeout */
bool get_stdin_char_timeout(char *ch, unsigned short timeout)
{
  return (sizeof(*ch) == rread(&dev_console, ch, sizeof(*ch), timeout));
}
