/*
 * menu_database.c
 *
 *  Created on: 31/03/2011
 *      Author: ian
 */
#include <stdio.h>
#include <rinhw/stdrinstrum.h>
#include <rinweigh/adcdatabase.h>
#include <rinweigh/adcinterface.h>
#include "getchar.h"
#include "adcthread.h"
#include "app_db_factory.h"
#include "app_db_runtime.h"
#include "app_db_user.h"

#include "menu_database.h"


void adc_database_menu(void)
{
  char ch;
  bool quit = false;
  AdcFactoryDatabase fdb;
  AdcUserDatabase udb;
  AdcRuntimeDatabase rdb;

  while (!quit)
  {
    printf("\nADC Library Database\n\n"
           " f - Set factory database to defaults\n"
           " u - Set user database to defaults\n"
           " r - Set user runtime database to defaults\n"
           " c - Set cal flag for factory database\n"
           " d - Set cal flag for user database\n"
           " x - Save factory database\n"
           " y - Save user database\n"
           " z - Save user runtime database\n"
           " q - Quit\n"
          );

    get_stdin_char_block(&ch);
    switch (ch)
    {
      /* Set database defaults */
      case 'f':
        AdcMutexLock(&adcSuperStructure);
        AdcDefaultDatabases(&adcSuperStructure, false, &fdb, NULL, NULL, false, false);
        AdcReInit(&adcSuperStructure, false, &fdb, NULL, NULL);
        AdcMutexUnlock(&adcSuperStructure);
        break;
      case 'u':
        AdcMutexLock(&adcSuperStructure);
        AdcDefaultDatabases(&adcSuperStructure, false, NULL, &udb, NULL, false, false);
        AdcReInit(&adcSuperStructure, false, NULL, &udb, NULL);
        AdcMutexUnlock(&adcSuperStructure);
        break;
      case 'r':
        AdcMutexLock(&adcSuperStructure);
        AdcDefaultDatabases(&adcSuperStructure, false, NULL, NULL, &rdb, false, false);
        AdcReInit(&adcSuperStructure, false, NULL, NULL, &rdb);
        AdcMutexUnlock(&adcSuperStructure);
        break;

      /* Cal flags */
      case 'c':
        adcSuperStructure.adcFactoryDatabase.calFlag = ADC_CAL_FLAG_OK;
        break;
      case 'd':
        adcSuperStructure.adcUserDatabase.calFlag = ADC_CAL_FLAG_OK;
        break;

      /* Save databases */
      case 'x':
        AdcSaveDatabases(&adcSuperStructure, true, &adcSuperStructure.adcFactoryDatabase, NULL, NULL, NULL);
        break;
      case 'y':
        AdcSaveDatabases(&adcSuperStructure, true, NULL, &adcSuperStructure.adcUserDatabase, NULL, &db_app_user.adc_user_database);
        break;
      case 'z':
        AdcSaveDatabases(&adcSuperStructure, true, NULL, NULL, &adcSuperStructure.adcRuntimeDatabase, NULL);
        break;

      /* Quit */
      case 'q':
        quit = true;
        break;
    }
  }
}
