libsetnetconfig - Library and programs for getting and setting network configuration on different targets
=======

* On the C500 & M4223, this is stored in /etc/rc.d/rc.conf.
* On PC (Ubuntu Desktop), Network Manager takes care of this. We use libnm to access it.


## Building ##

Building for the PC:

* As the network settings are (usually) managed by Network Manager, you'll need libnm for this to work:
 * ```sudo apt install libnm-dev libglib2.0-dev```
* Then to build:
 * ```./autogen.sh && ./configure --with-libnm --with-libresolv CFLAGS="-Wall -Wextra -Wno-unused-parameter -g -O0" && make clean && make```

Cross compiling for C500 or M4223:

* ```./autogen.sh && ./configure --host=m68k-uclinux --without-libnm --without-libresolv --enable-multi-call-binary CFLAGS="-Wall -Wextra -Wno-unused-parameter" && make clean && make```

NOTE: The configure option --enable-multi-call-binary is useful when statically linking to reduce the overall size of the binary.


## Testing ##

See the [README.md](test/README.md) in the test folder.

* CuTest is used for unit testing:
 * It is included as a git subtree:
  * ```git subtree add --squash -P test/cutest https://github.com/jacwah/cutest.git master```
 * To update with latest sources:
  * ```git subtree pull --squash -P test/cutest https://github.com/jacwah/cutest.git master```
