/*
 * lsnc_dhcp.h
 *
 *  Created on: 22 Jun. 2018
 *      Author: ian
 */

#ifndef LSNC_DHCP_H_
#define LSNC_DHCP_H_

#include <stdbool.h>
#include <setnetconfig.h>


/**
 * Get the network configuration DHCP setting by trying to guess the best config method
 * based on the current method (ioctl, getifaddrs, etc)
 */
enum e_snc_result snc_get_net_current_dhcp(const struct s_snc_configuration *config,
                                           const char *current_method, const char *eth_interface,
                                           bool *use_dhcp);


#endif /* LSNC_DHCP_H_ */
