/*
 * lsnc_nameservers.h
 *
 *  Created on: 1 Jun. 2018
 *      Author: ian
 */

#ifndef SRC_LSNC_NAMESERVERS_H_
#define SRC_LSNC_NAMESERVERS_H_

#include <stddef.h>
#include <netinet/in.h>
#include <setnetconfig.h>


/** Get the current IPv4 nameservers and our domain from libresolv. Function is only available if libresolv is available */
enum e_snc_result snc_ipv4_nameservers_domain_get_current_libresolv(struct s_snc_net_config *net_config);


/** Get the current IPv4 nameservers and domain by parsing the results from /etc/resolv.conf */
enum e_snc_result snc_ipv4_nameservers_domain_get_current_resolvconf(const char *resolvconf_path, struct s_snc_net_config *net_config);


/** Get the current IPv4 nameservers and domain, using libresolv if available, otherwise falling back to parsing /etc/resolv.conf */
enum e_snc_result snc_ipv4_nameservers_domain_get_current(const struct s_snc_configuration *config, struct s_snc_net_config *net_config);


#endif /* SRC_LSNC_NAMESERVERS_H_ */
