#ifndef LSNC_RCCONF_DOT_H
#define LSNC_RCCONF_DOT_H 1

#include <stdio.h>
#include <stdbool.h>
#include <setnetconfig.h>


/** Get the network configuration DHCP setting from rc.conf */
enum e_snc_result snc_get_net_config_dhcp_rcconf(const char *rcconf_path, const char *eth_interface, bool *use_dhcp);


/**
 * Find an variable (varname) in rcconf file, and extract its value into data
 *
 * @param rcconf is a config file open for reading
 * @param line is a pre-allocated line of length SNC_PARSE_LINE_LENGTH for reading each line into
 * @param varname is the variable name to look for
 * @param data is the buffer into which the variable value should be set
 * @param datalen is the maximum length of data
 * @param is_export if not NULL, is set if this variable is exported ie "export VARNAME=VARVALUE"
 */
enum e_snc_result snc_rcconf_find_variable(FILE *rcconf, char *line, const char *varname, char *data, size_t datalen, bool *is_export);


#endif /* #ifndef LSNC_RCCONF_DOT_H */
