/*
 * snc_multicall.c
 *
 *  Created on: 24 Jul. 2018
 *      Author: ian
 */
#include <stdbool.h>
#include <libgen.h>
#include <string.h>
#include <stdio.h>
#include <setnetconfig.h>


/* Function prototypes for multi-call programs */
int getnetconfig_main(int argc, char *argv[]);
int getnetcurrent_main(int argc, char *argv[]);
int setnetconfig_main(int argc, char *argv[]);
int setnetconfigx_main(int argc, char *argv[]);


/** Multi call binary main entry point */
int main(int argc, char **argv)
{
  int result;
  char *progname;
  bool handled;

  if (argc > 0)
  {
    progname = basename(argv[0]);

    handled = true;
    if (strcmp(progname, "setnetconfig") == 0)
    {
      result = setnetconfig_main(argc, argv);
    }
    else if (strcmp(progname, "setnetconfigx") == 0)
    {
      result = setnetconfigx_main(argc, argv);
    }
    else if (strcmp(progname, "getnetconfig") == 0)
    {
      result = getnetconfig_main(argc, argv);
    }
    else if (strcmp(progname, "getnetcurrent") == 0)
    {
      result = getnetcurrent_main(argc, argv);
    }
    else
    {
      handled = false;
    }
  }
  else
  {
    handled = false;
  }

  if (!handled)
  {
    printf("setnetconfig multi-call binary\n"
           "Symlink the following to point to this binary:\n"
           "  setnetconfigx - New extended version of setnetconfig\n"
           "  getnetconfig  - Get the network configuration\n"
           "  getnetcurrent - Get the current active network configuration\n");
    result = (int) sncr_invalid_commandline;
  }
  return result;
}
