/*
 * snc_validate.h
 *
 *  Created on: 25 Jul. 2018
 *      Author: ian
 */

#ifndef SRC_SNC_VALIDATE_H_
#define SRC_SNC_VALIDATE_H_

#include <stdbool.h>
#include <setnetconfig.h>


/**
 * Validate net_config and print out any
 *
 * @param program_name is the name of the program to print with error messages
 * @param net_config is the network configuration to validate
 * @param set_ifacecfg if set, then interface configuration members are validated
 * @param set_hostname if set, then hostname is validated
 * @param set_domain if set, then domain is validated
 *
 * @return result of the validation
 */
enum e_snc_result validate_and_print_errors(const char *program_name, const struct s_snc_net_config *net_config,
                                            bool set_ifacecfg, bool set_hostname, bool set_domain);


#endif /* SRC_SNC_VALIDATE_H_ */
