/*
 * lsnc_test.c
 *
 * Unit tests for libsetnetconfig
 *
 *  Created on: 28 Jun. 2018
 *      Author: ian
 */
#include <stdio.h>
#include <CuTest.h>

#include "lsnc_test_hostname.h"
#include "lsnc_test_ipv4_validate.h"
#include "lsnc_test_parse_addr.h"
#include "lsnc_test_print_net_config.h"
#include "lsnc_test_rcconf.h"
#include "lsnc_test_util.h"


int main(void)
{
  int result;

  CuString *output = CuStringNew();
  CuSuite* suite = CuSuiteNew();

  /* Add suites here */
  CuSuiteConsume(suite, CuGetSuite_lsnc_hostname());
  CuSuiteConsume(suite, CuGetSuite_lsnc_ipv4_validate());
  CuSuiteConsume(suite, CuGetSuite_lsnc_parse_addr());
  CuSuiteConsume(suite, CuGetSuite_lsnc_util());
  CuSuiteConsume(suite, CuGetSuite_lsnc_rcconf());
  CuSuiteConsume(suite, CuGetSuite_lsnc_print_net_config());

  /* Run all tests */
  CuSuiteRun(suite);
  CuSuiteSummary(suite, output);
  CuSuiteDetails(suite, output);

  /* Print results */
  printf("%s\n", output->buffer);
  result = (suite->failCount > 0) ? 1 : 0;

  /* Clean up */
  CuSuiteDelete(suite);
  suite = NULL;
  CuStringDelete(output);
  output = NULL;

  /* Return result */
  return result;
}
